2001-06-30  Zack Weinberg  <zackw@stanford.edu>

	* rtl.def (DEFINE_INSN, DEFINE_INSN_AND_SPLIT, DEFINE_PEEPHOLE):
	Change output-template slot to format 'T'.
	* rtl.h (XTMPL): New.
	* read-rtl.c (read_escape): New function.
	(read_quoted_string, read_braced_string): Use it.
	(read_rtx): Set star_if_braced from the format string.
	Use XTMPL where appropriate.
	* genoutput.c (gen_insn, gen_peephole): Use XTMPL to get the
	template string.

	* rtl.c: Include errors.h for sake of rtl_check_failed* routines.
	Document 'T' in rtx format strings.
	* Makefile.in (rtl.o, $(HOST_PREFIX_1)rtl.o): Depend on errors.h.
	* errors.c (internal_error): Add missing ": " at end of string.

	* i860.md: Change triple backslashes to double backslashes at
	ends of lines in output templates.
	* ns32k.md: Remove stray backslash-newline in output template.

2001-06-29  Nick Clifton  <nickc@cambridge.redhat.com>

	* gcc.c (process_command): Append a DIR_SEPARATOR to a path
	specified by the -B switch, if doing so would create a valid
	directory name.
	* doc/invoke.texi: Document changed behaviour of -B.

2001-06-29  DJ Delorie  <dj@redhat.com>

	* simplify-rtx.c (simplify_subreg): When simplifying a CONCAT, at
	least get rid of the CONCAT if we can't simplify further.

Fri Jun 29 12:27:24 2001  Jeffrey A Law  (law@cygnus.com)

	* simplify-rtx.c (simplify_rtx): Use swap_commutative_operands_p.

	* doc/gcc.texi (Passes): Update due to recent -fdce -> -fssa-dce
	changes.  Fix documentation for SSA DCE pass.

	* ssa-dce.c (ssa_eliminate_dead_code): Renamed from
	eliminate_date_code.
	* ssa.h (ssa_eliminate_dead_code): Corresponding changes.
	* timevar.def (TV_SSA_DCE): Renamed from TV_DEAD_CODE_ELIM.
	* toplev.c (DFI_ssa_dce): Renamed from DFI_dce.
	(dump_file_info): Similar changes.
	(flag_ssa_dce): Similarly
	(f_options): Similar changes.
	(rest_of_compilation): Corresponding changes.
	* doc/invoke.texi: Update as option is now -fssa-dce instead
	of -fdce.  Update dump file name.

	* ssa-dce.c (note_inherently_necessary_set): New function.
	(find_inherently_necessary): Use it.  Do not consider
	NOTEs, CODE_LABELs or BARRIERS are necessary.  Improve
	handling of asms and unspecs.
	(delete_insn_bb): Only delete INSNs, CALL_INSNs or JUMP_INSNs.

2001-06-29  Joseph S. Myers  <jsm28@cam.ac.uk>

	* target.h (struct gcc_target): Add comp_type_attributes and
	set_default_type_attributes.
	* target-def.h (TARGET_COMP_TYPE_ATTRIBUTES,
	TARGET_SET_DEFAULT_TYPE_ATTRIBUTES): Define.
	(TARGET_INITIALIZER): Update.
	* doc/tm.texi (COMP_TYPE_ATTRIBUTES, TARGET_COMP_TYPE_ATTRIBUTES,
	SET_DEFAULT_TYPE_ATTRIBUTES, TARGET_SET_DEFAULT_TYPE_ATTRIBUTES):
	Update documentation of old target macros to describe new target
	hooks.
	* tree.c (make_node): Use target.set_default_type_attributes.
	(default_comp_type_attributes,
	default_set_default_type_attributes): New functions.
	* tree.h (default_comp_type_attributes,
	default_set_default_type_attributes): Declare.
	* c-typeck.c (COMP_TYPE_ATTRIBUTES): Don't define.
	(comptypes): Use target.comp_type_attributes.
	* config/arc/arc-protos.h, config/arc/arc.c, config/arc/arc.h
	(arc_comp_type_attributes, arc_set_default_type_attributes,
	COMP_TYPE_ATTRIBUTES, SET_DEFAULT_TYPE_ATTRIBUTES): Remove
	functions and macros with default behaviour.
	* config/m32r/m32r-protos.h, config/m32r/m32r.c,
	config/m32r/m32r.h (m32r_comp_type_attributes,
	m32r_set_default_type_attributes, COMP_TYPE_ATTRIBUTES,
	SET_DEFAULT_TYPE_ATTRIBUTES): Likewise.
	* config/m68hc11/m68hc11-protos.h, config/m68hc11/m68hc11.c,
	config/m68hc11/m68hc11.h (m68hc11_comp_type_attributes,
	m68hc11_set_default_type_attributes, COMP_TYPE_ATTRIBUTES,
	SET_DEFAULT_TYPE_ATTRIBUTES): Likewise.
	* config/ns32k/ns32k-protos.h, config/ns32k/ns32k.c,
	config/ns32k/ns32k.h (ns32k_comp_type_attributes,
	COMP_TYPE_ATTRIBUTES): Likewise.
	* config/rs6000/rs6000-protos.h, config/rs6000/rs6000.c,
	config/rs6000/rs6000.h (rs6000_comp_type_attributes,
	rs6000_set_default_type_attributes, COMP_TYPE_ATTRIBUTES,
	SET_DEFAULT_TYPE_ATTRIBUTES): Likewise.
	* config/d30v/d30v.h (COMP_TYPE_ATTRIBUTES,
	SET_DEFAULT_TYPE_ATTRIBUTES): Remove commented out macro
	definitions.
	* config/i386/i386.h (SET_DEFAULT_TYPE_ATTRIBUTES): Likewise.
	* config/ns32k/ns32k.h (SET_DEFAULT_TYPE_ATTRIBUTES): Likewise.
	* config/arm/arm.c (arm_comp_type_attributes,
	arm_set_default_type_attributes): Make static.
	(TARGET_COMP_TYPE_ATTRIBUTES, TARGET_SET_DEFAULT_TYPE_ATTRIBUTES):
	Define.
	* config/arm/arm.h (COMP_TYPE_ATTRIBUTES,
	SET_DEFAULT_TYPE_ATTRIBUTES): Don't define.
	* config/arm/arm-protos.h (arm_comp_type_attributes,
	arm_set_default_type_attributes): Don't declare.
	* config/i386/i386.c (ix86_comp_type_attributes): Make static.
	(TARGET_COMP_TYPE_ATTRIBUTES): Define.
	* config/i386/i386.h (COMP_TYPE_ATTRIBUTES): Don't define.
	* config/i386/i386-protos.h (ix86_comp_type_attributes): Don't
	declare.

2001-06-28  Jan van Male  <jan.vanmale@fenk.wau.nl>

	* predict.c (dump_prediction): Eliminate fprintf warning.

2001-06-28  Diego Novillo  <dnovillo@redhat.com>

	* flow.c (dump_bb): Remove unused third argument to call
	to fprintf when displaying the basic block header.

2001-06-28  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>
	    Jeff Law <law@redhat.com>

	* Makefile.in (OBJS): Add df.o
	(df.o): Add dependencies.
	* basic-block.h (flow_depth_first_order_compute): Declare.
	* flow.c (flow_depth_first_order_compute): No longer declare.
	Make external.
	* df.c, df.h: New files.

2001-06-28  Zack Weinberg  <zackw@stanford.edu>

	* config/i386/i386.md: Global update to use new string syntax
	where it will improve readability.  Warning fixes:
	(*truncdfsf2_2): Abort if which_alternative is not 0 or 1.
	(*adddi_1_rex64, *adddi_2_rex64, *adddi_3_rex64,
	*adddi_4_rex64, *adddi_5_rex64): Cast 1 to unsigned int.

	* read-rtl.c: Syntactic sugar for C embedded in strings in
	machine descriptions.
	(read_string): Break inner loop into separate function.  Takes
	an int.  Dispatch to read_quoted_string or read_braced_string
	as appropriate.  Automatically insert a leading star on braced
	strings if STAR_IF_BRACED is true.
	(read_quoted_string, read_braced_string): New functions.
	* doc/rtl.texi, doc/md.texi: Document new syntax.  Update
	examples to match.

	* rtl.c: Split RTL reader (read_rtx, read_skip_spaces,
	traverse_md_constants, fatal_with_file_and_line,
	fatal_expected_char, read_name, read_string, def_hash,
	def_name_eq_p, read_constants, and related data) to its own
	file.  Weed out now-unnecessary #includes.
	* read-rtl.c: New file.
	* Makefile.in (HOST_RTL): Add read-rtl.o.
	(read-rtl.o): New rule.
	(rtl.o, $(HOST_PREFIX_1)rtl.o): Update dependencies.
	* doc/gcc.texi (Passes): Talk briefly about the support
	library used by genfoo.
	* doc/rtl.texi (Reading RTL): read_rtx is not available in the
	compiler itself.

2001-06-28  Stan Shebs  <shebs@apple.com>

	* config/darwin.h (REGISTER_TARGET_PRAGMAS): Define.
	* config/darwin-c.c: New file.
	* config/darwin-protos.h: Declare new functions.
	* config/rs6000/t-darwin (darwin-c.o): New rule.
	* config.gcc (powerpc-*-darwin*): Define c_target_objs and
	cxx_target_objs.
	* doc/extend.texi (Pragmas): New section.

Thu Jun 28 20:13:11 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* flow.c (try_merge_block): Rename to try_optimize_cfg;
	do basic simplifications on the CFG.
	(is_forwarder_block_p, can_fallthru, try_redirect_by_replacing_jump,
	 try_simplify_condjump): New.
	(redirect_edge_and_branch): Try replace jump insn.
	(flow_delete_insn): Handle deleting of ADDR_VEC insns.

	* basic-block.h (FALLTHRU_EDGE, BRANCH_EDGE): New macros.

Thu Jun 28 11:19:42 2001  Jeffrey A Law  (law@cygnus.com)

	* ssa-dce.c (eliminate_dead_code): Properly handle control
	dependencies implied by PHI nodes.

	* ssa-dce.c (eliminate_dead_code): Remove fake edges from the
	CFG after dead code elimination is complete.

2001-06-28  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* gthr-posix.h [LIBOBJC]: Add weak definitions of
	sched_get_priority_max, sched_get_priority_min.

2001-06-28  Gabriel Dos Reis  <gdr@codesourcery.com>

	* diagnostic.c (default_print_error_function): Tweak.
	(report_error_function): Likewise.
	* toplev.h (default_print_error_function): Move to...
	* diagnostic.h: ...here. Add a `diagnostic_context *' parameter.
	* tree.h (print_error_function): Move to...
	* diagnostic.h: ...here. Add a `diagnostic_context *' parameter.

Thu Jun 28 06:16:45 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_assignment): When have varying-length object,
	make MEM a BLKmode.
	(expand_expr, case ADDR_EXPR): Use SAVE_EXPR_RTL after putting
	SAVE_EXPR stack in case we had a SUBREG.

Thu Jun 28 10:31:06 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (cmp?i): Simplify; refuse immediate operand
	in alternative 0
	* i386.c (cmpsi_operand): Refuse constants.

	* i386.md (movsi_insv_1, movsi_insv_1_rex64): Allow immediate operand.

	* flow.c (block_label, redirect_edge_and_branch): Split out from ....
	(split_edge) .... here;

2001-06-28  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* i386/i386.c (ix86_valid_type_attribute_p): Give external
	linkage, move declaration to...
	* i386/i386-protos.h: ...here.

2001-06-27  H.J. Lu  (hjl@gnu.org)

	* build-make (CC): Removed.
	(HOST_CC): Set to $(CC_FOR_BUILD).
	(HOST_CFLAGS): Replace $(CFLAGS) with $(CFLAGS_FOR_BUILD).
	Fix a typo in comments.

	* configure.in: Set CFLAGS to $(CFLAGS_FOR_BUILD) when
	generating auto-build.h for canadian cross compile. Set CC
	to `"${CC_FOR_BUILD}"' instead of just `${CC_FOR_BUILD}'.
	Save/restore CFLAGS.
	* configure: Regenerated.

2001-06-27  Jim Wilson  <wilson@redhat.com>

	* emit-rtl.c (gen_highpart): Call validize_mem.

2001-06-27  Bruce Korb  <bkorb@gnu.org>

	* fixinc/inclhack.def(hpux11_cpp_pow_inline): new, but real similar to
	hpux10_cpp_pow_inline.  Not similar enough.
	(solaris_mutex_init): renamed.  PTHREAD_*_INITIALIZER is a problem for
	all Solaris versions.  This fix patches MUTEX and COND initializers,
	the RWLOCK one will wait for someone to complain.  For now, anyway.
	(uw7_byteorder_fix): It was looking for the byteorder.h file in the
	wrong directory.

2001-06-27  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c (handle_impent): Rewrite to be more portable
	and to use ASM_DECLARE_CLASS_REFERENCE.
	* config/darwin.h (ASM_DECLARE_CLASS_REFERENCE): Rename from
	undocumented DECLARE_CLASS_REFERENCE, add file argument.
	* doc/tm.texi (ASM_DECLARE_CLASS_REFERENCE): Document.

Wed Jun 27 18:01:09 2001  Jeffrey A Law  (law@cygnus.com)

	* simplify-rtx.c (simplify_rtx): Canonicalize commutative expressions
	by putting complex operands first and constants second.

2001-06-27  Gabriel Dos Reis  <gdr@codesourcery.com>

	* diagnostic.h: Add documentation. Make macros polymorphic.
	* diagnostic.c (ideal_line_wrap_cutoff): Remove
	definition. Replace with diagnostic_line_cutoff.
	(prefixing_policy): Remove. Replace with diagnostic_prefixing_rule.

2001-06-27  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/c-tree.texi, doc/contrib.texi, doc/cpp.texi,
	doc/cppinternals.texi, doc/extend.texi, doc/gcc.texi,
	doc/gcov.texi, doc/install-old.texi, doc/install.texi,
	doc/invoke.texi, doc/md.texi, doc/rtl.texi, doc/tm.texi: Replace
	. at end of sentences preceded by a capital letter with @..

2001-06-26  Daniel Berlin  <dan@cgsoftware.com>

	* doc/invoke.texi: Add description of max-gcse-passes param.

	* gcse.c (gcse_main): Use MAX_GCSE_PASSES instead of MAX_PASSES.
	(MAX_PASSES): Remove now unneeded macro.

	* params.h (MAX_GCSE_PASSES): New macro, to get parameter value of
	max-gcse-passes param.

	* params.def (PARAM_MAX_GCSE_PASSES): New parameter, controlling
	maximum number of GCSE passes to run. Defaults to 1 (which is what
	MAX_PASSES in gcse.c used to be).

2001-06-27  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* system.h (TARGET_ESC): Move to ...
	* defaults.h (TARGET_ESC): ... here.
	* target-def.h (TARGET_VALID_DECL_ATTRIBUTE,
	TARGET_VALID_TYPE_ATTRIBUTE): Default to a no-op handler.
	* tree.c (default_valid_attribute_p): New.
	(valid_machine_attribute): Handlers can not be NULL.
	* tree.h (default_valid_attribute_p): New.
	* doc/tm.texi: Document TARGET_ESC.
	* cp/decl2.c (import_export_class): Update.

2001-06-26  Bruce Korb  <bkorb@gnu.org>

	* gcc/fixinc/fixincl.c(initialize): In very strict ANSI, you cannot
	use preprocessing directives inside a string literal.  Fixed.

2001-06-26  Jim Wilson  <wilson@redhat.com>

	* doc/tm.texi (MAX_LONG_DOUBLE_TYPE_SIZE, INTEL_EXTENDED_IEEE_FORMAT):
	Document.

2001-06-27  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/cpp.texi, doc/cppinternals.texi, doc/extend.texi,
	doc/gcc.texi, doc/install.texi, doc/invoke.texi, doc/md.texi,
	doc/tm.texi: Use @: where necessary when a full stop does not end
	a sentence.

2001-06-27  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi, doc/install.texi, doc/invoke.texi: Remove trailing
	whitespace.

2001-06-26  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/c-tree.texi, doc/cpp.texi, doc/extend.texi, doc/gcc.texi,
	doc/install.texi, doc/invoke.texi, doc/objc.texi, doc/rtl.texi,
	doc/tm.texi: Use two spaces after ends of sentences.

2001-06-26  Daniel Berlin  <dan@cgsoftware.com>

	* toplev.c (display_help): Fix param thinko.
	* Makefile.in: Fix params.h dependencies.

2001-06-26  Gabriel Dos Reis  <gdr@codesourcery.com>

	* toplev.c (decode_f_option): Adjust setting.
	(toplev_main): Call diagnostic_initialize.  Remove call to
	reshape_diagnostic_buffer._

	* diagnostic.h (struct output_buffer): Add new field format_decoder.
	(diagnostic_format_decoder): New macro.
	(diagnostic_prefixing_rule): Likewise.
	(diagnostic_line_cutoff): Likewise.
	(set_message_prefixing_rule): Remove.

	* diagnostic.c (lang_printer): Remove.
	(diagnostic_message_length_per_line): Likewise.
	(current_prefixing_rule): Likewise.
	(initialize_diagnostics): Rename to...
	(diagnostic_initialize): ...this. Tweak.
	(default_initialize_buffer): Remove.
	(reshape_diagnostic_buffer): Likewise.
	(init_output_buffer): Adjust prefixing rule setting.
	(output_format): Use format_decoder from the output_buffer.

	* c-lang.c (c_init): Adjust tree formatter setting.

2001-06-26  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/i386/sol2.h (CPP_SPEC): Pass -P for .S files.

2001-06-26  Neil Booth  <neil@daikokuya.demon.co.uk>

	* Makefile.in (TARGET_H, TARGET_DEF_H): New.
	(c-decl.o, tree.o, c-typeck.o, $(out_object_file)): Update.
	* c-decl.c (duplicate_decls): Use function pointer.
	* c-typeck.c (common_type): Similarly.
	* tree.c (valid_machine_attribute): Similarly.
	(merge_machine_type_attributes): Rename merge_type_attributes.
	(merge_machine_decl_attributes): Rename merge_decl_attributes.
	(merge_dllimport_decl_attributes): New function.
	* tree.h (merge_machine_type_attributes): Rename merge_type_attributes.
	(merge_machine_decl_attributes): Rename merge_decl_attributes.
	(merge_dllimport_decl_attributes): New prototype.
	* target.h: New.
	* target-def.h: New.

doc:	(Joseph Myers)
	* doc/gcc.texi, doc/tm.texi: Update documentation.

cp:	Make-lang.in: Update dependencies.
	* spew.c: Include target.h.
	(duplicate_decls): Call target function.
	* decl2.c: include target.h
	(import_export_class): Use existence of target function pointer.
	* typeck.c: Include target.h.
	(qualify_type_recursive): Rename variable.  Call target function.
	(type_after_usual_arithmetic_conversions): Similarly.
	(common_type): Similarly.

config:	* 1750a/1750a.c, a29k/29k.c, alpha/alpha.c, arc/arc.c, arm/arm.c,
	avr/avr.c, c4x/c4x.c, clipper/clipper.c, convex/convex.c,
	d30v/d30v.c, dsp16xx/dsp16xx.c, elxsi/elxsi.c, fr30/fr30.c,
	i370/i370.c, i386/i386.c, i860/i860.c, i960/i960.c, ia64/ia64.c,
	m32r/m32r.c, m68hc11/m68hc11.c, m68k/m68k.c, m88k/m88k.c,
	mips/mips.c, mn10200/mn10200.c, mn10300/mn10300.c, ns32k/ns32k.c,
	pa/pa.c, pdp11/pdp11.c, pj/pj.c, romp/romp.c, rs6000/rs6000.c,
	sh/sh.c, sparc/sparc.c,	v850/v850.c, vax/vax.c, we32k/we32k.c)
	: Include target.h and target-def.h.  Define target.

	* arc/arc-protos.h (arc_valid_machine_decl_attribute): Remove.
	* arc/arc.c (arc_valid_machine_decl_attribute): Rename
	arc_valid_decl_attribute, make static.
	* arc/arc.h (VALID_MACHINE_TYPE_ATTRIBUTE): Remove.
	* arm/arm-protos.h (arm_valid_machine_decl_attribute,
	arm_valid_type_attribute_p, arm_pe_valid_machine_decl_attribute,
	arm_pe_merge_machine_decl_attributes): Remove.
	* arm/arm.c (arm_valid_machine_decl_attribute_p): Rename
	arm_valid_decl_attribute_p, make static.
	(arm_pe_valid_decl_attribute_p): Move from pe.c.
	* arm/pe.c (arm_pe_valid_machine_decl_attribute_p): Move to arm.c.
	(arm_pe_merge_machine_decl_attributes): Move to tree.c.
	* arm/arm.h (VALID_MACHINE_TYPE_ATTRIBUTE): Remove.
	* arm/coff.h (VALID_MACHINE_DECL_ATTRIBUTE): Remove.
	* arm/elf.h (VALID_MACHINE_DECL_ATTRIBUTE): Remove.
	* arm/pe.h (TARGET_DLLIMPORT_DECL_ATTRIBUTES): New.
	(VALID_MACHINE_TYPE_ATTRIBUTE, VALID_MACHINE_DECL_ATTRIBUTE): Remove.
	* avr/avr-protos.h (valid_machine_type_attribute,
	valid_machine_decl_attribute): Remove.
	* avr/avr.c (valid_machine_type_attribute,
	valid_machine_decl_attribute): Rename and make static.
	* avr/avr.h (VALID_MACHINE_TYPE_ATTRIBUTE,
	VALID_MACHINE_DECL_ATTRIBUTE): Remove.
	* c4x/c4x-protos.h (c4x_valid_type_attribute_p): Remove.
	* c4x/c4x.c (c4x_valid_type_attribute_p): Make static.
	* c4x/c4x.h (VALID_MACHINE_TYPE_ATTRIBUTE): Remove.
	* d30v/d30v.h: Remove obsolete comments.
	* h8300/h8300-protos.h (h8300_valid_machine_decl_attribute): Remove.
	* h8300/h8300.c (h8300_valid_machine_decl_attribute): Rename, make
	static.
	* h8300/h8300.h (VALID_MACHINE_DECL_ATTRIBUTE): Remove.
	* i386/cygwin.h (TARGET_DLLIMPORT_DECL_ATTRIBUTES): Define.
	(i386_pe_merge_decl_attributes, MERGE_MACHINE_DECL_ATTRIBUTES,
	i386_pe_valid_type_attributes_p): Remove.
	* i386/i386-protos.h (ix86_valid_decl_attribute_p,
	ix86_valid_type_attribute_p): Remove.
	* i386/i386.c (ix86_valid_decl_attribute_p): Remove.
	(ix86_valid_type_attribute_p): Make static.
	* i386/i386.h (VALID_MACHINE_DECL_ATTRIBUTE,
	VALID_MACHINE_TYPE_ATTRIBUTE): Remove.
	* i386/winnt.c (i386_pe_merge_decl_attributes): Move to tree.c.
	* ia64/ia64-protos.h (ia64_valid_type_attribute): Remove.
	* ia64/ia64.c (ia64_valid_type_attribute): Make static.
	* ia64/ia64.h (VALID_MACHINE_TYPE_ATTRIBUTE): Remove.
	* m32r/m32r-protos.h (m32r_valid_machine_decl_attribute): Remove.
	* m32r/m32r.c (m32r_valid_decl_attribute): Make static.
	* m32r/m32r.h (VALID_MACHINE_DECL_ATTRIBUTE): Remove.
	* m68hc11/m68hc11-protos.h (m68hc11_valid_decl_attribute_p,
	m68hc11_valid_type_attribute_p): Remove.
	* m68hc11/m68hc11.c (m68hc11_valid_decl_attribute_p): Remove.
	(m68hc11_valid_type_attribute_p): Make static.
	* m68hc11/m68hc11.h (VALID_MACHINE_DECL_ATTRIBUTE,
	VALID_MACHINE_TYPE_ATTRIBUTE): Remove.
	* mcore/mcore-protos.h (mcore_valid_machine_decl_attribute,
	mcore_merge_machine_decl_attribute): Remove.
	* mcore/mcore.c (mcore_valid_machine_decl_attribute): Rename,
	make static.
	(mcore_merge_machine_decl_attributes): Move to tree.c.
	* mcore/mcore.h (VALID_MACHINE_DECL_ATTRIBUTE,
	VALID_MACHINE_TYPE_ATTRIBUTE): Remove.
	(TARGET_DLLIMPORT_DECL_ATTRIBUTES): Define.
	* ns32k/ns32k-protos.h (ns32k_valid_decl_attribute_p,
	ns32k_valid_type_attribute_p): Remove.
	* ns32k/ns32k.c (ns32k_valid_decl_attribute_p): Remove.
	(ns32k_valid_type_attribute_p): Make static.
	* ns32k/ns32k.h (VALID_MACHINE_DECL_ATTRIBUTE,
	VALID_MACHINE_TYPE_ATTRIBUTE): Remove.
	* rs6000/rs6000-protos.h (rs6000_valid_decl_attribute_p,
	rs6000_valid_type_attribute_p): Remove.
	* rs6000/rs6000.c (rs6000_valid_decl_attribute_p): Remove.
	(rs6000_valid_type_attribute_p): Make static.
	* rs6000/rs6000.h (VALID_MACHINE_DECL_ATTRIBUTE,
	VALID_MACHINE_TYPE_ATTRIBUTE): Remove.
	* sh/sh-protos.h (sh_valid_machine_decl_attribute): Remove.
	* sh/sh.c (sh_valid_machine_decl_attribute): Rename, make static.
	* sh/sh.h (VALID_MACHINE_DECL_ATTRIBUTE): Remove.
	* v850/v850-protos.h (v850_valid_machine_decl_attribute): Remove.
	* v850/v850.c (v850_valid_machine_decl_attribute): Rename, make static.
	* v850/v850.h (VALID_MACHINE_DECL_ATTRIBUTE): Remove.

2001-06-26  Vladimir Makarov  <vmakarov@toke.toronto.redhat.com>

	* glimits.h (USHRT_MAX): Use unsigned suffix if int can not hold
	it.

2001-06-26  Gabriel Dos Reis  <gdr@codesourcery.com>

	* diagnostic.h (struct diagnostic_context): Add new field.
	(lang_diagnostic_starter, lang_diagnostic_finalizer): Remove
	declaratons.
	(global_dc): Declare.
	* diagnostic.c (global_diagnostic_context): New variable.
	(global_output_buffer): Remove.
	(global_dc): Define.
	(lang_diagnostic_starter, lang_diagnostic_finalizer): Remove
	definitions.
	(initialize_diagnostics): Adjust initialization.
	(set_diagnostic_context): Adjust setting.

2001-06-26  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/iris5.h (UNALIGNED_INT_ASM_OP,
	UNALIGNED_SHORT_ASM_OP): Define.
	* config/mips/iris6.h (UNALIGNED_INT_ASM_OP,
	UNALIGNED_SHORT_ASM_OP): Undef.

Tue Jun 26 12:40:12 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (float_truncate splitter, and to mov splitters): Add
	reload_completed; fix operand predicate.

	* haifa-sched.c (sched_init): Do not split insns.
	* toplev.c (rest_of_compilation): Call split_all_insns before
	sched1 pass; simplify condition of post-reload splitter;
	call split_all_insn before sched2 pass.

2001-06-26  Gabriel Dos Reis  <gdr@codesourcery.com>

	* diagnostic.h (diagnostic_prefixing_rule_t): New enum type.
	(set_message_prefixing_rule): Adjust prototype.
	* diagnostic.c (current_prefixing_rule): Adjust type.

2001-06-26  Neil Booth  <neil@daikokuya.demon.co.uk>

	* defaults.h: Default escape sequences to ASCII.
	* config/i370/i370.h: Adjust for ASCII default.
	* config/1750a/1750a.h: Remove escape sequence definitions.
	* config/a29k/a29k.h: Similarly.
	* config/alpha/alpha.h: Similarly.
	* config/arc/arc.h: Similarly.
	* config/arm/arm.h: Similarly.
	* config/avr/avr.h: Similarly.
	* config/c4x/c4x.h: Similarly.
	* config/clipper/clipper.h: Similarly.
	* config/convex/convex.h: Similarly.
	* config/d30v/d30v.h: Similarly.
	* config/dsp16xx/dsp16xx.h: Similarly.
	* config/elxsi/elxsi.h: Similarly.
	* config/fr30/fr30.h: Similarly.
	* config/h8300/h8300.h: Similarly.
	* config/i386/i386.h: Similarly.
	* config/i860/i860.h: Similarly.
	* config/i960/i960.h: Similarly.
	* config/ia64/ia64.h: Similarly.
	* config/m32r/m32r.h: Similarly.
	* config/m68hc11/m68hc11.h: Similarly.
	* config/m68k/m68k.h: Similarly.
	* config/m88k/m88k.h: Similarly.
	* config/mcore/mcore.h: Similarly.
	* config/mips/mips.h: Similarly.
	* config/mn10200/mn10200.h: Similarly.
	* config/mn10300/mn10300.h: Similarly.
	* config/ns32k/ns32k.h: Similarly.
	* config/pa/pa.h: Similarly.
	* config/pdp11/pdp11.h: Similarly.
	* config/pj/pj.h: Similarly.
	* config/romp/romp.h: Similarly.
	* config/rs6000/rs6000.h: Similarly.
	* config/sh/sh.h: Similarly.
	* config/sparc/sparc.h: Similarly.
	* config/v850/v850.h: Similarly.
	* config/vax/vax.h: Similarly.
	* config/we32k/we32k.h: Similarly.
	* doc/tm.texi: Update documentation.

2001-06-26  Gabriel Dos Reis  <gdr@merlin.codesourcery.com>

	* diagnostic.c (digit_buffer): Remove as global.  Move to...
	* diagnostic.h (struct output_buffer): ... here.
	* diagnostic.c (output_formatted_integer): Adjust use of digit_buffer.

2001-06-25  Steve Ellcey  <sje@cup.hp.com>

	* config.gcc (ia64*-*-hpux*): Add ia64/hpux_longdouble.h to tm_file.
	Define tmake_file to include ia64/t-hpux.
	* real.c (INTEL_EXTENDED_IEEE_FORMAT): Test for value instead of
	testing to see if it is defined.
	* real.h (INTEL_EXTENDED_IEEE_FORMAT): Likewise.  Default to 0 if
	undefined.
	* config/ia64/hpux_longdouble.h: New.
	* config/ia64/ia64.c (hfa_element_mode): Add comment about incorrect
	handling of long doubles.
	(ia64_function_arg, ia64_function_value): Add checks for TFmode
	and INTEL_EXTENDED_IEEE_FORMAT.
	* config/ia64/ia64.h (INTEL_EXTENDED_IEEE_FORMAT): Define to one.
	(HARD_REGNO_NREGS, HARD_REGNO_MODE_OK, LIBCALL_VALUE): Add checks for
	TFmode and INTEL_EXTENDED_IEEE_FORMAT.
	* config/ia64/ia64.md (all TFmode patterns): Test
	INTEL_EXTENDED_IEEE_FORMAT in condition.
	(floatdidf2, floatdisf2): New, for !INTEL_EXTENDED_IEEE_FORMAT.
	* config/ia64/quadlib.c: New.
	* config/ia64/t-hpux: New.
	* config/i386/i386.h (INTEL_EXTENDED_IEEE_FORMAT): Define to one.

2001-06-25  Jim Wilson  <wilson@redhat.com>

	* config/i960/t-960bare (i960-c.o): Add missing header dependencies.
	* config/i960/t-vxworks960: Likewise.

2001-06-25   Dale Johannesen    <dalej@apple.com>

	* bitmap.c (bitmap_last_bit_set): Fix a non-c89 usage (null actual
	argument to macro).

Mon Jun 25 11:10:51 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (movsi_insv_1, movsi_insv_1_rex64): Fix constraints.

2001-06-25  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/c-tree.texi, doc/contrib.texi, doc/extend.texi,
	doc/gcc.texi, doc/gcov.texi, doc/install.texi, doc/invoke.texi,
	doc/md.texi, doc/rtl.texi, doc/tm.texi: Be more consistent about
	the use of "GCC" and related terms.
	* doc/gcc.1, doc/gcov.1: Regenerate.

2001-06-24  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/extend.texi, doc/gcc.texi, doc/install-old.texi,
	doc/invoke.texi, doc/md.texi, doc/rtl.texi, doc/tm.texi: Remove
	uses of @refill.

Sun Jun 24 21:21:49 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* (movsi_insv_1, movsi_insv_1_rex64): Allow immediate operand.

2001-06-24  Richard Henderson  <rth@redhat.com>

	* builtins.c (expand_builtin_expect_jump): Disable if the
	expression can't be re-evaluated.

2001-06-24  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.c (arm_compute_save_reg_mask): For FIQ interrupt
	handlers examine register r0-r7, for other interrupt handlers
	examine r0-r12.  If the interrupt handler is not a leaf function
	save all call clobbered registers.
	(arm_output_epilogue): If the prologue has pushed the IP register,
	restore it here.
	(Arm_expand_prologue): For interrupt functions that need the frame
	pointer, push the IP register before it is corrupted.

	* config/arm/arm.h (ARM_SIGN_EXTEND): Fix compile time warnings
	about the use of signed and unsigned quantities in a conditional.

2001-06-23  Richard Henderson  <rth@redhat.com>

	* config/alpha/crtfastmath.c: New file.
	* config/alpha/t-crtfm: New file.
	* config/alpha/elf.h (ENDFILE_SPEC): Use crtfastmath.o.
	* config/alpha/osf.h (ENDFILE_SPEC): Likewise.
	* config/alpha/t-crtbe (EXTRA_PARTS): Add pieces defined here.
	* config.gcc (alpha-{linux,freebsd,netbsd,osf}): Use alpha/t-crtfm;
	do not set extra_parts here.

2001-06-24  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install-old.texi: Remove more documentation of configure
	options.
	* doc/install.texi: Add it here.

Sat Jun 23 19:40:05 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386-protos.h (emit_i387_cw_initialization): Declare.
	* i386.md (movsi_insv_1): Remove '*'.
	(fix_trunc?f?i2): Revamp to use control word parameters.
	(fix_trunc?i_1): Likewise; update splitters.
	(fix splitter): Remove.
	* i386.c (MAX_386_STACK_LOCALS): set to 3.
	(emit_i387_cw_initialization): New function.
	(output_fix_trunc): Do not initialize control word;
	kill dead code; simplify.

2001-06-23  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* cppmacro.c (make_string_token): Avoid warning.
	(cpp_macro_definition): Prepend the macro name.  Update
	comments.
	* cppmain.c (cb_define, dump_macro): Update for changes
	to cpp_macro_definition.

Sat Jun 23 10:20:03 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* flow.c (attempt_auto_inc, try_pre_increment_1): Fix typo.

Sat Jun 23 01:23:59 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* flow.c (mark_set_1, attempt_auto_inc, mark_used_reg,
	try_pre_increment_1): compute REG_FREQ using bb->frequency.

	* regclass.c (loop_cost): Kill.
	(frequency): New global variable.
	(record_operand_costs): Replace loop_cost by frequency.
	(scan_one_insn): Likewise.
	(regclass): Likewise; set frequency according to bb->frequency.

	* flow.c (split_edge): Set frequency.

Sat Jun 23 01:16:42 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* predict.c (block_info_def): Add nvisited.
	(propagate_freq): Count nvisited; re-queue delayed blocks; handle
	irreducible regions.

	* flow.c (dump_edge_info): Dump the probability of edge.
	(combine_predictions_for_insn): Dump the basic block.

2001-06-22  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi: Update documentation of source files of C
	compiler.

2001-06-22  Richard Henderson  <rth@redhat.com>

	* doc/invoke.texi (-funsafe-math-optimizations): Document its
	possible effects at link time.

2001-06-22  Diego Novillo  <dnovillo@redhat.com>

	* basic-block.h (dump_edge_info): Declare.
	(clear_edges): Declare.
	(mark_critical_edges): Declare.
	* flow.c (dump_edge_info): Remove static declaration.
	(clear_edges): Ditto.
	(mark_critical_edges): Ditto.
	(free_basic_block_vars): Only clear edges and free basic block
	array if basic_block_info is not NULL.
	* ssa.c (compute_dominance_frontiers): Remove static declaration.
	* ssa.h (compute_dominance_frontiers): Declare.

2001-06-22  Toshiyasu Morita  (toshiyasu.morita@hsa.hitachi.com)

	* predict.c: (expected_value_to_br_prob): Check for const_true_rtx
	instead of const1_rtx for true case.

2001-06-22  David Mosberger  <davidm@hpl.hp.com>

	* config/ia64/crtfastmath.c: New file.
	* config/ia64/t-ia64 (EXTRA_PARTS): Include it.
	* config/ia64/linux.h (ENDFILE_SPEC): New.

2001-06-22  Toshiyasu Morita  <toshiyasu.morita@hsa.hitachi.com>

	* config/h8300/h8300.c (asm_file_start): Remove reference to
	"release F-1".

2001-06-22  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-common.c (verify_tree): Check for x being NULL.
	* doc/c-tree.texi: Document COMPOUND_BODY of an empty
	COMPOUND_STMT.
	Fixes PR c/3259.

2001-06-22  DJ Delorie  <dj@redhat.com>

	* config/arm/arm.h (struct machine_function): Remove ra_rtx.
	* config/arm/arm.c (arm_mark_machine_status): Remove ra_rtx.
	(arm_return_addr): Use get_hard_reg_initial_val et al.
	* config/d30v/d30v.h (struct machine_function): Remove ra_rtx.
	* config/d30v/d30v.c (d30v_mark_machine_status): Remove ra_rtx.
	(d30v_return_addr): Use get_hard_reg_initial_val et al.
	* config/rs6000/rs6000.h (struct machine_function): Remove ra_rtx.
	* config/rs6000/rs6000.c (rs6000_override_options): Don't set
	mark_machine_status.
	(rs6000_mark_machine_status): Remove.
	(rs6000_return_addr): Use get_hard_reg_initial_val.
	(rs6000_ra_ever_killed): Use has_hard_reg_initial_val.
	* config/v850/v850.h (INIT_EXPANDERS): Delete.
	* config/v850/v850.c (struct machine_function): Delete.
	(v850_init_machine_status): Delete.
	(v850_mark_machine_status): Delete.
	(v850_free_machine_status): Delete.
	(v850_return_addr): Use get_hard_reg_initial_val.
	(v850_init_expanders): Delete.

Fri Jun 22 19:20:59 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* predict.c (estimate_bb_frequencies): Do not handle conditional
	jumps jumping to fallthru basic block as conditional jumps.

Fri Jun 22 19:11:28 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* regs.h (struct reg_info_def): Add freq field.
	(REG_N_REFS): Update comment.
	(REG_FREQ): New.
	* regclass.c (scan_one_insn): Update REG_FREQ.
	* flow.c (mark_set_1): Update REG_FREQ, make REG_N_SETS unweighted.
	(attempt_auto_inc): Likewise.
	(mark_used_reg): Likewise.
	(try_pre_increment_1): Likewise.
	* local-alloc.c (struct qty): Add freq field.
	(alloc_qty): Set freq.
	(update_equiv_regs): Set REG_FREQ.
	(QTY_CMP_PRI): Use freq.
	(combine_regs): Update qty->freq.
	* global.c (struct allocno): Update comment for n_refs;
	add freq field.
	(local_reg_freq): New array.
	(global_alloc): Update freq field;
	allocate and initialize local_reg_freq.
	(allocno_compare): Use freq field.
	(find_reg): Likewise.
	* reload1.c (count_pseudo): Use freq isntead of n_refs.
	(count_spilled_pseudo): Likewise.

	* tm.texi (GCOV_TYPE_SIZE): Document.
	* basic-block.h (gcov_type): Define.
	(struct edge_def): Use gcov_type for count field.
	(struct basic_block_def): Likewise.
	* defaults.h (GCOV_TYPE_SIZE): Define.
	* final.c (end_final): Use GCOV_TYPE_SIZE.
	* flow.c (dump_edge_info, dump_flow_info, dump_bb): Print count fields
	using HOST_WIDEST_INT_PRINT_DEC.
	* gcov-io.h (__fetch_gcov_type, __store_gcov_type, __read_gcov_type,
	__write_gcov_type): New.
	(store_long): Remove.
	* gcov.c (gcov_type): Set default.
	(struct adj_list): Use gcov_type for arc_count.
	(bb_info): Use gcov_type for succ_count, pred_count and exec_count.
	(create_program_flow_graph): Read arc_count properly.
	(solve_program_flow_graph): 'total' is gcov_type.
	(output_data): Line_counts is gcov_type, print it properly.
	* libgcc2.c (struct bb): Counts is gcov_type.
	(__bb_exit_func): Use __read_gcov_type and __write_gcov_type.
	* profile.c (LONG_TYPE_SIZE, LONG_LONG_TYPE_SIZE): Set default.
	(GCOV_TYPE_SIZE): Define.
	(struct bb_info): succ_count and pred_count is gcov_type.
	(compute_branch_probabilities): Use __read_gcov_type,
	print read edges to the dump file.
	(total): Is gcov_type.
	(gen_edge_profiler): Use GCOV_TYPE_SIZE.

2001-06-14  Andrew Haley  <aph@cambridge.redhat.com>

	* optabs.c (emit_libcall_block): When using non-call exceptions,
	don't mark libcalls never throwing.

2001-06-21  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c (hash_init): Use xcalloc.

2001-06-21  Richard Henderson  <rth@redhat.com>

	* flow.c (entry_exit_blocks): Initialize frequency.
	(split_block): Copy it.
	(dump_flow_info): Dump it.

Thu Jun 21 22:15:10 2001  J"orn Rennecke <amylaar@redhat.com>

	* sh.c (barrier_align): Also recognize branch-around-a-jump-sequence
	from machine-depedent_reorg for purposes of alignment supression
	when no delay slot insn has been added.

2001-06-21  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* cppmacro.c (make_string_token): Null terminate.

2001-06-21  DJ Delorie  <dj@redhat.com>

	* config/alpha/alpha.h (struct machine_function): Remove.
	* config/alpha/alpha.c (integrate.h): Include.
	(override_options): Don't set up machine_status hooks.
	(alpha_init_machine_status): Remove.
	(alpha_mark_machine_status): Remove.
	(alpha_free_machine_status): Remove.
	(alpha_return_addr): Use get_hard_reg_initial_val.
	(alpha_gp_save_rtx): Likewise.
	(alpha_ra_ever_killed): Use has_hard_reg_initial_val.

2001-06-20  Aldy Hernandez  <aldyh@redhat.com>

	* config/sh/sh.md (interrupt_function): Use
	current_function_interrupt.
	(define_delay): Schedule in delay slot if TARGET_SH3, even if it is
	an interrupt function.

	* config/sh/sh.h (current_function_interrupt): Define extern.

	* config/sh/sh.c (current_function_interrupt): New global.
	(sh_expand_prologue): Set current_function_interrupt.

2001-06-21  Phil Edwards  <pme@sources.redhat.com>

	* doc/install.texi:  Add 'c' to list of --enable-languages choices.

2001-06-21  DJ Delorie  <dj@redhat.com>

	* integrate.c (mark_hard_reg_initial_vals): Check for NULL.

	* integrate.c (ggc.h): Include.
	(initial_value_pair, initial_value_struct,
	setup_initial_hard_reg_value_integration): Add prototypes.
	(expand_inline_function): Call
	setup_initial_hard_reg_value_integration.
	(has_func_hard_reg_initial_val, get_func_hard_reg_initial_val,
	get_hard_reg_initial_val, has_hard_reg_initial_val): New functions
	to keep track of values present at the start of a function.
	(mark_hard_reg_initial_vals): New, for gc.
	(setup_initial_hard_reg_value_integration): New.  Sets up pseudo
	mappings for initial values.
	(emit_initial_value_sets): New.  Emits code to set initial value
	pseudos.
	* integrate.h: Add prototypes for new functions.
	* function.h (struct function): Add hard_reg_initial_vals field.
	* function.c (integrate.h): Include.
	(mark_function_status): Call
	mark_hard_reg_initial_vals.
	* toplev.c (integrate.h): Include.
	(rest_of_compilation): Call emit_initial_value_sets.

2001-06-21  Stan Shebs  <shebs@apple.com>

	* doc/contrib.texi, doc/cpp.texi, doc/cppinternals.texi,
	doc/extend.texi, doc/gcc.texi, doc/install.texi, doc/invoke.texi,
	doc/objc.texi, doc/tm.texi: Use the correct name "Objective-C"
	everywhere instead of "Objective C".

2001-06-21  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/c-tree.texi, doc/contrib.texi, doc/extend.texi,
	doc/gcc.texi, doc/install-old.texi, doc/install.texi,
	doc/invoke.texi, doc/rtl.texi: Consistently use "front end" and
	"back end" as nouns and "front-end" and "back-end" as adjectives.

Wed Jun 20 21:53:35 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* predict.c (estimate_probability): Fix loop bounds.

Wed Jun 20 19:10:48 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation): Run mark_constant_function
	before profile-arcs.

Wed Jun 20 19:08:18 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* predict.c (estimate_loops_at_level, propagate_freq
	estimate_bb_frequencies, count_to_freqs): New functions.
	(estimate_probability): Call estimate_bb_frequencies.
	* basic-block.h (basic_block_def): Add field "freq".
	(BB_FREQ_MAX): New constant.

Wed Jun 20 17:02:50 2001  J"orn Rennecke <amylaar@redhat.com>

	* sh.c (barrier_align): Don't ask for alignment when seeing a
	branch-around-a-jump from machine_dependent_reorg.

Wed Jun 20 08:35:02 2001  Jeffrey A Law  (law@cygnus.com)

	* ssa.c (rename_block): Update parameter to remove_phi_alternative
	(convert_from_ssa): Do create REG_DEAD and REG_UNUSED notes when
	re-running life analysis.

2001-06-20  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c (hash_init): Assume xmalloc always succeeds,
	also use memset to clear the hash tables.
	(hash_enter): Assume xmalloc always succeeds.
	(hash_add_attr): Ditto.
	(continue_class): Ditto.

2001-06-20  Michael Meissner  <meissner@redhat.com>

	* builtins.c (predict.h): Include.
	(expand_builtin_expect): Update comment.
	(expand_builtin_expect_jump): New function to expand
	__builtin_expect inside of a conditional jump expansion.

	* expr.c (do_jump): Special case __builtin_expect (<test>, 0) and
	__builtin_expect (<test>, 1).

	* Makefile.in (builtins.o): Depend on $(PREDICT_H).

	* rtl.h (expand_builtin_expect_jump): Add prototype.

2001-06-19  Geoffrey Keating  <geoffk@redhat.com>

	* doc/rtl.texi (Machine Modes): Correct description of
	floating-point modes on machines with non-8-bit bytes.

2001-06-19  Bernd Schmidt  <bernds@redhat.com>

	* regmove.c (optimize_reg_copy_3): Do nothing if previous insn
	carries a REG_EQUIV note.  If it carries REG_EQUAL, delete the
	note.

Tue Jun 19 07:53:52 2001  Jeffrey A Law  (law@cygnus.com)

	* ssa.c (remove_phi_alternative): Remove declaration.  No longer
	static.  Second argument is a pointer to a basic block structure,
	not a basic block index.
	(convert_to_ssa): Do not remove dead code.
	(convert_from_ssa): Do not remove dead code to create death notes.
	* ssa.h (remove_phi_alternative): Declare.

	* flow.c (delete_unreachable_blocks): Fix patch error in
	previous change (call to find_unreachable_blocks was lost).

	* ssa.c (ssa_uses): Remove definition.
	(apply_delayed_renames): Don't grow ssa_uses.
	(rename_block): Remove comment related to ssa_uses.
	(rename_registers): Do not initialize ssa_uses.
	(convert_from_ssa): Do not free ssa_uses.

	* ssa-dce.c: Renamed from dce.c.
	* Makefile.in (OBJS): Replace dce.o with ssa-dce.o
	(dependencies): Replace dce.c with ssa-dce.c and dce.o with
	ssa-dce.o.

2001-06-19  Eric Christopher <echristo@redhat.com>

	* emit-rtl.c (gen_lowpart_common): Do not assume that SFmode
	and DFmode are UNITS_PER_WORD and 2*UNITS_PER_WORD.  Use
	GET_MODE_BITSIZE instead of GET_MODE_SIZE/UNITS_PER_WORD.

Tue Jun 19 01:52:27 2001  J"orn Rennecke <amylaar@redhat.com>

	* sh.c (output_branch): Delete bogus code.

	* sh.c (initial_elimination_offset):
	Fix FROM == RETURN_ADDRESS_POINTER_REGNUM case.

Mon Jun 18 12:50:49 2001  Jeffrey A Law  (law@cygnus.com)

	* flow.c (find_unreachable_blocks): New function.
	(delete_unreachable_blocks): Use find_unreachable_blocks.
	* basic-block.h (find_unreachable_blocks): Declare.

	* dce.c (eliminate_dead_code): Fix formatting glitch.

2001-06-18  Jason Merrill  <jason_merrill@redhat.com>

	* c-common.h (RETURN_NULLIFIED_P): New macro.
	* c-semantics.c (genrtl_return_stmt): Check it.

	* expr.c (clear_storage): Set TREE_NOTHROW on the decl for memset.
	(emit_block_move): Likewise.

Mon Jun 18 17:27:24 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* unroll.c: Include predict.h.
	(unroll_loop): Drop prediction notes on preconditioning.
	* predict.def (PRED_LOOP_PRECONDITIONG, PRED_LOOP_CONDITION):
	New; add comments on the others.
	* Makefile.in: (unroll.o): Add dependency on predict.h.
	* loop.c (strength_reduce): Fix branch prediction.

Mon Jun 18 17:26:56 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* stmt.c (emit_case_nodes): Optimize test whether index is in given
	interval.

Mon Jun 18 15:43:10 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* predict.c (estimate_probability): Do not bail out early
	when note is present.
	(combine_predictions_for_insn): Fix note removal code.

2001-06-18  Ben Elliston  <bje@redhat.com>

	* except.c (resolve_fixup_regions): Initialise "cleanup".

2001-06-17  Neil Booth  <neil@daikokuya.demon.co.uk>

	* tm.texi: Document STDC_0_IN_SYSTEM_HEADERS.

Sat Jun 16 20:20:39 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_expr, case ADDR_EXPR): If taking address of SAVE_EXPR,
	use put_var_into_stack.

2001-06-16  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* gccspec.c (lang_specific_driver): If compiling ObjC, add
	-shared-libgcc when necessary.
	* Makefile.in (gccspec.o): Compile with DRIVER_DEFINES.

2001-06-16  Daniel Berlin  <dan@cgsoftware.com>

	* bitmap.h: Add dump_bitmap, bitmap_zero, bitmap_union_of_diffs,
	bitmap_a_or_b, bitmap_a_and_b, bitmap_first_set_bit,
	bitmap_last_set_bit. All for compatibility with sbitmap's.

	*bitmap.c (bitmap_zero): New function.
	(bitmap_union_of_diffs): New function.
	(bitmap_first_set_bit): New function.
	(bitmap_last_set_bit): New function.

2001-06-16  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpp.texi, invoke.texi: Update.
	* cpp.1, gcc.1: Regenerate.

Sat Jun 16 12:45:20 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (minsf): Fix splitter. (PR fortran/3191)

2001-06-16  Neil Booth  <neil@daikokuya.demon.co.uk>

	* doc/cpp.texi: Update.
	* doc/cpp.1: Regenerate.

2001-06-15  Loren J. Rittle  <ljrittle@acm.org>

	* doc/install.texi: Use correct markup hints.

Fri Jun 15 18:05:22 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* function.c (gen_mem_addressof): Handle case where DECL is SAVE_EXPR.

	* explow.c (expr_size): If DECL and size specified, use it.

2001-06-15  Zack Weinberg  <zackw@stanford.edu>

	* doc/cpp.texi: Formatting corrections.
	Correct buggy example of use of __GNUC__ etc.
	Clarify $ in identifiers.
	* doc/cpp.1: Regenerate.

Fri Jun 15 19:35:38 CEST 2001 Jan Hubicka  <jh@suse.cz>

	* optabs.c (expand_twoval_binop): Avoid undefined behaviour.

2001-06-15  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* doc/install.texi (Specific, alpha*-*-*): Fixed Tru64 UNIX
	etc. spelling.
	(Specific, alpha-*-osf1): Renamed to alpha*-*-osf*.
	Added Tru64 UNIX V5.1 bootstrap hints.
	(Specific, alpha*-*-osf*): Removed old section, obsolete.

2001-06-15  Andreas Jaeger  <aj@suse.de>

	* doc/install.texi (Specific): Mention that glibc cannot be
	compiled with GCC 3.0.

2001-06-14  Andrew Haley  <aph@cambridge.redhat.com>

	* combine.c (nonzero_bits): Don't optimize away division by
	zero.

2001-06-15  Zack Weinberg  <zackw@stanford.edu>

	* doc/cpp.texi: Revised and brought up to date.
	* doc/cpp.1: Regenerate.

2001-06-15  Loren J. Rittle  <ljrittle@acm.org>

	* doc/install.texi: Update --enable-threads to match reality.

2001-06-15  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* doc/install.texi: Update for C4x.
	* README.C4X: Remove.

2001-06-14  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/c-tree.texi, doc/contrib.texi, doc/extend.texi,
	doc/gcc.texi, doc/install.texi, doc/invoke.texi, doc/md.texi,
	doc/objc.texi, doc/rtl.texi, doc/tm.texi: Fix spelling and typos.
	Consistently use "built-in" and "bit-field".  Minor logical markup
	improvements.
	* doc/gcc.1: Regenerate.

2001-06-14  Richard Henderson  <rth@redhat.com>

	* config/mips/mips.md (exception_receiver): New.

2001-06-14  Daniel J. Berlin <dan@cgsoftware.com>

	* doc/gcc.texi:  Update passes documentation to be more in tune
	with reality.

Thu Jun 14 15:38:28 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_prologue): Fix merging conflict.

2001-06-14  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/c-tree.texi, doc/contrib.texi, doc/extend.texi,
	doc/gcc.texi, doc/gcov.texi, doc/install-old.texi,
	doc/invoke.texi, doc/md.texi, doc/rtl.texi, doc/tm.texi: Use more
	logical markup.  Use TeX quotes and dashes.  Use @dots{} and
	@minus{}.  Avoid spaces inside @var.  Update last modification
	date in gcc.texi.
	* doc/gcc.1, doc/gcov.1: Regenerate.

Thu Jun 14 12:44:15 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_accumulate_outgoing_args, x86_prologue_using_move,
	x86_epilogue_using_move): New global variables.
	(override_options): Enable ACCUMULATE_OUTGOING_ARGS if preferred.
	(ix86_emit_save_regs_using_mov): New static function.
	(ix86_expand_prologue, ix86_expand_epilogue): Use moves if preferred.
	* i386.h (MASK_MMX, MASK_SSE, MASK_SSE2, MASK_128BIT_LONG_DOUBLE,
	MASK_MIX_SSE_I387): Renumber.
	(MASK_NO_ACCUMULATE_OUTGOING_ARGS): New.
	(x86_accumulate_outgoing_args, x86_prologue_using_move,
	x86_epilogue_using_move): Declare.
	(TARGET_PROLOGUE_USING_MOVE, TARGET_EPILOGUE_USING_MOVE): New.

2001-06-13  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* inclhack.def (hpux10_cpp_pow_inline): New hack.

2001-06-13  Richard Henderson  <rth@redhat.com>

	* ifcvt.c (dead_or_predicable): Fix return value last patch.

2001-06-13  Mark Mitchell  <mark@codesourcery.com>

	* NEWS: Remove.

2001-06-13  Richard Henderson  <rth@redhat.com>

	* ifcvt.c (cond_exec_get_condition): Use reversed_comparison_code.
	(cond_exec_process_if_block, dead_or_predicable): Likewise.

2001-06-13  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* mips-tfile.c (copy_object): Always pass indexNil for symbol
	table index.

2001-06-13  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.h (OK_FOR_T): Remove.
	(EXTRA_CONSTRAINT): Do not use OK_FOR_T.
	* config/h8300/h8300.md: Remove alternatives involving inc and dec
	in the helper patterns for addhi3 and addsi3.

2001-06-13  Phil Edwards  <pme@sources.redhat.com>

	* doc/contrib.texi:  Link to libstdc++'s thanks.html for now.

2001-06-13  Zack Weinberg  <zackw@stanford.edu>

	* Makefile.in: Move _bb and __gcc_bcmp to LIB2FUNCS_ST.
	* libgcc-std.ver: Take out __bb* and __gcc_bcmp.

	* config/t-slibgcc-elf-ver, config/t-slibgcc-sld,
	config/alpha/t-osf4, config/mips/t-iris6: Extract all
	references to @shlib_map_file@, @shlib_objs@, or
	@shlib_base_name@ to Makefile variables.
	Bump soname version of libgcc to 1.

2001-06-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install.texi: Use more logical markup.  Include @node
	commands in the source when generating any non-HTML.

2001-06-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* README: Remove.  Some of the contents moved to ../README.

2001-06-13  Alexandre Oliva  <aoliva@redhat.com>

	* doc/install.texi (--enable-shared): List package names
	recognized by GCC.

2001-06-13  Alexandre Oliva  <aoliva@redhat.com>

	* doc/install.texi (ix86-*-solaris*): Removed, outdated.
	(*-*-solaris*): Document problem in /bin/sh that affects
	configuring libraries.
	(sparc-*-solaris*): Recommend GNU binutils 2.11.1 or vendor tools.
	(*-sun-solaris2.8): Document linker problem that explains why
	libjava is disabled by default.

2001-06-09  Mark Mitchell  <mark@codesourcery.com>

	Revert this patch:
	* toplev.c (rest_of_compilation): Remove dead code before
	purge_addressof.

2001-06-12  Alexandre Oliva  <aoliva@redhat.com>

	Reverted:
	2001-06-07  Nathan Sidwell  <nathan@codesourcery.com>
	* configure.in (sparc*-*-*): Check assembler R_SPARC_UA32 support.
	* configure: Rebuilt.

2001-06-12  Jim Wilson  <wilson@redhat.com>

	* loop.c (strength_reduce): Move bl->all_reduced set before
	check_ext_dependant_givs call.
	(check_ext_dependant_givs): Clear bl->all_reduced when ignoring givs.

2001-06-12  Alexandre Oliva  <aoliva@redhat.com>

	* doc/extend.texi (Function Attributes): Document SH's sp_switch
	and trap_exit.

2001-06-13  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/invoke.texi: Use more logical markup.  Use TeX quotes,
	dashes and @dots{}.

2001-06-12  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (ix86_expand_prologue): Always use
	gen_pro_epilogue_adjust_stack; update arguments.
	(ix86_expand_epilogue): Likewise.
	(ix86_emit_epilogue_esp_adjustment): Remove.
	(ix86_adjust_cost): Remove pro_epilogue_adjust_stack hack.
	* config/i386/i386.md (pro_epilogue_adjust_stack): Use a BLKmode
	clobber of scratch memory instead of a modification of EBP as the
	barrier.  Update all peepholes to match.

2001-06-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi: Change the font used for @def... commands to a
	fixed width font.
	* doc/extend.texi: Use more logical markup.  Use "built-in"
	instead of "builtin".  Use @deftypefn to mark up built-in
	functions; specify their types in the @deftypefn and not in the
	descriptive text.  Use TeX quotes and dashes.  Add more index
	entries.

2001-06-12  lars brinkhoff  <lars@nocrew.org>

	* gcc.texi (HOST_BITS_PER_LONGLONG): Document.
	(DIR_SEPARATOR_2): Likewise.

2001-06-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install.texi (--exec-prefix, --bindir, --libdir,
	--with-slibdir, --infodir, --mandir, --with-cpp-install-dir):
	Document.
	(--enable-cpp): Change to document --disable-cpp instead; update
	to reflect current default.
	(--without-fast-fixincludes): Remove documentation.
	(Final install): Document installation directories in more
	detail.  Document use of make dvi.

Tue Jun 12 19:01:43 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* recog.c (validate_replace_rtx_1): Fix previous patch.

Tue Jun 12 17:25:39 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* recog.c (validate_replace_rtx_1): Do plus_constant call always.

Tue Jun 12 17:24:07 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* simplify-rtx.c (simplify_subreg): Allow volatile memory
	to be subregged in case we don't have move instruction.

Tue Jun 12 12:20:12 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* loop.c: Include predict.h
	(strength_reduce): Drop branch prediction note in case
	number of iterations is known.
	* predict.def (PRED_LOOP_ITERATIONS): new.
	* Makefile.in (loop.o): Add dependency on predict.h

2001-06-12  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-decl.c (grokdeclarator): Use INTEGRAL_TYPE_P.

	* c-typeck.c (c_start_case): Likewise.

2001-06-12  Mark Mitchell  <mark@codesourcery.com>

	* expr.c (store_field): Don't set MEM_ALIAS_SET for a field
	in a structure at a variable address.

2001-06-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcov.texi: Use more logical markup.

2001-06-11  Mark Mitchell  <mark@codesourcery.com>

	* unroll.c (initial_reg_note_copy): Use PUT_REG_NOTE_KIND and
	REG_NOTE_KIND, not PUT_MODE and GET_MODE.
	(final_reg_note_copy): Remove REG_WAS_0 notes that are no longer
	valid.

2001-06-11  Stan Shebs  <shebs@apple.com>

	* config/darwin.h (ASM_FILE_END): Remove decl of language_string.

2001-06-11  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md ("*lshrdi3_const32"): Mark the clobber
	as an early clobber to make sure it is not used by reload in
	one of the operands.

2001-06-11  Mark Mitchell  <mark@codesourcery.com>

	* doc/c-tree.texi: Update information about flag_honor_std.
	* doc/install.texi: Note that binutils is required on HPUX 11.
	* doc/invoke.texi (-fhonor-std): Note that -fno-honor-std is
	now the default.

	* config/mips/abi64.h (RETURN_IN_MEMORY): Fix handling of
	variable-sized types.

2001-06-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/md.texi: Use TeX dashes and quotes.

2001-06-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/rtl.texi: Reference manual chapter about trees.

2001-06-11  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/iris6.h (NO_BUILTIN_WINT_TYPE): Define.
	(WINT_TYPE): Override.
	(WINT_TYPE_SIZE): Likewise.
	(SUBTARGET_CPP_SIZE_SPEC): Define __WINT_TYPE__ as appropriate.

	* config/sparc/sol2.h (WINT_TYPE): Define.
	(WINT_TYPE_SIZE): Likewise.

	* config/sparc/sol2-sld-64.h (NO_BUILTIN_WINT_TYPE): Define.
	(WINT_TYPE): Override.
	(WINT_TYPE_SIZE): Likewise.
	(CPP_ARCH32_SPEC): Add __WINT_TYPE__ definition.
	(CPP_ARCH64_SPEC): Likewise.

2001-06-11  Richard Henderson  <rth@redhat.com>

	* unwind-dw2-fde.c (__deregister_frame_info): Don't play games
	with alias attribute.

	* config/linux.h (CPLUSPLUS_CPP_SPEC): Use %(cpp) not $(cpp_cpu).
	* config/alpha/linux.h (CPLUSPLUS_CPP_SPEC): Likewise.

2001-06-11  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* config/rs6000/linux.h (CPLUSPLUS_CPP_SPEC): New.

2001-06-11  Stan Shebs  <shebs@apple.com>

	* config/darwin.c (darwin_encode_section_info):  Rewrite to simplify
	and fix coding mistakes.

2001-06-11  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/m32r/m32r.md (movstrsi_internal): Do not expect a
	return string from m32r_output_block_move.
	* config/m32r/m32r-protos.h: Make m32r_output_block_move a
	void function.
	* config/m32r/m32r.h (INT32_P): Rename to UNIT32_P and remove
	integer overflow.
	(ROUND_ADVANCE): Remove signed/unsigned conflict.
	* config/m32r/m32r.c: Declare prototypes for static functions.
	(move_src_operand): Replace INT32_P with UINT32_P.
	(function_arg_partial_nregs): Fixed signed/unsigned conflict
	in initialisation of 'size'.
	(m32r_sched_reord): Remove redundant declarations of 'code'.
	(m32r_output_block_move): Change to a void function.
	(m32r_encode_section_info): Cast return of
	TREE_STRING_POINTER to avoid compile time warning.

2001-06-11  Richard Henderson  <rth@redhat.com>

	* config/alpha/osf5.h (TARGET_LD_BUGGY_LDGP): New.
	* config/alpha/alpha.h (TARGET_LD_BUGGY_LDGP): Default.
	(struct machine_function): Add gp_save_rtx.
	* config/alpha/alpha.c (alpha_mark_machine_status): Mark it.
	(alpha_gp_save_rtx): New.
	* config/alpha/alpha-protos.h: Declare it.
	* config/alpha/alpha.md (exception_receiver): Make an expander.
	Use alpha_gp_save_rtx if TARGET_LD_BUGGY_LDGP.

2001-06-11  Richard Henderson  <rth@redhat.com>

	* config/alpha/osf.h (LINK_SPEC): Hide _GLOBAL_* symbols.

2001-06-11  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* configure.in: Align --help messages.
	Remove trailing full stops.
	Consistently use lower case.
	Fix DWARF 2 spelling.
	* configure: Rebuilt.

2001-06-11  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/alpha/alpha.h (CPP_SPEC): Don't define __LANGUAGE_C and
	variants for .cpp/.cp/.c++ files.
	Move definition of __LANGUAGE_C_PLUS_PLUS ...
	(CPLUSPLUS_CPP_SPEC): ... here.

Mon Jun 11 15:47:45 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* jump.c (duplicate_loop_exit_test): Fix loop header heuristics.

2001-06-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-decl.c (store_parm_decls): When comparing types in an
	old-style function declaration with those from a previous
	prototype, compare the unqualified versions of parameter types.
	Fixes PR c/3116.

2001-06-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/objc.texi: Use more logical markup.  Use TeX dashes.

2001-06-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/c-tree.texi: Use more logical markup.

2001-06-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-decl.c (xref_tag): Don't return previous tags of wrong type.

2001-06-11  Aldy Hernandez  <aldyh@redhat.com>

	* loop.c (scan_loop): Do not combine asm statements.

2001-06-11  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* simplify-rtx.c (simplify_subreg): Fix offset calculation
	for complex values within a CONCAT.

2001-06-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install.texi: Update details of what components are included
	in the GCC distribution.  Update default directory for g++
	includes.  Update documentation relating to old libio.  Adjust
	documentation on DejaGnu environment variables.  Remove
	documentation of --enable-cpplib.

2001-06-11  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/contrib.texi: Fix alphabetical order.  Fix typos.  Improve
	markup.

2001-06-10  Richard Henderson  <rth@redhat.com>

	* ifcvt.c (life_data_ok): New.
	(merge_if_block): Use it to determine whether to update
	global_live_at_end.
	(if_convert): Set it.

2001-06-10  Richard Henderson  <rth@redhat.com>

	* config/alpha/osf5.h (ASM_OLDAS_SPEC): Add -c.

2001-06-10  Alexandre Oliva  <aoliva@redhat.com>

	* doc/invoke.texi (MN10300 Options): Document -mno-crt0.
	(SH Options): Document -mieee.
	* doc/install.texi (Final install): Remove obsolete information
	about installing cross compilers.
	* doc/gcc.1: Rebuilt.

2001-06-10  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (override_options): Set align_loops,
	align_jumps, and align_functions.
	* config/alpha/alpha.h (FUNCTION_BOUNDARY): Set to 32 bits.
	(LOOP_ALIGN, LABEL_ALIGN_AFTER_BARRIER): Remove.

2001-06-11  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* emit-rtl.c (gen_lowpart_common): Do not assume that SFmode and DFmode
	are one and two words in size.

2001-06-10  Richard Henderson  <rth@redhat.com>

	* doc/invoke.texi (Optimization Options): Document -fpeephole2.
	(Code Generation Options): Document -fnon-call-exceptions.

2001-06-10  Mark Kettenis  <kettenis@gnu.org>

	* config/i386/gnu.h (MD_FALLBACK_FRAME_STATE_FOR): Undefine.

2001-06-10  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* m68hc11.md (peepholes): Remove unused and wrong peepholes.

2001-06-10  Mark Mitchell <mark@codesourcery.com>
	    Gabriel Dos Reis  <gdr@codesourcery.com>

	* Makefile.in (c-parse.o): Depend on diagnostic.h
	(dwarf2out.o): Likewise.

	* dwarf2out.c: #include diagnostic.h

	* toplev.h (warningcount, errorcount, sorrycount): Remove
	declarations.

	* toplev.c (warningcount, errorcount, sorrycount): Remove
	definitions.

	* diagnostic.h (struct output_buffer): Reorder fields.
	(diagnostic_kind_count): New macro.
	(errorcount, warningcount, sorrycount): Define as macros.
	(diagnostic_report_warnings_p): New macro.
	(output_state): Add diagnostic_count field.

	* diagnostic.c (warningcount, errorcount, inhibit_warnings):
	Remove tentative declaration.
	(count_error): Use diagnostic_report_warnings_p.

	* c-parse.in: #include diagnostic.h

2001-06-10  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md ("extendhisi2"): Fix constraints to
	prefer a memory for operand 1.
	("*addsi3"): Fix constraints, the '!' was too strong.
	("*addsi3_split"): Accept soft register and split accordingly.

2001-06-10  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11-protos.h (m68hc11_initialize_trampoline):
	Move definition in the RTX_CODE section.

2001-06-10  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.h (RETURN_ADDR_RTX): Define the return
	address as relative to the argument pointer.

Sun Jun 10 10:58:53 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* predict.def (PRED_OPCODE): Place before call and error_return.

Sun Jun 10 10:00:17 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* predict.def (PRED_CALL, PRED_ERROR_RETURN): New.
	* predict.c (estimate_probability): Calculate dominance
	information; improve detection of NORETURN heuristics;
	add call/error_return heuiristics; tweak comparison heuristics
	to recognize -1.

2001-06-09  Alexandre Oliva  <aoliva@redhat.com>

	* doc/invoke.texi (C Dialect Options): Document -aux-info.
	(Debugging Options): Document -print-multi-directory and
	-print-multi-lib.
	* doc/gcc.1: Rebuilt.

	* toplev.c (independent_decode_option): Require `=' between
	`-aux-info' and filename in the same argument.
	* gcc.c: Don't pass -aux-info=filename twice.

2001-06-09  Mark Mitchell  <mark@codesourcery.com>

	* expr.c (expand_expr, case ARRAY_REF): Do not replace
	an array element with the known initializing value if it has
	side-effects.

	* toplev.c (rest_of_compilation): Remove dead code before
	purge_addressof.

2001-06-09  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppinit.c (print_help): Document -fpreprocessed.
	* invoke.texi: Similarly.

Sun Jun 10 00:35:37 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* predict.def: New file.
	* predict.h: New file.
	* predict.c: Include predict.h.
	(predictor_info): New structure and array.
	(predict_edge, predict_insn): Rewrite; make global.
	(predict_edge_def, predict_insn_def): New global functions.
	(dump_prediction, combine_predictions_for_insns): New
	static functions.
	(estimate_probability): Change calls to predict_edge
	to predict_edge_def and calls to predict_insn to predict_insn_def;
	combine probabilities.
	(expected_value_to_br_prob): Behave as predictor.
	* rtl.h (REG_BR_PRED): Update coment.
	(invert_br_probabilities): New.
	* jump.c: Include predict.h
	(duplicate_loop_exit_test): Drop branch prediction notes.
	(invert_jump): Use invert_br_probabilities.
	* Makefile.in: Add dependency on predict.h for jump and predict pass.
	* ifcvt.c (dead_or_predicable): Use invert_br_probabilities.
	* combine.c (distribute_notes): Handle BR_PRED.

Sat Jun  9 23:29:41 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* predict.c (predict_insn, predict_edge): New static functions.
	(estimate_probability): Revamp to use new functions;
	fix loop header heruistics; add loop exist heruistics

2001-06-09  Alexandre Oliva  <aoliva@redhat.com>

	* config.gcc: Re-enable bi-arch sparc on Solaris 7 and above.

2001-06-09  Peter Jakubek <pjak@snafu.de>

	* config/m68k/m68k.md (ashrdi_const): Fix right shift by 16.

2001-06-09  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* vax.h (NOTICE_UPDATE_CC): Set CC_NO_OVERFLOW in cc_status.flags
	for integer operations that don't update C bit.

2001-06-09  Nicola Pero <nicola@brainstorm.co.uk>

	* gthr-posix.h (__gthread_objc_init_thread_system): If
	pthread_key_create fails, it's not clear what the return value is.
	This obvious fix makes sure it always returns -1 if a problem
	occurs.

2001-06-09  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi: Use @defcodeindex for the index of options.  Add
	more index entries.  Use more logical markup where appropriate.
	Use TeX quotes and dashes.

2001-06-09  Benjamin Kosnik  <bkoz@redhat.com>

	* unwind-pe.h: Conditionally qualify references to abort with
	std::.

2001-06-09  Julian Foad <julian_foad@hotmail.com>

	* doc/invoke.texi: Remove superfluous text.

2001-06-08  Richard Henderson  <rth@redhat.com>

	* config/alpha/linux.h (CPLUSPLUS_CPP_SPEC): New.
	(LIB_SPEC): Mirror config/linux.h version.

2001-06-08  Richard Henderson  <rth@redhat.com>

	* except.c (get_exception_pointer, get_exception_filter): Take a
	struct function.  Update all callers.
	* except.h (get_exception_pointer): Update declaration.
	* expr.c (expand_expr): Update get_exception_pointer call.
	* integrate.c (expand_inline_function): Remap the exception pointer
	from callee to caller.

2001-06-08  Mark Mitchell  <mark@codesourcery.com>

	* c-decl.c (grokdeclarator): Make the TREE_TYPE for declarations
	accurately reflect its cv-qualification.
	* c-typeck.c (type_lists_compatible_p): Ignore the top-levl
	cv-qualifiers on function types.

2001-06-08  Mark Mitchell  <mark@codesourcery.com>

	* basic-block.h: Improve comments.
	* except.c (expand_eh_region_end_allowed): Remove redundant call
	to do_pending_stack_adjust.
	* flow.c (life_analysis): Fix typo in comment.
	(calculate_global_regs_live): Add documentation.
	(mark_set_1): Likewise.
	(debug_regset): Likewise.
	* doc/rtl.texi (cond_exec): Document it.

Fri Jun  8 21:52:51 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.h (CONST_COSTS): set cost of constants representable in
	immediate fields to 0.

Fri Jun  8 21:34:54 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* function.c (diddle_return_value): Kill code to determine
	return value before expand_function_end.
	(expand_function_end): Delay call to clobber_return_register
	after fucntion return value is computed.

	Re-install temporary reverted patch:
	* toplev.c (rest_of_compilation): Call split_all_insns
	before reg-stack and shorten-branches. Do shorten-branches
	after reg-stack.
	* final.c (shorten_branches): Remove insn splitting code.

2001-06-08  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi, doc/invoke.texi: Add index of command line
	options.  Use @opindex to index them rather than other indexing
	commands.  Use @var{...} instead of <...>.  Avoid spaces in names
	inside @var.  Don't use @kindex to index escape sequences in
	source code.

2001-06-08  Jason Merrill  <jason_merrill@redhat.com>

	* stmt.c (current_nesting_level): New fn.
	* tree.h: Declare it.
	* c-semantics.c (genrtl_compound_stmt): Use it.

	* dbxout.c (dbxout_symbol): Use DECL_RTL_SET_P.

2001-06-08  Jakub Jelinek  <jakub@redhat.com>

	* jump.c (mark_modified_reg): Allow jump threading if condition
	codes are represented by a hard register.

2001-06-08  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/ia64.c (ia64_function_arg): Use [SDT]Fmode as gr_mode
	for complex floats passed to unprototyped functions.

2001-06-08  Mark Mitchell  <mark@codesourcery.com>

	* except.c (expand_eh_region_end_allowed): Call
	do_pending_stack_adjust as necessary.

Fri Jun  8 14:16:33 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* function.c (clobber_return_register): Clobber the pseudo return
	register too.

	* sibcall.c (skip_unreturned_value): New function.
	(call_ends_block_p): Use it.

	* recog.c (split_insn): Break out from ...
	(split_all_insns): ... here; do not use basic block information
	when it is broken.

Thu Jun  7 18:27:53 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* simplify-rtx.c (simplify_subreg):  Fix verification of
	combined subreg.

2001-06-08  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/mips.h (CPP_SPEC): Simplify .s/.S handling.
	Don't define _LANGUAGE_C and variants for .cpp/.cp/.c++ files.
	Move definition of _LANGUAGE_C_PLUS_PLUS ...
	(CPLUSPLUS_CPP_SPEC): ... here.
	Fixes PRs c++/3047, target/441.

2001-06-08  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi2html (MAKEINFO): Keep value if set already.

2001-06-08  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi: Add trailing slash to URL.

2001-06-07  Stan Shebs  <shebs@apple.com>

	* config/darwin.h (ENCODE_SECTION_INFO): Define.
	(REDO_SECTION_INFO_P): Ditto.
	(STRIP_NAME_ENCODING): Ditto.
	(ASM_DECLARE_OBJECT_NAME): Use ENCODE_SECTION_INFO.
	(ASM_OUTPUT_ALIGNED_DECL_LOCAL): Ditto.
	(ASM_OUTPUT_LABELREF): Use STRIP_NAME_ENCODING.
	(GEN_LAZY_PTR_NAME_FOR_SYMBOL): Ditto.
	* config/darwin.c: No longer include c-tree.h.
	(machopic_classify_ident): Rewrite to use symbol encoding.
	(lookup_name_darwin): Remove.
	(machopic_non_lazy_ptr_name): Handle encoded symbols.
	(machopic_stub_name): Use STRIP_NAME_ENCODING.
	(machopic_validate_stub_or_non_lazy_ptr): Ditto.
	(machopic_finish): Ditto, remove test of decl.
	(update_non_lazy_ptrs): New function.
	(darwin_encode_section_info): New function.
	* config/darwin-protos.h: Declare it.
	* config/rs6000/rs6000.c (machopic_output_stub): Use
	STRIP_NAME_ENCODING.

2001-06-07  Mark Mitchell  <mark@codesourcery.com>

	* tree.h (DECL_SOURCE_FILE): Improve documentation.
	(DECL_SOURCE_LINE): Likewise.

2001-06-07  Loren J. Rittle  <ljrittle@acm.org>

	* config/alpha/elf.h (MAKE_DECL_ONE_ONLY): Copy definition
	from config/elfos.h.

2001-06-07  Phil Edwards  <pme@sources.redhat.com>

	* linux.h (CPLUSPLUS_CPP_SPEC):  Move -D_GNU_SOURCE to here.
	* pa/pa-linux.h:  Allow CPLUSPLUS_CPP_SPEC to remain.

2001-06-08  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/contrib.texi: Add copyright notice.

2001-06-08  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/md.texi: Use four digit years in copyright notice.

2001-06-08  Joseph S. Myers  <jsm28@cam.ac.uk>

	* config.gcc: For $target_alias of athlon-*, set
	target_cpu_default2=5.

Thu Jun  7 16:17:40 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* global.c (build_insn_chain): Allow ADDR_VEC or ADDR_DIF_VEC after
	end of last block if last real insn is a JUMP_INSN.

2001-06-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* NEWS: Regenerate.

2001-06-07  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* gthr-posix.h (__gthread_objc_thread_detach): Simply cast
	pthread_t to objc_thread_t.
	(__gthread_objc_thread_id): Likewise.

2001-06-07  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* alpha/osf5.h (CPP_XFLOAT_SPEC): Override default definition.
	(ASM_OLDAS_SPEC): Likewise.

	* alpha/osf.h (CPP_XFLOAT_SPEC): Define.
	(CPP_SUBTARGET_SPEC): Use it.
	(ASM_OLDAS_SPEC): Define.
	(ASM_SPEC): Use it.
	(SUBTARGET_EXTRA_SPECS): Define, declare the new specs above.

2001-06-07  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/alpha/alpha.c (alpha_va_arg): Handle TFmode, TCmode args,
	passed by reference.

2001-06-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/tm.texi (TARGET_SWITCHES, TARGET_OPTIONS): Adjust markup.
	Document use of N_(...), and show it in examples.  Note that
	documentation should be added to invoke.texi.  Avoid an overfull
	hbox.

Thu Jun  7 17:09:50 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation): Revert previous patch.
	* final.c (shorten_branches): Likewise.

2001-06-07  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* pself.c, pself1.c, pself2.c, pself3.c, pself4.c, pself5.c:
	Remove.

2001-06-07  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install-old.texi: Remove more obsolete documentation.

Thu Jun  7 13:20:14 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* expr.c (copy_blkmode_from_reg): Fix operand_subword_force call.

Thu Jun  7 12:12:58 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation): Call split_all_insns
	before reg-stack and shorten-branches. Do shorten-branches
	after reg-stack.
	* final.c (shorten_branches): Remove insn splitting code.

2001-06-07  Nathan Sidwell  <nathan@codesourcery.com>

	* configure.in (sparc*-*-*): Check assembler R_SPARC_UA32 support.
	* configure: Rebuilt.

2001-06-07  Andreas Jaeger  <aj@suse.de>

	* emit-rtl.c (operand_subword): Remove unused variable.

Wed Jun  6 14:51:05 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (floatdi?f): Avoid usinf of SSE instructions
	if TARGET_64BIT is false.
	(floatdi?f_i386_only): New insn.
	(floatdi?f_i386): Disable for !TARGET_64BIT.

	* (min?f, max?f splitters): Handle case where
	operands are cross-matched.

	* i386.h (HI_REGISTER_NAMES): Remove redundant definition
	(MMX_REGISTER_NAMES): Kill.
	(PRINT_OPERAND): Fix comment.
	(PRINT_REG): Likewise.
	* i386.c (print_reg): Kill support for 'm' CODE; simplify.
	(print_operand): Update comment; kill 'm'.

	* i386.c (x86_branch_hints): New global variable
	(print_operand): Support outputting of branch prediction hints.
	* i386.md (conditional jump patterns): Add branch prediction hints
	to the template.
	* i386.h (x86_branch_hints): Declare
	(TARGET_BRANCH_PREDICTION_HINTS): New macro.
	(PRINT_OPERAND_FUNCT_VALID_P): New.
	* final.c (final_forward_branch_p): New function.

2001-06-06  Richard Henderson  <rth@redhat.com>

	* flow.c (mark_used_reg): Clean up looping over multiple hard
	registers.  Do conditional life bits across multiple hard regs.

2001-06-05  Jeffrey D. Oldham  <oldham@codesourcery.com>

	* reload1.c (reload): Revert Schmidt's change so all USEs are not
	deleted during reload.

2001-06-05  Mark Mitchell  <mark@codesourcery.com>

	* c-semantics.c (genrtl_scope_stmt): Write out nested inline
	functions here, instead of ...
	* c-decl.c (c_expand_body): ... here.

2001-06-05  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc, config/sparc/bsd.h:  Do not directly include
	sparc/sparc.h.  Instead do it via tm_file.

2001-06-05  Richard Henderson  <rth@redhat.com>

	* dwarf2.h (DW_EH_PE_aligned): New.
	* dwarf2asm.c (eh_data_format_name): Name it.
	(dw2_asm_output_encoded_addr_rtx): Align for it.
	* dwarf2out.c (output_call_frame_info): Handle it for personality
	routine and LSDA pointers.

	* unwind-pe.h (DW_EH_PE_aligned): New.
	(base_of_encoded_value): Handle it.
	(read_encoded_value_with_base): Likewise.
	* unwind-dw2-fde.c (base_from_object): Likewise.
	(get_cie_encoding): Likewise.

	* config/alpha/elf.h: Remove ecoff commentary.
	* config/alpha/osf.h (ASM_PREFERRED_EH_DATA_FORMAT): New.

2001-06-05  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc, config/i386/bsd386.h:  Do not directly include
	i386/386bsd.h.  Instead do it via tm_file.

2001-06-05  David O'Brien  <obrien@FreeBSD.org>

	* elfos.h (USING_ELFOS_H):  Identify the use of elfos.h in the same
	way svr4.h does.

2001-06-05  Pascal Obry  <obry@act-europe.fr>

	* configure.in: Quote $enable_win32_registry in case the value has
	spaces in it.
	* configure: Ditto.

2001-06-05  Mark Mitchell  <mark@codesourcery.com>

	* print-rtl.c (xspaces): Remove.
	(print_rtx): Use printf field-width, rather than xpsaces, to
	indent.
	* toplev.c (main): Disable sibling-call optimization if we are
	handling exceptions.

2001-06-05  Bernd Schmidt  <bernds@redhat.com>

	* reload1.c (reload): Delete all USEs generated during reload.

2001-06-05  scott snyder  <snyder@fnal.gov>

	* gccbug.in:  Fix typo.

2001-06-05  Andreas Jaeger  <aj@suse.de>

	* builtins.def: Fix definition of __builtin_cosf, it uses float as
	parameter and return value.

2001-06-04  Anthony Green  <green@redhat.com>

	* config/sparc/elf.h (CPP_PREDEFINES): Don't assert cpu or
	machine.  This is now done in sparc.h.

2001-06-05  Nathan Sidwell  <nathan@codesourcery.com>

	Correct CVS resurrection of invoke.texi.
	* doc/invoke.texi: Document new tree dump flags.

2001-06-05  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-typeck.c (build_c_cast): Use TYPE_MAIN_VARIANT when checking
	for casting an aggregate to its own type.  Fixes PR c/2735.

2001-06-05  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/texinfo.tex: Update to version 2001-05-24.08.

2001-06-05  Nathan Sidwell  <nathan@codesourcery.com>

	* c-common.h (flag_dump_translation_unit): Remove.
	(enum tree_dump_index): Define.
	(TDF_ADDRESS, TDF_SLIM): New #defines.
	(dump_node_to_file): Remove.
	(dump_node): Make extern. Add flags.
	(dump_flag, dump_enabled_p, dump_begin, dump_end,
	dump_switch_p): Prototype.
	* c-common.c (flag_dump_translation_unit): Remove.
	* c-decl.c (c_decode_option): Remove -fdump-translation-unit
	logic. Use dump_switch_p.
	* c-dump.h (struct dump_info): Add node and user fields.
	(dump_pointer): Declare.
	* c-dump.c (dump_node): Make extern. Add flags.
	(SOL_COLUMN, EOL_COLUMN, COLUMN_ALIGNMENT): New #defines.
	(dump_new_line, dump_maybe_newline): Use them.
	(dump_pointer): New function.
	(dequeue_and_dump): Check TDF_SLIM before dumping a _DECL's
	chain or function's body. Dump address, if TDF_ADDRESS set.
	(dump_flag): Define.
	(dump_node_to_file): Remove.
	(struct dump_file_info): New struct.
	(dump_files): New array.
	(dump_begin, dump_end, dump_enabled_p, dump_switch_p): Define.
	* c-lang.c (finish_file): Adjust dumping.
	* toplev.h (dump_base_name): Make extern.
	* invoke.texi: Document new flags.

2001-06-04  Mark Mitchell  <mark@codesourcery.com>

	* c-tree.h (lang_decl): Add pending_sizes fields.
	* c-decl.c (store_parm_decls): Save pending_sizes away for nested
	functions.
	(c_expand_body): Expand them.
	(lang_mark_tree): Mark lang_decl:pending_sizes.
	* function.c (expand_pending_sizes): New function, broken out
	from ...
	(expand_function_start): ... here.
	* tree.h (expand_pending_sizes): Declare it.

2001-06-04  Loren J. Rittle  <ljrittle@acm.org>

	* doc/install.texi: Update FreeBSD information.  Generalize
	and update information for alpha-based platforms using ELF.

2001-06-04  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* c-decl.c (get_parm_info): Use INTEGRAL_TYPE_P.
	(store_parm_decls): Likewise.
	* c-typeck.c (convert_arguments): Likewise.

2001-06-04  Richard Henderson  <rth@redhat.com>

	* sibcall.c (optimize_sibling_and_tail_recursive_call): Suppress
	optimization if current_function_calls_setjmp.

2001-06-04  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/c-tree.texi: Fix documentation of TREE_STRING_LENGTH for
	wide strings.

Mon Jun  4 20:44:25 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* simplify-rtx.c (simplify_subreg): Fix combining of
	paradoxical subregs.

Mon Jun  4 20:15:25 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* rtlanal.c (rtx_unsable_p): ADDRESSOF is stable.
	(no_labels_between_p): Short circuit case beg==end.

Mon Jun  4 20:03:05 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* rtlanal.c (operand_preference): Fix preference for objects.

Mon Jun  4 20:00:40 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* gcse.c (handle_avail_expr): Be prepared to handle single_set
	parallels.

Mon Jun  4 19:59:46 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* combine.c (if_then_else_cond): Use simplify_subreg instead
	of operand_subword.
	* integreate.c (sub_constants): Likewise.

Mon Jun  4 19:59:12 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* emit-rtl.c (constant_subword): Deprecate; remove most of code
	and use simplify_gen_subreg.

Mon Jun  4 19:55:23 CEST 2001  Lars Brinkhoff  <lars@nocrew.org>

	* sibcall.c (skip_copy_to_return_value): recognize the situation
	when the called function's return value is copied into an
	intermediate pseudo, and then into the calling functions return
	value register.

Mon Jun  4 16:50:33 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* simplify_rtx.c (simplify_subreg): Keep subregs on return values,
	check CLASS_CANNOT_CHANGE_MODE before avoiding subreg on hard reg,
	in case register wasn't OK previously, accept it now; allow
	subregs of frame pointer if reload completed and frame pointer
	is not needed.

	* combine.c (sombine_simplify_rtx): Fix comment;
	use subreg_lowpart_offset instead of subreg_lowpart_p
	(gen_lowpart_for_combine): Use subreg_lowpart_offset.
	* rtl.h (subreg_lowpart_parts_p): Kill.
	(subreg_lowpart_offset, subreg_highpart_offset): Declare.
	* simplify-rtx.c (simplify_subreg): Use subreg_lowpart_offset.
	* emit-rtl.c (gen_lowpart_SUBREG): Use subreg_lowpart_offset;
	(gen_lowpart_common): Likewise.
	(subreg_lowpart_p): Likewise.
	(subreg_lowpart_parts_p): Kill.
	(subreg_lowpart_offset, subreg_highpart_offset): New function.

	* emit-rtl.c (gen_lowpart_common): Use simplify_gen_subreg
	to simplify SUBREG and REG.
	(gen_highpart): Use simplify_gen_subreg for all simplifications.

	* emit-rtl.c (gen_realpart, gen_imagpart): Do not handle
	CONCAT specially.

	* rtlanal.c (replace_regs):  Use simplify_gen_subreg

Mon Jun  4 09:21:19 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* doc/c-tree.texi (ARRAY_REF): Say what type of expression must be.
	(ARRAY_RANGE_REF): Added description.

	* tree.def (ARRAY_RANGE_REF): New code.
	* alias.c (handled_component_p, can_address_p): Handle it.
	* dwarf2out.c (loc_descriptor_from_tree): Likewise.
	* explow.c (set_mem_attributes): Likewise.
	* expr.c (expand_assignment, get_inner_reference): Likewise.
	(expand_expr, expand_expr_unaligned, do_jump): Likewise.
	* fold-const.c (operand_equal_p): Likewise.
	* tree.c (staticp, stabilize_reference): Likewise.
	* varasm.c (decode_addr_const): Likewise.

Sun Jun  3 21:59:51 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* reload.c (reload_inner_reg_of_subreg): Return 1 for PLUS.
	(push_reload): Handle non-REG in reload_inner_reg_of_subreg case.

2001-06-03  kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* gcc/config/sh/sh.c (print_operand_address, print_operand): Call
	mark_constant_pool_use before output_addr_const.
	(struct pool_node): New field wend.
	(add_constant): Note a sequence of constants that are referenced
	by a given label.
	(pool_window_label, pool_window_last): New variables.
	(dump_table): Emit a unspec_volatile representing the end of a
	sequence of constants.
	(mark_constant_pool_use): New function.
	* gcc/config/sh/sh.md (UNSPECV_WINDOW_END): New constant.
	(consttable_2): Add the second operand which flags whether
	this consttable entry was used or not.
	(consttable_4, consttable_8, consttable_sf, consttable_df):
	Likewise.
	(consttable_window_end): New insn.

2001-06-03  Alexandre Oliva  <aoliva@redhat.com>

	* insn-addr.h (INSN_ADDRESSES_NEW): Make insn_uid__ unsigned.
	Reformat according to coding standards.

	Warning removal.
	* config/sh/sh.c (print_operand_address): Cast INTVAL to int.
	(shl_and_kind): Cast wide constant.
	(gen_far_branch): Define as static, as in declaration.
	(barrier_align): Compute cache-line length as unsigned.  Add
	parentheses in initial credit computation.
	(rounded_frame_size): Add parentheses.
	(permanent_obstack): Remove declaration.  Include ggc.h for
	declaration of ggc_add_root_rtx().
	(get_free_reg): Removed declaration of unused variable reg.
	(legitimize_pic_address): Mark mode argument as unused.

2001-06-03  Igor Shevlyakov  <igor@windriver.com>

	* config/sh/sh.c (output_branch): Support for insn with lenght
	attr 12 & 16 which represents cond branches outside +-4096 range.

2001-06-03  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/lib1funcs.asm (ic_invalidate): Align the
	cache-mirroring sequence.  Add nops.

2001-06-03  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install-old.texi: Remove more old installation
	documentation.
	* doc/install.texi: Add relevant parts here.

2001-06-03  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi2html: New script.

2001-06-03  David Edelsohn  <edelsohn@gnu.org>

	* doc/install.texi: Update AIX information again.

2001-06-02  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/gcc.texi, doc/install-old.texi: Remove old system-specific
	installation documentation.
	* doc/install.texi: Move it to here.

2001-06-02  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install.texi: Clean up Texinfo markup.

2001-06-02  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/cpp.texi, doc/cppinternals.texi, doc/gcc.texi: Move contents
	to just after title page.

2001-06-02  Joseph S. Myers  <jsm28@cam.ac.uk>

	* doc/install-old.texi: Remove documentation of some configuration
	options.
	* doc/install.texi: Add relevant parts of this documentation here.

2001-06-02  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* contrib.texi: Updated entries for Mark Mitchell, Joseph S. Myers,
	Gerald Pfeifer, Bernd Schmidt, and Dean Wakerley.

Sat Jun  2 12:23:51 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (all uses of ext_register_operand): Make sure they are
	VOIDmode; replace all uses outside zero_extend.
	(and?i splitters): Use ext_register_operands.
	(test?i peep2): Remove ignored constraints.
	* i386.c (ext_register_operand): Check that operand is
	either pseudo or hard or 'Q' register.

Sat Jun  2 06:53:50 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.h (struct record_layout_info_s): New field unpadded_align.
	(set_lang_adjust_rli): New declaration.
	* stor-layout.c (layout_decl): If DECL is packed, but at alignment
	it would have if not packed, do not downgrade DECL_ALIGN.
	(lang_adjust_rli, set_lang_adjust_rli): New.
	(start_record_layout): Initialize new field unpadded_align.
	(debug_rli): Display it.
	(place_union_field, place_field): Set it.
	(layout_type, case RECORD_TYPE): Call via lang_adjust_rli if set.

	* print-tree.c (print_node): Don't print "regdecl" when bit doesn't
	mean that; use proper names instead.
	Print DECL_NO_STATIC_CHAIN.

	* except.c (expand_builtin_frob_return_addr): Add missing call
	to convert_memory_address #ifdef POINTERS_EXTEND_UNSIGNED.
	(expand_builtin_eh_return): Likewise.
	(expand_eh_return): Clean up ptr_mode != Pmode cases.

2001-06-01  Jan van Male  <jan.vanmale@fenk.wau.nl>

	* doc/invoke.texi: Remove references to papers about sequence points
	to readings.html, refer to that page.

2001-06-01  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* README: Update references to installation instructions.

2001-06-01  Laurent Guerby  <guerby@acm.org>
	    Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi: Define srcdir when sources come from CVS.
	Significantly improve markup.  Wrap overly long lines

2001-06-01  DJ Delorie  <dj@redhat.com>

	* c-tree.texi, contrib.texi, cpp.texi, cppinternals.texi,
	extend.texi, fdl.texi, gcov.texi, invoke.texi, md.texi,
	objc.texi, rtl.texi, tm.texi, texinfo.tex, gcc.1, cpp.1,
	gcov.1: Move to doc subdirectory.
	* install.texi: Move to doc/install-old.texi.
	* gcc.texi: Move to doc, refer to install-old.texi.
	* Makefile.in: Reflect move of docs to doc/.
	* f/Make-lang.in: Ditto.
	* java/Make-lang.in: Ditto.
	* doc/.cvsignore: New.

2001-05-31  Jan van Male  <jan.vanmale@fenk.wau.nl>

	* invoke.texi: use two spaces between command options, eliminate
	some 'overfull hboxes'

2001-06-01  Hans-Peter Nilsson  <hp@axis.com>

	* Makefile.in (s-mlib): Make backtick-commands always succeed.
	(DRIVER_DEFINES): Ditto.

2001-05-31  Richard Henderson  <rth@redhat.com>

	* gcc.c (init_gcc_specs): When linking against libgcc_s.so,
	also link against libgcc.a.

2001-05-31  Geoff Keating  <geoffk@cygnus.com>

	* config/mips/mips.h (ASM_OUTPUT_ASCII): Convert to function.
	* config/mips/mips.c (mips_output_ascii): New function.
	* config/mips/mips-protos.h (mips_output_ascii): Prototype.

	* config/mips/mips.h (DWARF_CIE_DATA_ALIGNMENT): Force to 4.

Thu May 31 19:09:53 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* flow.c (set_block_for_new_insns): Remove bogus shortcut.
	* i386.c (ix86_expand_int_movcc): Force one of operands to be register.

2001-05-31  Rodney Brown  <rbrown64@csc.com.au>

	* install.texi (Configuration): Add html links for --with-gnu-as &
	--with-gnu-ld and refer to them from hppa & SCO triplets.
	(Specific): Link back to with-gnu-ld for all ELF platfoms.
	(Specific): Reword AVR binutils recommendation.

2001-05-30  Zack Weinberg  <zackw@stanford.edu>

	* ggc-page.c (size_lookup): Increase minimum allocation size
	to eight bytes.
	(ggc_print_statistics): Report size of each bin in bytes, not
	as its order; there is no longer a direct relationship.

2001-05-31  Jan van Male  <jan.vanmale@fenk.wau.nl>

	* extend.texi: Fix formating of examples, eliminate some
	'overfull hboxes'.
	* gcc.texi: Eliminate some 'overfull hboxes'.
	* invoke.texi: Use two spaces between command options, eliminate
	some 'overfull hboxes'.

2001-05-30  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (dwarf2out_finish): Don't emit DW_AT_stmt_list at -g1.

2001-05-30  Tom Tromey  <tromey@redhat.com>

	* gcc.c (do_spec_1): In `%O' case, if we computed saved_suffix,
	use it in the new association.

2001-05-30  Loren J. Rittle  <ljrittle@acm.org>
	    John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* gthr-posix.h (__gthread_active_ptr): Cast function pointer
	to target type to allow ISO C++ compiler to accept it.
	* gthr-dce.h (__gthread_active_ptr): Likewise.
	* gthr-solaris.h (__gthread_active_ptr): Likewise.

2001-05-30  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpplex.c (_cpp_lex_token): Revert patch of 16 May 2001
	so that we do accept comments in preprocessed input.

2001-05-30  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpphash.c (alloc_node): Cast allocated pointer.

2001-05-30  Gordon Sadler <gbsadler1@lcisp.com>

	* invoke.texi (Option Summary): Remove -isystem-c++ from options.

2001-05-29  Stan Shebs  <shebs@apple.com>

	* gcc.texi: Add links for information about Objective-C.

2001-05-29  Nathan Sidwell  <nathan@codesourcery.com>

	* configure.in (gcc_version): Remove unrequired \ on ". (Solaris
	/bin/sed fails on [^\"]).
	(configargs.h): Likewise.

2001-05-29  Hartmut Schirmer <SchirmerH@Innovative-Systems.de>

	* config/sh/sh.h (IDENT_ASM_OP): End with TAB, not LF.

2001-05-28  Stan Shebs  <shebs@apple.com>

	* objc/objc.gperf: Remove, no longer used.

2001-05-28  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-tree.texi, contrib.texi, cpp.texi, extend.texi, gcc.texi,
	gcov.texi, install.texi, md.texi, objc.texi, rtl.texi, tm.texi:
	Remove trailing whitespace.

2001-05-28  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Specific): http://reality.sgi.com/ariel/freeware/
	became http://freeware.sgi.com/.

2001-05-27  Geoffrey Keating  <geoffk@redhat.com>

	* local-alloc.c (update_equiv_regs): Don't eliminate constant
	expressions at -O0.

2001-05-27  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c: Add/fix various comments.
	(init_selector): Remove, no longer used.
	(build_msg_pool_reference): Ditto.
	(objc_debug): Ditto.

2001-05-27  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-decl.c (init_decl_processing):
	 Don't call start_identifier_warnings.
	* flags.h (warn_id_clash, id_clash_len): Remove.
	* stringpool.c: Don't include flags.h.
	(scan_for_clashes, do_identifier_warnings,
	start_identifier_warnings): Remove.
	* toplev.c (warn_id_clash, id_clash_len): Remove.
	(display_help): Don't document -Wid-clash.
	(decode_W_option): Print warning on -Wid-clash.
	* tree.h (start_identifier_warnings): Remove.
	* invoke.texi: Remove documentation of -Wid-clash.

2001-05-27  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fixinc/fixtests.c: Declare entries in ENV_TABLE.

2001-05-27  Bruce Korb  <bkorb@gnu.org>

	* fixinc/check.tpl(HACK) add and use a Scheme variable
	(has no test text): error out if no "test_text" is defined
	* fixinc/fixincl.tpl: likewise
	(FIXIDX): make it an enumeration so we minimize diffs
	* fixinc/inclhack.def: re-alphabetize and add sort instructions
	* fixinc/fixincl.x: regenerate
	* fixinc/tests/base/stdio.h: test output got moved due to
	the alphabetizing
	* README-fixinc: rewrite (mostly)

2001-05-27  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpplib.c (run_directive): Set pfile->directive.

2001-05-23  Theodore Papadopoulo  <Theodore.Papadopoulo@sophia.inria.fr>

	* c-tree.texi: Reformat the manual as a single chapter now
	included by gcc.texi.
	* gcc.texi: Include c-tree.texi. Merge all indexes.
	* Makefile.in (dvi): Add generation for the cppinternals
	documentation. Added dependencies on fdl.texi and c-tree.texi
	where appropriate.  Use TEXI2DVI instead of custom tex calls.
	(info): Added dependencies on fdl.texi and c-tree.texi where
	appropriate.  Remove the target c-tree.info.

2001-05-27  Lars Brinkhoff  <lars@nocrew.org>

	* combine.c (try_combine): Fix typo in comment.
	* expr.c (expand_expr): Likewise.
	* config/i370/i370.md (untyped_call): Likewise.

2001-05-26  Bruce Korb  <bkorb@gnu.org>

	* fixinc/fixtests.c(stdc_0_in_system_headers_test): Must return "FIX"
	when fixincl is operating in test mode
	* fixinc/inclhack.def(AAB_dgux_int_varargs) : aesthetics
	(AAB_ultrix_limits): remove redundant text
	(AAB_ultrix_memory): ditto
	(AAB_ultrix_string): ditto
	(djgpp_wchar_h): fix the test text
	(irix_stdio_va_list): add test text
	(irix_limits_const): add a testing output file (limits.h is overwritten)
	(strict_ansi_not_ctd): put limits.h second in list for same reason
	(solaris27_mutex_init): test text needed selection text, too

	* fixinc/fixtests.c(stdc_0_in_system_headers_test): Must return "FIX"
	when fixincl is operating in test mode

2001-05-26  Philip Blundell  <philb@gnu.org>

	* config/c4x/c4x-protos.h: Use GCC_C_PRAGMA_H in place of _C_PRAGMA_H.
	* config/i960/i960-protos.h: Likewise.
	* config/i370/i370-protos.h: Likewise.
	* config/h8300/h8300-protos.h: Likewise,
	* config/sh/sh-protos.h: Likewise.
	* config/v850/v850-protos.h: Likewise.

2001-05-26  Philip Blundell  <philb@gnu.org>

	* config/arm/arm-protos.h: Use GCC_C_PRAGMA_H in place of _C_PRAGMA_H.

2001-05-25  Zack Weinberg  <zackw@stanford.edu>

	* toplev.c (debug_args, f_options, W_options): Mark
	descriptions for translation.
	(display_help): Translate descriptions on output.

	* cp/lang-options.h, f/lang-options.h, java/lang-options.h,
	objc/lang-options.h: Mark descriptions for translation.

	* aclocal.m4: Quote final argument of patsubst.  Use
	3-argument form of AC_DEFINE.  Restore quotes to [] while
	using AC_FD_CC.
	* configure.in: Remove unnecessary changequote calls.
	* configure, config.in: Regenerate.

2001-05-25  Sam TH  <sam@uchicago.edu>

	* basic-block.h: Fix header include guards.
	* bitmap.h c-dump.h c-lex.h c-pragma.h c-tree.h collect2.h
	cppdefault.h cpphash.h cpplib.h defaults.h diagnostic.h errors.h
	except.h flags.h gcc.h gcov-io.h graph.h gstab.h gthr-aix.h
	gthr-dce.h gthr-posix.h gthr-rtems.h gthr-single.h gthr-solaris.h
	gthr-vxworks.h gthr-win32.h gthr.h hard-reg-set.h hwint.h
	insn-addr.h libgcc2.h mbchar.h mkdeps.h params.h prefix.h real.h
	rtl.h sbitmap.h system.h timevar.h toplev.h tradcpp.h tsystem.h
	varray.h version.h: Likewise.
	* config/dbxelf.h config/fp-bit.h config/arm/arm-protos.h
	config/arm/arm.h config/c4x/c4x-protos.h
	config/h8300/h8300-protos.h config/h8300/h8300.h
	config/i370/i370-protos.h config/i370/i370.h
	config/i960/i960-protos.h config/mcore/mcore.h
	config/mips/mips-protos.h config/sh/sh-protos.h config/sh/sh.h
	config/v850/v850-protos.h config/v850/v850.h: Likewise.
	* fixinc/fixlib.h fixinc/server.h: Likewise.

2001-05-25  Stacey Sheldon  <ssheldon@Catena.com>

	* config/arc/initfini.c (.init): Fix typo.

2001-05-25  Geoffrey Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.md (fseldfsf4): Correct mode of operand 4.

2001-05-25  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* i386/i386.h (CC1_CPU_SPEC): Clarify -m486 etc deprecation messages.

2001-05-25  Richard Henderson  <rth@redhat.com>

	* libgcc-std.ver: Export XFmode and TFmode versions of symbols.

2001-05-25  Richard Henderson  <rth@redhat.com>

	* config.gcc (all gnu and linux): Use t-slibgcc-elf-ver with t-linux.
	(i386-*-solaris2): Use t-slibgcc-elf-ver or t-slibgcc-sld.
	(sparc*-*-solaris2): Likewise.
	* config/t-linux: Remove shared libgcc macros.
	* config/t-slibgcc-elf-ver: Move from sparc/t-slibgcc.
	* config/t-slibgcc-sld: Move from sparc/t-slibgcc-sld.

2001-05-25  Loren J. Rittle  <ljrittle@acm.org>

	* config.gcc (*-*-freebsd*): Report bad configuration.

2001-05-25  David Edelsohn  <edelsohn@gnu.org>

	* xcoffout.h (DBX_OUTPUT_GCC_MARKER): Do not emit any marker.

	* config/rs6000/aix.h (USER_LABEL_PREFIX): AIX symbols do not have
	any prefix.
	(ASM_OUTPUT_LABELREF): Delete.

2001-05-25  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (strict_ansi_not, strict_ansi_not_ctd,
	strict_ansi_only): Don't run if stdc_0_in_system_headers.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/fixtests.c (stdc_0_in_system_headers_test): New function.
	(FIX_TEST_TABLE): Declare it.
	* fixinc/fixlib.h: Include config.h.

2001-05-25  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (alpha___assert): Change char * args to
	const char * on Tru64 UNIX to avoid excessive warnings from
	assert.h.
	* fixinc/fixincl.x: Regenerate.

2001-05-25  Geoff Keating  <geoffk@redhat.com>

	* dbxout.c (dbxout_symbol): Invert previous patch, which was
	outputting a tag only for variable-size records.

2001-05-25  Jeff Knaggs  <jknaggs@redhat.com>

	* config/alpha/alpha.md (movtf_internal): Use reg_overlap_mentioned_p
	instead of rtx_equal_p for early clobber test.

2001-05-26  Mark Mitchell <mark@codesourcery.com>

	* builtins.def: Encode additional information, such as names and
	types, here.
	* builtin-types.def: New file.
	* builtins.c (built_in_names): Adjust use of DEF_BUILTIN.
	(built_in_decls): Likewise.  Don't explicitly initialize global
	data to NULL.
	(expand_builtin_mathfn): Handle float and long double variants of
	math builtins.
	(expand_builtin): Likewise.
	* c-common.c (c_common_nodes_and_builtins): Make it table-driven.
	(expand_tree_builtin): Handle long, long long, float, and long
	double variants of math functions.
	* c-common.h (c_tree_index): Remove some unused nodes.
	(void_ftype): Remove.
	(void_type_ptr): Likewise.
	(int_ftype_int): Likewise.
	(ptr_ftype_sizetype): Likewise.
	* c-decl.c (init_decl_processing): Remove creation of DWARF
	builtins.
	* defaults.h (MD_INIT_BUILTINS): Provide default definition.
	* tree.h (built_in_function): Adjust definition of DEF_BUILTIN.
	* Makefile.in (c-common.o): Depend on builtin-types.def.

2001-05-25  Dale Johannesen  <dalej@apple.com>

	* config/rs6000/t-darwin: Fix dependencies for darwin.o.

2001-05-25  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-parse.in (notype_initdcl): Remove redundant line.

2001-05-25  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* aclocal.m4: Fixed typo.
	(gcc_AC_HEADER_STDBOOL): Define.
	(gcc_AC_C__BOOL): Define.
	* configure.in: Use them.
	(AC_CHECK_HEADERS): Remove stdbool.h
	* configure, config.in: Regenerate.

2001-05-25  Richard Henderson  <rth@redhat.com>

	* function.c (expand_function_start): Don't abort on PARALLEL
	returns from hard_function_value.

2001-05-25  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.md: Revert previous change.  Do not apply
	the peephole if the components do not die after the sequence.

2001-05-25  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-parse.in (array_declarator): New.  Handle C99 constructs.
	Don't restrict [*] declarators to C only.
	(after_type_declarator, parm_declarator_starttypename,
	parm_declarator_nostarttypename, notype_declarator,
	direct_absdcl1): Use it.
	* c-decl.c (build_array_declarator, set_array_declarator_type):
	New functions.  Warn that [*] isn't properly implemented; pedwarn
	for [*] outside C99 mode if pedantic rather than giving a hard
	error.
	(grokdeclarator): Handle static and type qualifiers in parameter
	array declarators.
	* c-tree.h (build_array_declarator, set_array_declarator_type):
	Declare.
	* extend.texi (Attribute Syntax): Document attributes in parameter
	array declarators.

2001-05-25  Mark Mitchell  <mark@codesourcery.com>

	* config/i386/i386.md: Make sure cmpstr peepholes do not
	affect liveness information.

2001-05-24  Mark Mitchell  <mark@codesourcery.com>

	* c-typeck.c (digest_init): Issue error messages about
	invalid constants, not warnings.

2001-05-24  Mark Mitchell  <mark@codesourcery.com>

	* invoke.texi (-fno-builtin): Document that this is always on
	in C++.

2001-05-24  Philip Blundell  <philb@gnu.org>

	* doc/install.texi (arm*-*-linux-gnu): Say that binutils 2.10 is
	required.

2001-05-24  Philip Blundell  <philb@gnu.org>

	* config/arm/arm.c (output_return_instruction): Correctly handle
	interworking and interrupt functions.

2001-05-24  Philip Blundell  <philb@gnu.org>

	* config/arm/arm.h (TARGET_SWITCHES): Correct misleading help for
	-m{no-}sched-prolog.  Fix typos and improve formatting.

2001-05-24  Philip Blundell  <philb@gnu.org>

	* invoke.texi (ARM Options): Improve wording slightly.  Add
	documentation for more options, including those for Thumb mode.
	Don't mention options that don't exist or are unimplemented.
	(Thumb Options): Delete; merged into above section.

2001-05-24  Geoff Keating  <geoffk@redhat.com>

	* config/rs6000/linux.h (SIGNAL_FRAMESIZE): Define.
	(MD_FALLBACK_FRAME_STATE_FOR): Use it.

Thu May 24 19:47:19 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* simplify-rtx.c (simplify_subreg): Fix CONCAT simplification;
	fix hard register simplification.

Thu May 24 00:15:17 2001  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* sparc/sol2.h (CPLUSPLUS_CPP_SPEC): Add all of CPP_SPEC instead
	of just copying CPP_CPU_SPEC.

Thu May 24 15:56:48 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (incdec_operand): Accept only 1 and -1.

2001-05-23  Kelley Cook  <kelley.cook@home.com>

	* Makefile.in: Move many of the *_H definitions eariler in the
	file, so that rules in t-* files that use them for
	dependencies will work in a parallel build.
	* config/i386/t-cygwin (winnt.o): Depend on $(CONFIG_H).

2001-05-23  Richard Henderson <rth@redhat.com>

	* integrate.c (expand_inline_function): Handle CONCAT DECL_RESULT.

2001-05-23  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpp.texi: Update for handling of charconsts.
	* cpplex.c (maybe_read_ucs): Don't accept D800-DFFF.  Update
	diagnostics.  Skip to the end if the UCS is too short.
	(cpp_interpret_charconst): Long charconsts issue a warning
	not an error.

2001-05-23  Richard Henderson  <rth@redhat.com>

	* doc/install.texi (alpha-linux): Require binutils 2.11.

2001-05-23  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.c (read_escape, read_ucs): Delete.
	(lex_string): Use cpp_parse_escape.
	* cpplex.c (read_ucs): Rename maybe_read_ucs.  Do nothing
	if not C++ or not C99.  Warn if traditional.
	(parse_escape): Rename cpp_parse_escape.  Make the bitmask
	unsigned.  Warn for out-of-range escape sequences here.
	Update to use maybe_read_ucs.
	(cpp_interpret_charconst):  Don't warn here.
	* cpplib.h (cpp_parse_escape): New exported function.

2001-05-23  Joseph S. Myers  <jsm28@cam.ac.uk>

	* extend.texi (Attribute Syntax): Clarify application of
	attributes to parameters declared as functions or arrays.

2001-05-23  Jason Merrill  <jason_merrill@redhat.com>

	* dbxout.c (dbxout_type_methods): Do still group methods by name.

2001-05-23  Zack Weinberg  <zackw@stanford.edu>

	* diagnostic.c (vnotice): Kill.
	(fnotice): Call vfprintf directly.
	(diagnostic_for_decl, output_do_verbatim, output_verbatim,
	verbatim, set_diagnostic_context): Rename string argument to
	indicate that it is run through gettext.
	(vbuild_message_string, build_message_string, output_do_printf):
	Rename string argument to indicate that it is NOT run through
	gettext.
	(output_printf, diagnostic_for_decl, fatal_io_error, sorry,
	output_do_verbatim, set_diagnostic_context, fnotice, _fatal_insn):
	Run msgid argument through gettext.
	(default_print_error_function): Run constant strings through
	gettext when nothing else will.
	(fatal_error, internal_error, error_recursion): Use fnotice.
	Present complete sentences to gettext.

2001-05-23  Mark Mitchell  <mark@codesourcery.com>

	* jump.c (mark_jump_label): Fix thinko in 2001-05-19 change.

2001-05-23  Richard Henderson  <rth@redhat.com>

	* function.c (expand_function_start): Always use a pseudo
	for the function result value.

2001-05-22  Richard Henderson  <rth@redhat.com>

	* config/mips/iris6.h (EH_FRAME_SECTION_ASM_OP): Give the
	section pointer alignment.

	* doc/install.texi (alpha-linux): Require binutils >= 2.10.

	* unwind-dw2-fde.c (__deregister_frame_info): Stringize use
	of __USER_LABEL_PREFIX__.

2001-05-22  Richard Henderson  <rth@redhat.com>

	* unwind-dw2-fde.c (__deregister_frame_info): Stubbify in favour of...
	(__deregister_frame_info_bases): New.
	* unwind-dw2-fde.h: Declare it.
	* libgcc-std.ver: Export it.
	* crtstuff.c (__do_global_dtors_aux): Call it if we would have
	called __register_frame_info_bases.

2001-05-22  Loren J. Rittle  <ljrittle@acm.org>

	* config/freebsd.h (FBSD_CPP_PREDEFINES): Use #endif/#if pair
	instead of #elif (which is OK for this case but not in general).

2001-05-22  Andrew MacLeod  <amacleod@redhat.com>

	* builtins.c (expand_builtin_longjmp): A longjmp can be a call too.
	* config/ia64/ia64.md (nonlocal_goto): Reverse label and frame pointer
	parameters to __ia64_nonlocal_goto. Flag as NO_RETURN.
	* config/ia64/ia64.c (ia64_expand_epilogue): Make sure we are issuing
	"r2" to the assembly file. Only issue allocs with non-zero parameters.

2001-05-22  Loren J. Rittle  <ljrittle@acm.org>
	    David O'Brien  <obrien@freebsd.org>

	* config/freebsd.h (LIB_SPEC): Key the exact setting to
	configure-time options and target version of FreeBSD.  Set-up
	to match architectural change in threading support.  Correctly
	report when -pthread option is not supported by configure-time
	options.
	(FBSD_CPP_PREDEFINES): Move from architecture-specific files
	and extend to encode target version number in run-time setting
	of __FreeBSD__ macro to match the system compiler.
	(CPP_PREDEFINES): Likewise.
	(PREFERRED_DEBUGGING_TYPE): Change to DWARF2_DEBUG.

	* config/alpha/freebsd.h (CPP_PREDEFINES): Moved to common freebsd.h.
	* config/i386/freebsd.h (CPP_PREDEFINES): Likewise.

2001-05-22  Loren J. Rittle  <ljrittle@acm.org>
	    David O'Brien  <obrien@freebsd.org>

	* config.gcc (the unlabeled system switch statement): Add
	generic configuration section to handle *-*-freebsd*.  Also,
	to match the system compiler, default to threading support (it
	may be disabled with the standard --disable-threads
	configuration-time switch).
	(i[34567]86-*-freebsd* in machine-specific section): Use it.
	(alpha*-*-freebsd* in machine-specific section): Likewise.

	* config/freebsd3.h: New file to expose FBSD_MAJOR macro (3).
	* config/freebsd4.h: New file to expose FBSD_MAJOR macro (4).
	* config/freebsd5.h: New file to expose FBSD_MAJOR macro (5).
	* config/freebsd6.h: New file to expose FBSD_MAJOR macro (6).
	* config/freebsd-nthr.h: New file to expose FBSD_NO_THREADS macro.

2001-05-22  Loren J. Rittle  <ljrittle@acm.org>
	    David O'Brien  <obrien@freebsd.org>

	* config/t-freebsd (TARGET_LIBGCC2_CFLAGS): Add -fPIC.
	* config/t-freebsd-thread (TARGET_LIBGCC2_CFLAGS): Add
	-pthread instead setting macro.

2001-05-22  Richard Henderson  <rth@redhat.com>

	* crtstuff.c (__register_frame_info_bases): Declare.
	(frame_dummy): Use it, if CRT_GET_RFIB_TEXT or CRT_GET_RFIB_DATA.
	(__do_global_dtors_aux, __do_global_dtors): Streamline.

	* config/i386/linux.h (ASM_MAYBE_OUTPUT_ENCODED_ADDR_RTX): New.
	(CRT_GET_RFIB_DATA): New.
	* config/i386/sysv4.h: Likewise.
	* config/i386/sco5.h: Likewise.
	(ASM_PREFERRED_EH_DATA_FORMAT): New.

2001-05-22  Richard Henderson  <rth@redhat.com>

	* rtl.c (read_string): Break out from ...
	(read_rtx): ... here.

2001-05-22  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Specific): Remove a bogus and duplicate part
	copied from the end of the document.

2001-05-22  Bernd Schmidt  <bernds@redhat.com>

	* Makefile.in (LIBGCC_DEPS): Correct LIB1ASMSRC dependency.

2001-05-22  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* install.texi: Remove obsolete information on SunOS as well as
	i386-sun-sunos4, i860-intel-osf1, and powerpcle-*-solaris2*.
	(Installing GNU CC on the Sun): Remove section.

2001-05-22  Alexandre Oliva  <aoliva@redhat.com>

	* cppfiles.c (remove_component_p): Don't assume lstat/stat will
	keep errno unchanged on success.

2001-05-22  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-lex.c (lex_number): If pedantic and not C99, pedwarn exactly
	once for hexadecimal floats, whether or not they contain a decimal
	point.  Don't let the setting of pedantic otherwise affect the
	parsing of hexadecimal floats.

2001-05-22  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* README.ACORN: Remove obsolete file.

2001-05-22  Jan Hubicka  <jh@suse.cz>

	* combine.c (gen_binary): Use swap_commutative_operands_p
	(simplify_comparison): Likewise.
	* expmed.c (emit_store_flag): Likewise.
	* expr.c (compare_from_rtx): Likewise.
	(do_compare_rtx_and_jump): Likewise.
	* optabs.c (emit_cmp_and_jump_insn): Revert last patch; abort
	if not emitting a branch and operands want swapping.

2001-05-22  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.c (c_lex): Just cast cpp's hashnode to gcc's one.
	* stringpool.c:	(IS_FE_IDENT, make_identifier): Delete.
	(maybe_get_identifier): Update.
	* tree.h (make_identifier): Delete.

2001-05-21  Richard Henderson  <rth@redhat.com>

	* combine.c (subst): Do not substitute for a register as
	a destination subreg/strict_low_part/zero_extract.

	* combine.c (simplify_comparison): Update op1 after constant
	extension.
	* recog.c (const_int_operand): Accept only constants valid
	for the given mode.
	* genrecog.c: Update comments wrt const_int_operand.

	* emit-rtl.c (init_emit_once): Zero unused memory in a
	CONST_DOUBLE.

2001-05-21  Mark Mitchell  <mark@codesourcery.com>

	* tree.h (type_num_arguments): Declare it.
	* tree.c (type_num_arguments): New function.

2001-05-21  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (current_funcdef_number): Move outside dwarf2
	conditional ifdef.

2001-05-21  Geoff Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.md (maxsf3): Use rs6000_emit_minmax.
	(maxsf3+1): Delete.
	(minsf3): Use rs6000_emit_minmax.
	(minsf3+1): Generalize to handle both SMIN and SMAX.  Use
	rs6000_emit_minmax.
	(movsfcc): Use rs6000_emit_cmove.
	(fselsfsf4): Don't compare a CONST_INT with a floating-point value.
	Don't generate emit_fselsfsf4.
	(fseldfsf4): Likewise.
	(maxdf3): Use rs6000_emit_minmax.
	(maxdf3+1): Delete.
	(mindf3): Use rs6000_emit_minmax.
	(mindf3+1): Generalize to handle both SMIN and SMAX.  Use
	rs6000_emit_minmax.
	(movdfcc): Use rs6000_emit_cmove.
	(fseldfdf4): Don't compare a CONST_INT with a floating-point value.
	Don't generate emit_fselsfsf4.
	(fselsfdf4): Likewise.
	* config/rs6000/rs6000.c (zero_fp_constant): New predicate.
	(min_max_operator): New predicate.
	(rs6000_emit_cmove): New function.
	(rs6000_emit_minmax): New function.
	* config/rs6000/rs6000-protos.h: Prototype new functions.
	* config/rs6000/rs6000.h (PREDICATE_CODES): Add zero_fp_constant
	and min_max_operator.

	* config/rs6000/rs6000.c (output_cbranch): Handle all
	conditional types in the switch statement.

2001-05-21  Mark Mitchell  <mark@codesourcery.com>

	* c-decl.c (finish_decl): Don't set DECL_C_HARD_REGISTER for
	non-register variables.
	* extend.texi: Document that asm-specifications do not make sense
	for non-static local variables.

2001-05-21  Jason Merrill  <jason_merrill@redhat.com>

	* dbxout.c (MINIMAL_DEBUG, flag_minimal_debug): Lose.
	(dbxout_type_fields): Lose minimal_debug support.
	(dbxout_type_methods, dbxout_type): Likewise.

2001-05-17  Andrew Haley  <aph@redhat.com>

	* config/rs6000/linux.h (MD_FALLBACK_FRAME_STATE_FOR): New.

2001-05-21  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (DEBUG_FRAME_SECTION): Rename from FRAME_SECTION.
	Update all users.

2001-05-20  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (DEBUG_ABBREV_SECTION, DEBUG_ARANGES_SECTION,
	DEBUG_MACINFO_SECTION, DEBUG_LOC_SECTION, DEBUG_PUBNAMES_SECTION,
	DEBUG_STR_SECTION): Rename from s/DEBUG_//.  Update all users.
	* dwarfout.c (DEBUG_SFNAMES_SECTION, DEBUG_SRCINFO_SECTION,
	DEBUG_MACINFO_SECTION, DEBUG_PUBNAMES_SECTION, DEBUG_ARANGES_SECTION):
	Likewise.
	* config/mips/iris6.h (DEBUG_SFNAMES_SECTION, DEBUG_SRCINFO_SECTION,
	DEBUG_MACINFO_SECTION, DEBUG_PUBNAMES_SECTION, DEBUG_ARANGES_SECTION,
	DEBUG_FRAME_SECTION, DEBUG_ABBREV_SECTION): Rename as above.
	(DEBUG_LOC_SECTION, DEBUG_STR_SECTION): New.
	* config/ia64/ia64.h (DEBUG_ABBREV_SECTION, DEBUG_ARANGES_SECTION,
	DEBUG_PUBNAMES_SECTION): Rename as above.
	(DEBUG_MACINFO_SECTION, DEBUG_LOC_SECTION, DEBUG_STR_SECTION): New.

2001-05-20  Richard Henderson  <rth@redhat.com>

	* optabs.c (emit_cmp_and_jump_insns): Don't swap commutative
	operands unless the operation is commutative.

2001-05-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fold-const.c (tree_expr_nonnegative_p): Detect more non-negative
	cases.

2001-05-21  Joseph S. Myers  <jsm28@cam.ac.uk>

	* extend.texi: Clarify documentation of extensions included in ISO
	C99.  Prefer C99 terminology and syntax to old GNU terminology and
	syntax.  Add more index entries.  Document mixed declarations and
	code as an extension in C89 mode.  Warn about future changes to
	semantics of inline functions.  Fixes PR other/930.

Sun May 20 16:39:24 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_expr, case ARRAY_REF): Don't fold constant
	access if EXPAND_CONST_ADDRESS or EXPAND_INITIALIZER.
	(expand_expr, case COMPONENT_REF): Do copy if misaligned even
	if EXPAND_CONST_ADDRESS or EXPAND_INITIALIZER.

	* stmt.c (expand_decl): Set mode, alignment, and sizes for CONST_DECL.

2001-05-20  Richard Henderson  <rth@redhat.com>

	* sched-deps.c (sched_analyze_insn): Force volatile memory reads
	to be output before a branch.

2001-05-20  Richard Henderson  <rth@redhat.com>

	* Makefile.in (dwarf2asm.o): Depend on $(TREE_H).

2001-05-20  Richard Henderson  <rth@redhat.com>

	* config/i386/att.h (ASM_SHORT, ASM_LONG): Add trailing \t.
	(ASM_DOUBLE): Remove.
	* config/i386/bsd.h, config/i386/sco5.h: Likewise.
	* config/i386/sun386.h: Likewise.

	* config/i386/i386.h (UNALIGNED_SHORT_ASM_OP): New.
	(UNALIGNED_INT_ASM_OP, INT_ASM_OP): New.

	* config/i386/cygwin.h (INT_ASM_OP): Remove.
	* config/i386/freebsd-aout.h, config/i386/i386-aout.h: Likewise.
	* config/i386/i386-coff.h, config/i386/i386-interix.h: Likewise.
	* config/i386/netbsd.h, config/i386/openbsd.h: Likewise.

	* config/i386/cygwin.h: Adjust uses of ASM_LONG for trailing \t.
	* config/i386/djgpp.h, config/i386/i386.h: Likewise.
	* config/i386/i386elf.h, config/i386/ptx4-i.h: Likewise.
	* config/i386/sco5.h, config/i386/svr3gas.h: Likewise.
	* config/i386/sysv4.h, config/i386/vsta.h: Likewise.
	* config/i386/win32.h: Likewise.

2001-05-20  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Add more options to summary list.

2001-05-20  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Document meaning of -pedantic when -std=gnu* is
	used.  Fixes PR c/2291.
	* gcc.1: Regenerate.

2001-05-20  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.c (m68hc11_override_options): Ignore
	the -fpic and -fPIC options, clear flag_pic.

2001-05-20  Neil Booth  <neil@daikokuya.demon.co.uk>

	* hashtable.c (calc_hash): Fix HASHSTEP definition.
	* stringpool.c (make_identifier): No statistics here anymore.
	* objc-act.c (steup_string_decl): Remove redundant check.

2001-05-20  Neil Booth  <neil@daikokuya.demon.co.uk>

	* Makefile.in (OBJS, LIBCPP_OBJS, LIBCPP_DEPS,
	cpplib.o, cpphash.o, fix-header): Update.
	(hashtable.o): New target.
	* c-common.h: Include cpplib.h.  Define C_RID_CODE and
	struct c_common_identifier here.
	* c-lang.c (c_init_options): Update.  Call set_identifier_size.
	* c-lex.c (c_lex): Update.
	* c-pragma.h: Update.
	* c-tree.h (struct lang_identifier): Contain c_common_identifier.
	Delete rid_code.
	(C_RID_CODE): Delete.
	* cpphash.c: Rewrite to use hashtable.c.
	* cpphash.h: Update include guards.
	(struct cpp_reader): Remove hashtab.
	hash_ob and buffer_ob are no longer pointers.  Add hash_table
	and our_hashtable.
	(HASHSTEP, _cpp_init_hashtable,	_cpp_lookup_with_hash): Delete.
	(_cpp_cleanup_hashtable): Rename _cpp_destroy_hashtable.
	(_cpp_cleanup_stacks): Rename _cpp_init_directives.
	* cppinit.c (cpp_create_reader): Update.
	* cpplex.c (cpp_ideq, parse_identifier, cpp_output_token): Update.
	(cpp_interpret_charconst): Eliminate warning.
	* cpplib.c (do_pragma, do_endif, push_conditional,
	cpp_push_buffer, cpp_pop_buffer): Update.
	(_cpp_init_stacks): Rename cpp_init_directives.
	(_cpp_cleanup_stacks): Remove.
	* cpplib.h: Update include guards.  Include tree-core.h and c-rid.h.
	(cpp_hashnode, cpp_token, NODE_LEN, NODE_NAME,
	 cpp_forall_identifiers, cpp_create_reader): Update.
	(C_RID_CODE, cpp_make_node): New.
	(c_common_identifier): New identifier node for C front ends.
	* cppmain.c (main): Update.
	* fix-header.c (read_scan_file): Update.
	* flags.h (id_clash_len): Make unsigned.
	* ggc.h (ggc_mark_nonnull_tree): New.
	* hashtable.c: New.
	* hashtable.h: New.
	* stringpool.c: Update comments and copyright.  Update to use
	hashtable.c.
	* toplev.c (approx_sqrt): Move to hashtable.c.
	(id_clash_len): Make unsigned.
	* toplev.h (ident_hash): New.
	* tree.c (gcc_obstack_init): Move to hashtable.c.
	* tree.h: Include hashtable.h.
	(IDENTIFIER_POINTER, IDENTIFIER_LENGTH): Update.
	(GCC_IDENT_TO_HT_IDENT, HT_IDENT_TO_GCC_IDENT): New.
	(struct tree_identifier): Update.
	(make_identifier): New.
cp:
	* cp-tree.h (struct lang_identifier, C_RID_YYCODE): Update.
	(C_RID_CODE): Remove.
	* lex.c (cxx_init_options): Call set_identifier_size.  Update.
	(init_parse): Don't do it here.
objc:
	* objc-act.c (objc_init_options): Call set_identifier_size. Update.

Sat May 19 18:23:04 2001  Richard Henderson <rth@redhat.com>

	* except.c (dw2_build_landing_pads): Use word_mode, not Pmode,
	as ncessary.
	(expand_eh_return): Convert between word_mode and Pmode.
	* unwind-dw2.c (extract_cie_info): Do not assume words and pointers
	are the same size.
	(execute_stack_op): Likewise.
	(execute_cfa_program): Likewise.
	(uw_frame_state_for): Likewise.
	(uw_update_context_1): Likewise.
	* unwind.inc (_Unwind_Reason_Code): Likewise.
	* config/mips/mips.h (EH_RETURN_DATA_REGNO): Define.
	(EH_RETURN_STACKADJ_RTX): Likewise.
	* config/mips/mips.c (compute_frame_size): Make space for saving
	EH return registers.
	(mips_expand_epilogue): Handle EH stack adjustments.
	* config/mips/mips.md (eh_return): New pattern.
	(eh_set_lr_si): Likewise.
	(eh_set_lr_di): Likewise.
	Add splitter to perform EH return after reload.

2001-05-19  Mark Mitchell  <mark@codesourcery.com>

	* jump.c (mark_jump_label): Tidy previous change.

2001-05-19  Bruce Korb  <bkorb@gnu.org>

	* fixinc/genfixes: no need for two warnings
	* fixinc/Makefile.in: open stdin for those building with a closed one.

2001-05-19  Mark Mitchell  <mark@codesourcery.com>

	* jump.c (jump_optimize_1): Tidy.
	(mark_jump_label): When changing the label in a LABEL_REF, change
	update any REG_EQUAL notes as well.

2001-05-19  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-parse.in (parm_declarator): Split into
	parm_declarator_starttypename and parm_declarator_nostarttypename.
	(parm_declarator_starttypename, parm_declarator_nostarttypename):
	New.  Allow parenthesised sub-declarators which don't begin with a
	TYPENAME.  Fixes PR c/166.

2001-05-19  Mark Mitchell  <mark@codesourcery.com>

	* defaults.h (TARGET_ALLOWS_PROFILING_WITHOUT_FRAME_POINTER): New
	macro.
	* tm.texi (TARGET_ALLOWS_PROFILING_WITHOUT_FRAME_POINTER):
	Document it.
	* toplev.c (main): If the target does not allow profiling without
	a frame pointer, issue an error message.
	* config/i386/linux.h (TARGET_ALLOWS_PROFILING_WITHOUT_FRAME_POINTER):
	Define it to false.

Sat May 19 07:53:42 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* recog.c (general_operand): Modify last change to allow it if reload
	has completed.

Sat May 19 10:23:54 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* recog.c (general_operand): Prohibit nonzero subreg bytes on
	subregs containing mem.

Sat May 19 09:40:45 2001  Denis Chertykov  <denisc@overta.ru>

	* regrename.c (regrename_optimize): frame pointer register can
	use a few hardregs.

2001-05-18  Jason Merrill  <jason_merrill@redhat.com>

	* README.DWARF: Move into dwarfout.c.

2001-05-18  Dale Johannesen  <dalej@apple.com>

	* config/rs6000/rs6000.c (secondary_reload_class): Fix Darwin
	specific misuse of r0 as a reload address.

Fri May 18 22:42:04 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* combine.c (combine_simplify_rtx): Clear op0_mode if simplification
	succeeded.

Fri May 18 07:26:34 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* genrecog.c (enum decision_type): Add DT_elt_zero-wide_safe.
	(add_to_sequence): Make that decision type.
	(maybe_both_true_2, nodes_identical_1, factor_tests): Use it.
	(write_switch, write_cond, debug_decision_2): Likewise.

	* dbxout.c (dbxout_type): Use host_integerp and fix typo in testing
	for INTEGER_TYPE.
	(dbxout_symbol, case TYPE_DECL): Don't generate tag for records of
	variable size.

2001-05-18  Stan Shebs  <shebs@apple.com>

	* configure.in (gcc_cv_as_eh_frame): Cope with old assemblers.
	* configure: Regenerate.

2001-05-18  Per Bothner  <per@bothner.com>

	Changes needed for java/jvspec.c
	* gcc.h (n_infiles, outfiles):  Add declarations.
	* gcc.c (n_infiles, outfiles):  Mske no longer static.

Fri May 18 10:14:42 2001  Jeffrey A Law  (law@cygnus.com)

	* config/pa/som.h (EXCEPTION_SECTION): Define.

2001-05-18  Daniel Berlin  <dan@cgsoftware.com>

	* dwarf2out.c: Add dw_loc_list_ref, a reference to a location
	list.
	Add have_location_lists, a variable to determine whether we need a
	.debug_loc section or not.
	(enum dw_val_class): Add dw_val_class_loc_list.
	(dw_val_struct): Add val_loc_list.
	(dw_loc_list_struct): New structure, represents location lists.
	(new_loc_list): New function, return a new location list, given
	the range and location expression.
	(add_loc_descr_to_loc_list): New function, add a location
	expression to a location list, given the expression and range.
	(output_loc_list): New function, output a location list.
	(gen_internal_sym): Modified to take symbol prefix, so we can
	reuse it for location list symbols.
	(add_AT_loc_list): New function, add a location list to a DIE at
	the named attribute.
	(AT_loc_list): New function, return the location list reference
	for a given attribute, if it's a location list.
	(print_die): Handle dw_val_class_loc_list.
	(size_of_die): Ditto.
	(value_format): Ditto.
	(output_die): Ditto.
	(output_location_lists): New function, output all of the location
	lists for a DIE and it's children.
	(dwarf2out_finish): Call output_location_lists if we have location
	lists.


Fri May 18 15:39:16 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* gcse.c (try_replace_reg): First try global replace, later try to
	simplify the expression.

	* gcse.c (find_used_regs): Change calling convention; work via
	note_uses.
	(cprop_insn): Update call of find_used_regs; work for CALL_INSNs too.

2001-05-18  Bernd Schmidt  <bernds@redhat.com>

	Revert
	2001-02-09  Nick Clifton  <nickc@redhat.com>
	* config/arm/arm.md: Change output constraint on post inc
	load/store multiple patterns to be a read/write constraint.

2001-05-18  Mark Mitchell  <mark@codesourcery.com>

	* basic-block.h (struct basic_block_def): Add documentation about
	what a basic block is, and what the various fields are used for.
	* flow.c (calculate_globlal_regs_live): Add documentation about
	how the algorithm works, and how we know that it will terminate.
	Check that the the inductive assumption that guarantees
	termination actually holds.
	(mark_used_regs): Treat conditionally set registers as used.
	(debug_regset): Add comment.
	* rtl.texi (cond_exec): Add documentation.

	* function.c (expand_function_start): Avoid creating BLKmode
	pseudos.

2001-05-17  Mark Mitchell  <mark@codesourcery.com>

	* dwarf2out.c (output_comp_unit): Always output a compilation-unit
	DIE, even if it has no children.
	(dwarf2out_finish): Always output the line-number table, even if
	it has no content.

2001-05-18  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (movsfcc,movdfcc): Remove NE case.

2001-05-17  Bruce Korb <bkorb@gnu.org>

	* fixinc/fixincl.tpl: rewritten as an AutoGen version 5 template
	* fixinc/genfixes: emit a warning if AutoGen is out of date

2001-05-17  Brendan Conoboy <blc@cygnus.com>
	    Bruce Korb <bkorb@gnu.org>

	* fixinc/fixincl.sh(FIXINC): accept local directory if fixincl not
	found in fixinc directory.  Facilitates binary distributions.

2001-05-17  Jeffrey Oldham  <oldham@codesourcery.com>

	* dbxout.c (dbxout_symbol_location): For CONCAT, skip types not
	COMPLEX_TYPE.

Thu May 17 19:42:39 2001  Mark Kettenis  <kettenis@wins.uva.nl>

	* dwarf2out.c (modified_type_die): Equate qualified type to die.

Thu May 17 23:19:46 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* integrate.c (copy_rtx_and_substitute): Use simplify_gen_subreg.
	(simplify_subreg): Handle complex types represented as CONCAT.

	* recog.c (validate_replace_rtx_1): Properly canonicalize expression
	* rtl.h (swap_commutative_operands_p): Declare.
	* rtlanal.c (swap_commutative_operands_p): New.
	(operand_preference): New static function.

	* combine.c (combine_simplify_rtx): Use swap_commutative_operands_p.
	(gen_binary): Likewise.
	* optabs.c (emit_cmp_and_jump_insns, emit_conditional_move): Likewise.
	* simplify-rtx.c (simplify_gen_binary,
	simplify_gen_relational): Likewise.

Thu May 17 20:43:36 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* cse.c (fold_rtx): Use simplify_subreg.

	* simplify-rtx.c (simplify_replace_rtx): Use simplify_gen_subreg.
	(simplify_gen_subreg): New.
	(simplify_rtx): Use simplify_subreg.
	* rtl.h (simplify_gen_subreg): Declare.

2001-05-17  Mark Mitchell  <mark@codesourcery.com>

	* doc/install.texi: Update Solaris information.

	* except.h (protect_cleanup_actions): Remove it.
	(lang_protect_cleanup_actions): Declare it.
	* except.c (protect_cleanup_actions): Remove it.
	(lang_protect_cleanup_actions): New variable.
	(init_eh): Don't make protect_cleanup_actions a GC root.
	(expand_eh_region_and_cleanup): Call
	lang_protect_cleanup_actions.
	(output_function_exception_table): Remove unused `align'
	variable.
	* varasm.c (assemble_external): Abort if we have not yet
	opened the assembly output file.

Thu May 17 11:54:50 2001  Jeffrey A Law  (law@cygnus.com)

	* except.c (sjlj_emit_function_enter): Call assemble_external_libcall
	for eh_personality_libfunc.

Thu May 17 19:48:00 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* recog.c (validate_replace_rtx_1): Use "TO" mode if not VOIDmode
	when calling simplify_subreg.  This is needed to allow replacing
	of expression of one mode by expression of different mode.

Thu May 17 19:40:03 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* simplify-rtx.c  (simplify_subreg): Avoid creating of incorrect subregs.

2001-05-17  Bernd Schmidt  <bernds@redhat.com>

	* expr.c (protect_from_queue): Protect against subsequent calls to
	emit_queue.
	(expand_expr, case ADDR_EXPR): Prevent protect_from_queue from being
	too clever.

Thu May 17 18:17:34 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* simplify_rtx.c (simplify_subreg): Fix simplification of nested subregs.

2001-05-17  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* gccbug.in (CATEGORIES): Add "bootstrap".

Thu May 17 16:59:41 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* simplify-rtx.c (simplify_subreg): Break out from ...
	* combine.c (combine_splify_rtx) ... here and ...
	* recog.c (validate_replace_rtx_1): ... here;
	* rtl.h (subreg_lowpart_parts_p, simplify_subreg): Declare.
	* emit-rtl.c (subreg_lowpart_parts_p): Break out from ...
	(subreg_lowpart_p): ... here.

2001-05-17  Bernd Schmidt  <bernds@redhat.com>

	* stmt.c (expand_asm_operands): For inout operands, make sure
	the substitution of '=' for '+' makes it into the rtl.

	* reload1.c (delete_output_reload): Call eliminate_regs on substed.
	(reload_as_needed): Call update_eliminable_offsets a bit later.

2001-05-17  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* gcc.texi (gccbug): Refer to the web pages for detailed information
	on GNATS.

2001-05-16  Zack Weinberg  <zackw@stanford.edu>

	* libgcc1-test.c, libgcc1.c, config/i386/perform.h: Delete file.

	* Makefile.in: Delete variables: OLDCC, CCLIBFLAGS, OLDAR,
	OLDAR_FLAGS, LIBGCC1, LIBGCC1_TEST, CROSS_LIBGCC1,
	LIB1FUNCS, and LIB1FUNCS_EXTRA.  Delete rules: libgcc1-test,
	libgcc1-test.o.  Clarify commentary now that libgcc1 no longer exists.
	* cross-make: Don't set LIBGCC1.
	* mklibgcc.in: Delete all code for building from libgcc1.c.
	Always honor LIB1ASMFUNCS if set.

	* crtstuff.c, floatlib.c, longlong.h, config/fp-bit.c,
	config/arc/lib1funcs.asm, config/arm/lib1funcs.asm,
	config/d30v/libgcc1.asm, config/fr30/lib1funcs.asm,
	config/h8300/lib1funcs.asm, config/i386/cygwin.asm,
	config/i386/uwin.asm, config/m68hc11/larith.asm,
	config/m68k/lb1sf68.asm, config/mcore/lib1.asm,
	config/mn10200/lib1funcs.asm, config/sh/lib1funcs.asm,
	config/sparc/lb1spc.asm, config/sparc/lb1spl.asm,
	config/v850/lib1funcs.asm, config/c4x/libgcc.S:
	Delete or update references to libgcc1 in commentary.

	* config/t-libc-ok, config/t-linux, config/t-linux-aout,
	config/t-netbsd, config/a29k/t-a29kbare, config/a29k/t-vx29k,
	config/alpha/t-interix, config/alpha/t-osf, config/alpha/t-vms,
	config/arc/t-arc, config/arm/t-arm-aout, config/arm/t-arm-coff,
	config/arm/t-arm-elf, config/arm/t-linux, config/arm/t-pe,
	config/arm/t-semi, config/arm/t-strongarm-coff,
	config/arm/t-strongarm-elf, config/arm/t-strongarm-pe,
	config/arm/t-xscale-coff, config/arm/t-xscale-elf, config/avr/t-avr,
	config/c4x/t-c4x, config/d30v/t-d30v, config/fr30/t-fr30,
	config/h8300/t-h8300, config/i386/t-beos, config/i386/t-cygwin,
	config/i386/t-i386elf, config/i386/t-interix, config/i386/t-netware,
	config/i386/t-next, config/i386/t-rtems-i386, config/i386/t-sol2,
	config/i960/t-960bare, config/i960/t-vxworks960, config/ia64/t-ia64,
	config/m32r/t-m32r, config/m68hc11/t-m68hc11-gas, config/m68k/t-lynx,
	config/m68k/t-m68kbare, config/m68k/t-m68kelf,
	config/m68k/t-mot3300-gald, config/m68k/t-mot3300-gas,
	config/m68k/t-next, config/m68k/t-vxworks68, config/m88k/t-bug,
	config/m88k/t-dgux, config/m88k/t-dgux-gas, config/m88k/t-dguxbcs,
	config/m88k/t-luna, config/m88k/t-luna-gas, config/m88k/t-m88k,
	config/m88k/t-m88k-gas, config/m88k/t-sysv4, config/mcore/t-mcore,
	config/mcore/t-mcore-pe, config/mips/t-bsd, config/mips/t-bsd-gas,
	config/mips/t-cross64, config/mips/t-ecoff, config/mips/t-elf,
	config/mips/t-iris6, config/mips/t-r3900, config/mips/t-svr3,
	config/mips/t-svr3-gas, config/mips/t-svr4, config/mips/t-svr4-gas,
	config/mips/t-ultrix, config/mn10200/t-mn10200,
	config/mn10300/t-mn10300, config/pa/t-linux, config/pa/t-linux64,
	config/pa/t-pa, config/pa/t-pa64, config/pa/t-pro,
	config/pdp11/t-pdp11, config/pj/t-pj, config/rs6000/t-aix43,
	config/rs6000/t-beos, config/rs6000/t-darwin, config/rs6000/t-newas,
	config/rs6000/t-ppccomm, config/rs6000/t-rs6000, config/sh/t-linux,
	config/sh/t-sh, config/sparc/t-chorus-elf, config/sparc/t-elf,
	config/sparc/t-sol2, config/sparc/t-sp86x, config/sparc/t-sparcbare,
	config/sparc/t-sparclite, config/sparc/t-splet,
	config/sparc/t-sunos41, config/sparc/t-vxsparc,
	config/sparc/t-vxsparc64, config/v850/t-v850:
	Don't set any of LIBGCC1, CROSS_LIBGCC1, or LIBGCC1_TEST.

	* config/alpha/alpha.h, config/i386/i386.h, config/i860/i860.h:
	Don't set FLOAT_VALUE_TYPE, FLOAT_ARG_TYPE, INTIFY, or FLOATIFY.
	* config/d30v/d30v.h: Don't mention LIBGCC_NEEDS_DOUBLE,
	FLOAT_VALUE_TYPE, FLOAT_ARG_TYPE, FLOATIFY, INTIFY,
	nongcc_SI_type, nongcc_word_type, or perform_*
	* config/i860/fx2800: Don't define perform_umodsi3 or perform_modsi3.

	* config/i386/386bsd.h, config/i386/beos-elf.h,
	config/i386/linux-aout.h, config/i386/linux-oldld.h,
	config/i386/linux.h, config/i386/mach.h, config/i386/netbsd.h,
	config/i386/openbsd.h, config/i386/osfrose.h, config/i386/rtemself.h:
	Don't include i386/perform.h.

	* config/a29k/t-a29k, config/arm/t-semiaof, config/i370/t-i370,
	config/i370/t-linux, config/i370/t-mvs, config/i370/t-oe,
	config/i386/t-djgpp, config/i386/t-i386bare, config/i386/t-vsta,
	config/ia64/t-hpux, config/mips/t-mips, config/mips/t-mips-gas,
	config/mips/t-osfrose, config/sparc/t-sp64, config/sparc/t-sunos40,
	config/vax/t-openbsd, config/vax/t-vax: Delete.

	* config.gcc: Remove references to deleted files.
	(arm-semi-aof): Use arm/t-semi for tmake_file.

	* gcc.texi, install.texi, invoke.texi, tm.texi:
	Delete or rewrite text which is no longer relevant now that
	libgcc1 no longer exists.

	* config/t-openbsd, config/alpha/t-interix, config/i386/t-interix:
	No need to set INSTALL_ASSERT_H.  (Missed in previous sweep.)

2001-05-16  Wolfgang Bangerth <wolfgang.bangerth@iwr.uni-heidelberg.de>
	Bruce Korb <bkorb@gnu.org>

	* fixinc/inclhack.def(solaris27_mutex_init):  Fix broken mutex
	initializer

2001-05-16  Zack Weinberg  <zackw@stanford.edu>

	* i386.md: Add two peepholes to clean up code generated by
	cmpstr* expanders.

2001-05-16  Richard Henderson  <rth@redhat.com>

	* dwarf2asm.c (eh_data_format_name): Add names for "pointer size"
	variants of non-absolute encodings.

	* config/i386/i386.h (ASM_PREFERRED_EH_DATA_FORMAT): New.

	* libgcc-std.ver (_Unwind_Find_FDE, __register_frame_info_bases,
	__register_frame_info_table_bases): Export.

2001-05-16  Richard Henderson  <rth@redhat.com>

	* except.c (eh_data_format_name): Move to ...
	* dwarf2asm.c: ... here.  Use designated initializers if available.
	(dw2_asm_output_encoded_addr_rtx): Accept varargs commentary.
	* dwarf2asm.h: Update declarations.
	* dwarf2out.c (output_cfi) [DW_CFA_set_loc]: If for_eh, mind
	ASM_PREFERRED_EH_DATA_FORMAT.
	(output_call_frame_info): Likewise.  Use 'L' augmentation for
	the LSDA encoding.

	* unwind-dw2-fde.h (struct fde_vector): New.
	(struct old_object): Rename from struct object.
	(struct object): New.
	(__register_frame_info_bases): Declare.
	(__register_frame_info_table_bases): Declare.
	(struct dwarf_fde): Remove explicit pc_begin/pc_range members.
	* unwind-dw2-fde.c (objects): Remove.
	(unseen_objects, seen_objects): New.
	(__register_frame_info_bases): New.
	(__register_frame_info): Use it.
	(__register_frame_info_table_bases): New.
	(__register_frame_info_table): Use it.
	(__deregister_frame_info): Rewrite for changed object struct.
	(base_from_object, get_cie_encoding, get_fde_encoding): New.
	(fde_unencoded_compare): Rename from fde_compare; uninline.
	(fde_single_encoding_compare, fde_mixed_encoding_compare): New.
	(start_fde_sort): Adjust for new definition of fde_vector.
	(fde_insert): Likewise.
	(end_fde_sort): Likewise.  Select comparison function based
	on properties of the object.
	(fde_split): Take object and fde_compare_t arguments.
	(frame_heapsort, fde_merge): Likewise.
	(classify_object_over_fdes): Rename from count_fdes.  Handle
	encoded pointers.  Collect encoding, mixed_encoding, and pc_begin
	for the object.
	(add_fdes): Handle encoded pointers.
	(init_object): Rename from frame_init.  Update for new struct object.
	(linear_search_fdes): Rename from search_fdes.  Handle encoded
	pointers.
	(binary_search_unencoded_fdes): Broken out from _Unwind_Find_FDE.
	(binary_search_single_encoding_fdes): New.
	(binary_search_mixed_encoding_fdes): New.
	(search_object): New.
	(_Unwind_Find_FDE): Update for new struct object.  Fill in
	the dwarf_eh_bases.
	* unwind-dw2.c: Include unwind-pe.h.  Constify all pointers
	iterating over EH data.
	(_Unwind_FrameState): Remove saw_lsda, addr_encoding.  Add
	fde_encoding, lsda_encoding.
	(read_uleb128, read_sleb128): Remove.
	(read_encoded_pointer): Remove.  All callers use read_encoded_value.
	(extract_cie_info): Set lsda_encoding from 'L' augmentation.
	(uw_frame_state_for): Don't set bases.func.  Handle encoded fde
	pointers.
	* unwind-pe.h: Add "struct" to _Unwind_Context references.

2001-05-16  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* cppexp.c (lex): Use NODE_NAME and NODE_LEN.
	* cpphash.c (_cpp_lookup_with_hash): Similarly.
	* cpplex.c (cpp_ideq, parse_identifier, cpp_token_len,
	cpp_spell_token, cpp_output_token): Similarly.
	* cpplib.c (lex_macro_node, do_undef, do_pragma,
	do_pragma_poison, parse_assertion, do_assert): Similarly.
	* cppmacro.c (builtin_macro, parse_args, funlike_invocation_p,
	save_parameter, _cpp_create_definition, check_trad_stringification,
	cpp_macro_definition): Similarly.
	* cppmain.c (cb_define, cb_undef, dump_macro): Similarly.
	* c-lex.c (cb_undef, c_lex): Similarly.
	* fix-header.c (recognized_function): Similarly.
	* cpplib.h (NODE_LEN, NODE_NAME): New.
	(cpp_hashnode): Rename length len.

Wed May 16 13:41:10 2001  Jeffrey A Law  (law@cygnus.com)

	* pa32-regs.h (HARD_REGNO_MODE_OK): Allow TI/TFmode values in
	GPRs.

2001-05-16  Andreas Jaeger  <aj@suse.de>

	* Makefile.in (toplev.o): Add dependency on dwarf2asm.h.

	* toplev.c: Include dwarf2asm.h for prototype of
	dw2_output_indirect_constants.

Wed May 16 19:53:53 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* stmt.c (expand_asm_operands): Be able to offload addressof
	expression to memory. (PR optimization/185)

Wed May 16 18:53:23 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* combine.c (combine_simplify_rtx): Set op0_mode to VOIDmode after
	applying distributive law.

2001-05-16  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa-hpux10.h (THREAD_MODEL_SPEC): Define.

	* gthr-dce.h (UNUSED): Attribute unused macro.
	(__gthread_key_dtor): Make arguments UNUSED.
	(__gthread_key_delete): Revise for compatibility with DRAFT4
	implementation.

2001-05-16  David Edelsohn  <edelsohn@gnu.org>

	* doc/install.texi: Update AIX information.
	* README.RS6000: Remove obsolete file.

2001-05-16  Jakub Jelinek  <jakub@redhat.com>
	    Nathan Sidwell  <nathan@codesourcery.com>

	* gcc.c (give_switch): Don't write before start of string.
	Always append suffix.

2001-05-16  Nathan Sidwell  <nathan@codesourcery.com>

	* cpplex.c (_cpp_lex_token, '/' case): Comments can't appear
	after stage3.

2001-05-16  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* README.ALTOS: Remove obsolete file.

2001-05-16  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.h (save_and_forget_protocol_qualifiers,
	forget_protocol_qualifiers, remember_protocol_qualifiers):
	Remove deleted functions' prototypes.

2001-05-16  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-parse.in (methodtype): New production.
	(methoddef, methodproto): Collapse separate '-' and '+'
	handlers into 1.

2001-05-16  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* c-common.h (RID_FIRST_PQ): New.
	* c-parse.in (objc_pq_context): New.
	(objc parser): Set objc_pq_context rather than calling
	remember_protocol_qualifiers and forget_protocol_qualifiers.
	Don't call save_and_forget_protocol_qualifiers.
	(yylexname): Handle objc protocol qualifiers here.
	* stringpool.c (struct str_header): Replace with sp_hashnode.
	(SP_EMPTY, SP_LEN, SP_TREE, SP_STR, SP_VALID): New.
	(alloc_string): Rename alloc_ident.  Use the SP_ accessors.
	Allocate an IDENTIFIER_NODE for each identifier.
	(FORALL_STRINGS, set_identifier): Delete.
	(FORALL_IDS, expand_string_table, stringpool_statistics): Update.
	(ggc_alloc_string): Use an obstack.
	(get_identifier, maybe_get_identifier, mark_string_hash): Update.
	* tree.h: Update comments.
	(set_identifier): Delete.
	* objc/objc-act.c (N_PQ, saved_pq, saved_not_pq,
	save_and_forget_protocol_qualifiers, forget_protocol_qualifiers,
	remember_protocol_qualifiers): Delete.

Tue May 15 22:14:09 2001  Jeffrey A Law  (law@cygnus.com)

	* flow.c (life_analysis): After life analysis is complete, do
	an optional scan over insns looking for REG_LABEL notes that
	reference a deleted label.
	(propagate_block_delete_insn): Verify INOTE is a CODE_LABEL
	before peeking at LABEL_NUSES.

2001-05-15  Richard Henderson  <rth@redhat.com>

	* unwind-sjlj.c (_Unwind_GetDataRelBase): New.
	(_Unwind_GetTextRelBase): New.

2001-05-15  Mark Mitchell  <mark@codesourcery.com>

	* config/sparc/sol2.h (CPLUSPLUS_CPP_SPEC): Define.

2001-05-15  Geoffrey Keating  <geoffk@redhat.com>

	* objc/objc-act.c (handle_class_ref): Use rest_of_decl_compilation
	so that CHOOSE_SECTION gets used.

	* config/rs6000/sysv4.h (ASM_PREFERRED_EH_DATA_FORMAT): Treat
	TARGET_RELOCATABLE like flag_pic for now.

2001-05-15  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (movdi splitter): Sign extend more efficiently.
	* rs6000.c (reg_or_arith_cint_operand): Redefine 64-bit constant
	to "long long" valid on 32-bit and 64-bit hosts.
	(logical_operand): Cast trunc_int_for_mode return value.
	(rs6000_emit_move): Shift macro to encapsulate variable.
	(rs6000_va_start): Use HOST_WIDE_INT_PRINT_DEC.
	(rs6000_emit_{prologue,epilogue}): EH regno is unsigned but
	plus_constant requires signed argument.

2001-05-15  Loren J. Rittle  <ljrittle@acm.org>

	* gthr-posix.h: Make additional pthread-* functions weak.

Tue May 15 13:51:32 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* recog.c (apply_change_group): Avoid unneeded validating.

2001-05-14  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (num_insns_constant_wide): Constants are sign-extended.
	(num_insns_constant): CONST_INT can be 64-bits.

2001-05-14  Stan Shebs  <shebs@apple.com>

	* config/darwin.h (LIB_SPEC): Just use -lSystem.
	(LIBGCC_SPEC): Don't define.

2001-05-14  Richard Henderson  <rth@redhat.com>

	* configure.in (gcc_cv_as_eh_frame): New test.
	* config.in, configure: Rebuild.
	* gcc.c (init_spec): Honor USE_AS_TRADITIONAL_FORMAT.

2001-05-14  Andrew MacLeod  <amacleod@redhat.com>

	* config/ia64/lib1funcs.asm (__divtf3): Fix incorrect bits in
	extended precision divide.

2001-05-14  Andrew MacLeod  <amacleod@redhat.com>

	* config/ia64/ia64.c (rtx_needs_barrier): Call rtx_needs_barrier
	for RETURNS as well.

Mon May 14 17:34:48 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.h (TARGET_64BIT): Define to constant if !TARGET_BI_ARCH
	(CPP_CPU??_SIZE_TYPE): New.
	(CPP_CPU??_SPEC, CPP_CPUCOMMON_SPEC): Break out from...
	(CPP_CPU_SPEC): ... here; support choosing of CPU.
	(EXTRA_SPECS): Add cpp_cpu??, cpp_cpu??sizet, cpp_cpucommon.
	(MAX_LONG_TYPE_SIZE, MAX_BITS_PER_WORD): Define to 32 for 32bit-only
	compiler.
	* i386.c (override_options): Add sorry about not suported modes.

Mon May 14 08:56:47 2001  Jeffrey A Law  (law@cygnus.com)

	* config/pa/som.h (NM_FLAGS): Remove.
	(ASM_OUTPUT_FUNCTION_PREFIX): No longer truncate subspace names.
	(ASM_OUTPUT_SECTION_NAME): Remove.
	(MAKE_DECL_ONE_ONLY, ASM_WEAKEN_LABEL): Likewise.

2001-05-14  Mark Mitchell  <mark@codesourcery.com>

	* regrename.c (regrename_optimize): Do not rename registers to
	leaf registers.

2001-05-14  Alexandre Oliva  <aoliva@redhat.com>

	* rtl.texi (CALL_INSN_FUNCTION_USAGE): Note that (and when) it may
	contain MEMs.  Remove useless distinction about clobbering
	registers.

2001-05-13  Geoff Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.h (EXCEPTION_SECTION): Move to...
	* config/rs6000/aix.h (EXCEPTION_SECTION): ... here.
	* config/rs6000/sysv4.h (CONST_SECTION_ASM_OP): Delete.
	(ASM_PREFERRED_EH_DATA_FORMAT): Define.
	(EXCEPTION_SECTION): Define.

2001-05-13  Zack Weinberg  <zackw@stanford.edu>

	* libgcc2.c, libgcc2.h: Restore __eprintf.  Label as used for
	binary backward compat only.
	* Makefile.in (LIB2FUNCS_ST): New.  Put _eprintf here, not
	in LIB2FUNCS.  Pass it to mklibgcc.
	* mklibgcc.in: Handle LIB2FUNCS_ST.

	* Makefile.in (installdirs): Don't create $(gcc_tooldir).

2001-05-13  Alexandre Oliva  <aoliva@redhat.com>

	* tm.texi (THREAD_MODEL_SPEC): Document it.
	* gcc.c (main): Use it.
	* config/rs6000/aix43.h (THREAD_MODEL_SPEC): Define it.
	* config/rs6000/aix51.h (THREAD_MODEL_SPEC): Likewise.

2001-05-13  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rtl.h (SYMBOL_REF_WEAK): New macro.
	* rtlanal.h (rtx_addr_can_trap): Use it, a weak SYMBOL_REF can trap.
	* varasm.c (make_decl_rtl): Mark SYMBOL_REF weak if necessary.
	* rtl.texi (SYMBOL_REF_WEAK): Document it.
	* gcc.texi: Remove wrong description.

2001-05-13  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in (STAMP): New macro.
	Replace all uses of `touch' with $(STAMP).
	* fixinc/Makefile.in: Likewise.

Sun May 13 07:26:34 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* configure.in: ldopen is never in -lexc, so don't test for it.
	Add test for exc_resume in -lexc for Ada.
	* configure: Regenerated.

2001-05-12  Richard Henderson  <rth@redhat.com>

	* dwarf2asm.c (size_of_encoded_value): New function.
	* dwarf2asm.h: Declare it.
	* except.c (output_function_exception_table): Align the TType
	array only as wide as the encoding.

2001-05-12  Zack Weinberg  <zackw@stanford.edu>

	* extend.texi: Document #pragma GCC java_exceptions.

2001-05-12  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* c-parse.in (bison parser, init_reswords): Remove uses of
	doing_objc_thang.
	* c-tree.h (doing_objc_thang): Remove.

2001-05-12  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpplex.c (_cpp_lex_token): Ensure we warn at most once
	about files not ending in newlines.

2001-05-12  Neil Booth  <neil@cat.daikokuya.demon.co.uk>

	* dwarfout.c (dwarfout_init): Add cast.
	* sched-deps.c (sched_analyze_insn): Remove unused vars.
	* unwind-dw2-fde.c (_Unwind_Find_FDE): Flag unused parameter so.
cp:
	* method.c (build_mangled_C99_name): Remove unused prototype.

2001-05-12  Alexandre Oliva  <aoliva@redhat.com>

	* config/arm/arm.h (TARGET_PTRMEMFUNC_VBIT_LOCATION): Use delta.

2001-05-12  Alexandre Oliva  <aoliva@redhat.com>

	* defaults.h (TARGET_PTRMEMFUNC_VBIT_LOCATION): Define.
	* tm.texi (TARGET_PRTMEMFUNC_VBIT_LOCATION): Document.

2001-05-11  Richard Henderson  <rth@redhat.com>

	* defaults.h (ASM_PREFERRED_EH_DATA_FORMAT): New.
	* dwarf2asm.c (dw2_force_const_mem, dw2_output_indirect_constant_1,
	dw2_output_indirect_constants, dw2_asm_output_encoded_addr_rtx): New.
	* dwarf2asm.h (dw2_asm_output_encoded_addr_rtx): Prototype.
	(dw2_output_indirect_constants): Prototype.
	* dwarf2out.c (dwarf2out_begin_prologue): Generate
	current_function_func_begin_label if we'll need it for EH.  Exit
	early for IA64_UNWIND_INFO.
	* except.c: Get DW_EH_PE_* defines from dwarf2.h.
	(eh_data_format_name): Update for indirect references.
	(output_function_exception_table): Care for IA64_UNWIND_INFO.
	Handle ASM_PREFERRED_EH_DATA_FORMAT.
	* except.h (MUST_USE_SJLJ_EXCEPTIONS): IA64_UNWIND_INFO needn't
	define HAVE_eh_return etc.
	* final.c (final_start_function): Always call dwarf2out_begin_prologue.
	(final_end_function): Don't call output_function_exception_table.
	* toplev.c (compile_file): Call dw2_output_indirect_constants.
	(rest_of_compilation): Invoke output_function_exception_table
	for ia64 before assemble_end_function.
	* tm.texi (ASM_PREFERRED_EH_DATA_FORMAT): Document.
	(ASM_MAYBE_OUTPUT_ENCODED_ADDR_RTX): Document.

	* unwind-dw2.c (_Unwind_GetTextRelBase, _Unwind_GetDataRelBase): New.
	* unwind.h: Declare them.
	* libgcc-std.ver: Export them.
	* unwind-pe.h: New file.

	* config/alpha/elf.h (ASM_PREFERRED_EH_DATA_FORMAT): New.

	* config/ia64/fde-glibc.c: Use "struct unw_table_entry"
	instead of "fde".
	(find_fde_for_dso): Extract DT_PLTGOT.
	(_Unwind_FindTableEntry): Rename from __ia64_find_fde; return
	the segment and gp as well.
	* config/ia64/frame-ia64.c: Remove file.
	* config/ia64/frame-ia64.h: Remove file.
	* config/ia64/unwind-ia64.c: New file.
	* config/ia64/unwind-ia64.h: New file.
	* config/ia64/ia64.h (ASM_OUTPUT_EH_CHAR): Remove.
	(ASM_OUTPUT_EH_SHORT, ASM_OUTPUT_EH_INT): Remove.
	(ASM_OUTPUT_EH_DOUBLE_INT): Remove.
	(ASM_PREFERRED_EH_DATA_FORMAT): New.
	(ASM_MAYBE_OUTPUT_ENCODED_ADDR_RTX): New.
	(IA64_UNWIND_INFO): Re-enable.
	(HANDLER_SECTION): Remove.
	(EH_RETURN_DATA_REGNO): New.
	* config/ia64/ia64.md (exception_receiver): Remove.
	* config/ia64/t-glibc (LIB2ADDEH): Re-enable.
	* config/ia64/t-ia64 (LIB2ADDEH): Re-enable.

2001-05-11  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.c (group_barrier_needed_p): Don't allow
	calls and jumps to be bundled together.
	(ia64_reorg): Emit a break after a noreturn call that ends
	a function.
	* config/ia64/ia64.md (break_f): New.

2001-05-12  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-lex.c (lex_charconst): Convert into a simple wrapper
	around cpp_interpret_charconst, to which most of the code
	body is moved.
	* cppexp.c (MAX_CHAR_TYPE_SIZE, MAX_WCHAR_TYPE_SIZE,
	MAX_LONG_TYPE_SIZE, MAX_INT_TYPE_SIZE, MAX_CHAR_TYPE_MASK,
	MAX_WCHAR_TYPE_MASK, parse_escape, parse_charconst): Remove.
	(lex): Use cpp_interpret_charconst.
	* cpplex.c (parse_escape, read_ucs, cpp_interpret_charconst,
	hex_digit_value): New functions.
	(MAX_CHAR_TYPE_SIZE, MAX_WCHAR_TYPE_SIZE): New macros.
	* cpplib.h (cpp_interpret_charconst): New prototype.
	* Makefile.in: Update.

2001-05-12  Dean Wakerley  <dean@wakerley.com>

	* doc/install.texi: New file. Converted to texinfo from the HTML
	documentation in wwwdocs/htdocs/install.

Fri May 11 15:50:13 2001  Jeffrey A Law  (law@cygnus.com)

	* gcse.c (insert_insn_end_bb): Do not search for assignments to
	non-argumment registers that are mentioned in CALL_INSN_FUNCTION_USAGE.

	* toplev.c (compile_file): Move comment for opening output
	file to just before the code that opens the output file.

2001-05-11  Jakub Jelinek  <jakub@redhat.com>

	* regmove.c (regmove_optimize): Suppress the optimization for
	unchanging destination register.  Add comment above function.

2001-05-11  Zack Weinberg  <zackw@stanford.edu>

	* Makefile.in: Exterminate all references to assert.h.
	* cross-make: Likewise.
	* assert.h: Delete.
	* configure.in: Correct commentary.
	* configure: Regenerate.

	* libgcc-std.ver, libgcc2.c, libgcc2.h, sys-protos.h:
	Remove __eprintf.

	* config/t-freebsd, config/t-linux, config/t-linux-aout,
	config/t-netbsd, config/t-rtems, config/x-linux,
	config/i386/t-beos, config/mcore/t-mcore, config/mcore/t-mcore-pe:
	No need to override INSTALL_ASSERT_H.

	* fixinc/fixinc.dgux, fixinc/fixinc.interix, fixinc/fixinc.ptx,
	fixinc/fixinc.svr4, fixinc/fixinc.winnt, fixinc/fixinc.wrap,
	fixinc/fixincl.sh: Don't install assert.h into objdir/include.

2001-05-11  Graham Stott  <grahams@redhat.com>

	* combine.c (simplify_comparison): Fix typo.

2001-05-11  Mark Mitchell  <mark@codesourcery.com>

	* loop.h (struct movables): Remove `num'.
	* loop.c (scan_loop): Don't set it.  Use count_insns_in_loop.
	Adjust call to strength_reduce.
	(num_unmoved_movables): New function.
	(move_movables): Don't set movables->num.
	(strength_reduce): Compute the number of instructions in the loop
	here, rather than in the caller.
	(check_dbra_loop): Always clear reversible_mem_store if there
	are any memory sets.
	(loop_regs_scan): Don't count instructions here.
	(count_insn_in_loop): New function.

2001-05-11  Mark Mitchell  <mark@codesourcery.com>

	* optabs.c (emit_libcall_block): Don't mark calls as CONST_CALL_P.

2001-05-11  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-common.c (finish_label_expr): New function, lifted from
	from cp/semantics.c.
	* c-common.h (finish_label_expr, lookup_label): New prototypes.
	* c-parse.in: Move 3 blocks of parser code into new functions.
	* c-typeck.c (simple_asm_stmt, c_cast_expr): New functions.
	* c-tree.h (simple_asm_stmt, c_cast_expr): New prototypes.
	(lookup_label): Remove.

2001-05-11  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/t-mn10300 (dp-bit.c, fp-bit.c): Don't define
	FLOAT_BIT_ORDER_MISMATCH.

2001-05-10  David Edelsohn  <edelsohn@gnu.org>

	* expr.c (emit_push_insn): Convert PUSH_ROUNDING argument to
	bytes.  Reported by Kazu Hirata <kazu@hxi.com>.

2001-05-10  David Edelsohn  <edelsohn@gnu.org>

	* expr.c (emit_group_load): extract_bit_field requires a REG or
	MEM as an argument.

Thu May 10 14:45:44 2001  Jeffrey A Law  (law@cygnus.com)

	* cse.c (cse_insn): Mostly remove first hunk of code which collapsed
	a computed jump into an unconditional jump.
	In second hunk of code for collapsing computed and conditional jumps
	into unconditional jumps, reemit the jump in additional cases.

	* jump.c (jump_optimize_1): Do not wrap the new jump target
	inside a LABEL_REF; gen_jump will do that automatically.

2001-05-10  Toon Moene  <toon@moene.indiv.nluug.nl>

	* dwarf2out.c (mem_loc_descriptor): Do not pass constant pool
	contents for a SYMBOL_REF in case of floating point constants.

2001-05-10  DJ Delorie  <dj@redhat.com>

	* c-common.c (combine_strings): Widen strings in a
	host-endian-independent way.

2001-05-10  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-parse.in: Remove many shift/reduce conflicts.  Update
	%expect values.
	(declspecs_nosc_nots_nosa_noea, declspecs_nosc_nots_nosa_ea,
	declspecs_nosc_nots_sa_noea, declspecs_nosc_nots_sa_ea,
	declspecs_nosc_ts_nosa_noea, declspecs_nosc_ts_nosa_ea,
	declspecs_nosc_ts_sa_noea, declspecs_nosc_ts_sa_ea,
	declspecs_sc_nots_nosa_noea, declspecs_sc_nots_nosa_ea,
	declspecs_sc_nots_sa_noea, declspecs_sc_nots_sa_ea,
	declspecs_sc_ts_nosa_noea, declspecs_sc_ts_nosa_ea,
	declspecs_sc_ts_sa_noea, declspecs_sc_ts_sa_ea, declspecs_ts,
	declspecs_nots, declspecs_ts_nosa, declspecs_nots_nosa,
	declspecs_nosc_ts, declspecs_nosc_nots, declspecs_nosc, declspecs,
	maybe_type_quals_setattrs, typespec_nonattr, typespec_attr,
	typespec_reserved_nonattr, typespec_reserved_attr,
	typespec_nonreserved_nonattr, maybe_setattrs, structsp_attr,
	structsp_nonattr, components_notype, component_notype_declarator,
	absdcl1_ea, absdcl1_noea, direct_absdcl1, absdcl_maybe_attribute,
	firstparm, setspecs_fp): New
	(typed_declspecs, reserved_declspecs, typed_typespecs,
	reserved_typespecquals, declmods, typespec, typespecqual_reserved,
	typed_declspecs_no_prefix_attr reserved_declspecs_no_prefix_attr
	declmods_no_prefix_attr, nonempty_type_quals, structsp,
	type_quals): Remove.  Users updated.
	(initdecls, notype_initdecls, after_type_declarator,
	parm_declarator, notype_declarator, absdcl1, components, ivars):
	Don't allow attributes at the start of a declarator; include them
	in the production containing the declarator instead.  Always
	require type specifiers before trying to redeclare a typedef name.
	(typename): Allow for attributes but warn that they are ignored.
	(parmlist, firstparm, setspecs_fp): Include attributes in
	parmlist; suck them off the parser stack in firstparm using
	setspecs_fp.

Thu May 10 09:17:42 2001  Jeffrey A Law  (law@cygnus.com)

	* ifcvt.c (merge_if_block): Use any_uncondjump_p, not simplejump_p
	to determine if a block has an unconditional jump at its end.

	* jump.c (jump_optimize_1): When converting a conditional jump
	to an unconditional jump, build the jump using gen_jump instead
	of just modify operands in-place.

2001-05-09  Zack Weinberg  <zackw@stanford.edu>

	* cppinit.c (cpp_post_options): Shut off macro expansion if
	-fpreprocessed.
	* cpplib.c (_cpp_handle_directive): If -fpreprocessed, accept
	IN_I directives only if the # is in column 1 and the directive
	name begins in column 2.
	* cppmain.c (scan_buffer): Insert a space between # and an
	identifier, when that identifier is a directive name.

	* tradcpp.c (struct file_buf): Add a pointer to the next entry
	in the header search path.
	(enum node_type): Add T_INCLUDE_NEXT.
	(directive_table): Add entry for include_next.
	(do_include_next): New function.
	(process_include): New routine, broken out of do_include.
	(finclude): Insert 'nhd' argument, to be copied into
	next_header_dir of the new buffer.
	(main): Adjust to match.
	* gsyslimits.h, limity.h: Un-indent #include_next.

2001-05-09  Joseph S. Myers  <jsm28@cam.ac.uk>

	* objc.texi: Move from ../libobjc/objc-features.texi.  Adjust for
	inclusion as a chapter of the GCC manual.
	* gcc.texi: Include objc.texi.
	* fdl.texi: Use @unnumberedsec for the addendum.
	* Makefile.in ($(srcdir)/gcc.info, gcc.dvi): Update dependencies.

Wed May  9 16:01:41 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (DImode move splitters): Use !MMX and !SSE for the condition.

Wed May  9 10:40:25 2001  Alexandre Oliva  <aoliva@redhat.com>

	* regclass.c (scan_one_insn): Update REG_N_REFS when optimizing
	handling of two-address insns.

Wed May  9 10:36:18 2001  Alexandre Oliva  <aoliva@redhat.com>

	* Makefile.in (NM_FOR_TARGET): Look for ./nm, then
	../binutils/nm-new instead of ../binutils/nm.

Wed May  9 12:15:46 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (movdi splitter): Fix the splitting condition
	(float_extenddftf splitter): Fix mode.

Wed May  9 12:05:39 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* genrecog.c (write_switch): Avoid outputting of switch for
	types wider than int.

2001-05-03  Andrew Haley  <aph@cambridge.redhat.com>

	* reload1.c (copy_eh_notes): New function.
	(emit_input_reload_insns): Call it.
	(emit_output_reload_insns): Call it.

2001-05-07  Zack Weinberg  <zackw@stanford.edu>

	* config.gcc (i[34567]86-*-sco3.2v4*, i[34567]86-*-sco*):
	Delete stanzas.
	* config/i386/sco.h, config/i386/sco4.h, config/i386/scodbx.h,
	config/i386/sco4dbx.h, config/i386/x-sco4: Delete file.

	* optabs.c: Delete #ifdef BROKEN_LDEXP block.

2001-05-07  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.md (interspace_jump): Revise comment.
	(builtin_longjmp): Block initial setup insns from delay slot of
	interspace branch.
	(builtin_setjmp_receiver): New expander to save and restore PIC
	register.

	* som.h (NM_FLAGS): Remove `-n' sort option.  Revise comment.

Mon May  7 09:30:14 2001  Jeffrey A Law  (law@cygnus.com)

	* toplev.c (compile_file): Set up the output file before we call
	the various initializers for the compiler.

	* except.c (sjlj_mark_call_sites): Do not search for assignments to
	non-argumment registers that are mentioned in CALL_INSN_FUNCTION_USAGE.

	* pa.h (MAX_LONG_TYPE_SIZE): Should be 32, not 64.
	* pa-64.h (*_TYPE_SIZE): Undefine before redefining.

2001-05-06  Zack Weinberg  <zackw@stanford.edu>

	* Makefile.in (tradcpp0): Correct typo in dependency list.

2001-05-06  Geoff Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.c (rs6000_emit_prologue): Don't save
	the link register if we're not going to use it.

	* config/rs6000/rs6000.c (output_profile_hook): Fix a warning.
	(output_function_profiler): Likewise.

2001-05-07  Alan Modra  <amodra@one.net.au>

	* pa.c (compute_frame_size): 64-bit frame marker is 16 bytes.

2001-05-06  Alexandre Oliva  <aoliva@redhat.com>

	* unroll.c (loop_iterations): Don't sign-extend abs_diff;
	zero-extend it.  Make abs_inc unsigned.

	* optabs.c (expand_binop): Sign-extend xop0 and xop1 from the
	widest mode in narrowing and widening operations.

	* config/mips/mips.md: Sign extend CONST_INTs.

2001-05-06  Andreas Jaeger  <aj@suse.de>

	* invoke.texi (Option Summary): Add -momit-leaf-frame-pointer
	(i386 Options): Document -momit-leaf-frame-pointer.

2001-05-06  Neil Booth  <neil@daikokuya.demon.co.uk>

	* c-typeck.c (internal_build_compound_expr): Check for
	array to pointer conversion just once.

2001-05-05  Richard Henderson  <rth@redhat.com>

	* integrate.c (copy_insn_list): Substitute NOTE_EXPECTED_VALUE.

2001-05-05  Richard Henderson  <rth@redhat.com>

	* except.c (remove_fixup_regions): Adjust REG_EH_REGION notes
	to the parent of the fixup region.

2001-05-05  Jakub Jelinek  <jakub@redhat.com>

	* gcc.c (cpp_options): Define __NO_INLINE__ unless we are honoring
	"inline" keyword.
	* cpp.texi (__NO_INLINE): Document it.

2001-05-05  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppfiles.c (struct include_file): New member err_no.
	(find_or_create_entry): Set it.
	(open_file): Don't set fds to -2.  Instead, use err_no to
	remember previous errors, if any.

2001-05-05  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.c (m68hc11_gen_movhi): Optimize moves
	between X and Y by using sequences of xgdx and xgdy.

2001-05-05  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md ("*logicalsi3_silshr16"): Use '?' instead
	of '!' for the 'D' alternative ('!' is too strong).
	("*logicalsi3_silshl16"): Likewise.
	("movstricthi"): Accept 'A' when 'd' constraint, remove spurious '+'.
	("movstrictsi"): Remove spurious '+'.
	("movstrictqi"): Don't accept 'A' and remove spurious '+'.
	("tstqi_1", "*lshrqi3_const1"): Put 'm' constraint before 'd'.
	("subqi3"): Disparage with '!' the 'x' and 'y' registers to avoid
	a reload to them.

2001-05-04  David Edelsohn  <edelsohn@gnu.org>

	* calls.c (store_one_arg): Don't divide align by BITS_PER_UNIT.

2001-05-04  Lars Brinkhoff  <lars@nocrew.org>

	* simplify-rtx.c (simplify_binary_operation): Simplify ~a + 1
	into -a.

2001-05-04  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* config/rs6000/rs6000.md (ashldi3 splits): Guard with
	TARGET_POWERPC64.

2001-05-04  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md (lshrhi3_const1): Fix shift of
	soft register, use ror instead of rol.

2001-05-04  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.c (m68hc11_check_z_replacement): Take
	into account pre/post increment decrement for 68HC12.
	Fix other problems in replacement and fix call to reg_mentioned_p.

2001-05-04  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/larith.asm (L_regs_frame): New for _.frame.
	Put the soft registers in bss for 68HC12.
	(L_regs_d3_4): New for _.d3 and _.d4.
	(L_regs_d5_6): Likewise.
	(L_regs_d1_2): Likewise.
	* config/m68hc11/t-m68hc11-gas (T_CPPFLAGS): Compile new parts.

2001-05-04  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.h (CPP_SPEC): Pass -D__HAVE_SHORT_DOUBLE__
	to the pre-processor when -fshort-double is specified.
	* config/m68hc11/m68hc11.2 (CPP_SPEC): Likewise.

2001-05-04  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/larith.asm (divmodhi4): Empty for 68HC12.
	(__mulsi3): Rewrite for 68HC12.
	* config/m68hc11/m68hc11.md (divmodhi4): Use idivs for 68HC12.
	Mark 'x' constraint with earlyclobber to prevent a
	RELOAD_FOR_OTHER_ADDRESS to go in it.
	(mulhi3_m68hc12): New pattern.
	(mulhi3_m68hc11): Rename of mulhi3.
	(mulhi3): New expand for 68HC12 optimisation.
	(umulhisi3, mulhisi3): New patterns for 68HC12.

2001-05-04  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md (*tbne, *tbeq): New patterns for 68HC12.
	(extendqisi2, extendqihi2, extendhisi2): Use sex for 68HC12.
	(uminqi3, umaxqi3, uminhi3, umaxhi3): New pattern for 68HC12.

2001-05-04  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.h (CONST_COSTS): Make the cost of
	constants cheap after reload.
	* config/m68hc11/m68hc11.c (m68hc11_shift_cost): Shift by 16 and 32
	are cheap.
	(m68hc11_rtx_costs): Cost of multiplication by 65536 is expensive
	so that gcc prefers a shift by 16.
	(m6811_cost, m6812_cost): Make the shift cheap compared to an add.

2001-05-04  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/elf.h (ASM_OUTPUT_ALIGNED_COMMON): Define.

2001-05-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alpha.h: NULL_PTR -> NULL.
	* arm.c: Likewise.
	* arm.h: Likewise.
	* avr.h: Likewise.
	* c4x.c: Likewise.
	* c4x.h: Likewise.
	* i386.c: Likewise.
	* i386.md: Likewise.
	* i860.c: Likewise.
	* ia64.c: Likewise.
	* m68hc11.h: Likewise.
	* rs6000.h: Likewise.
	* sh.c: Likewise.
	* sh.h: Likewise.
	* sparc.h: Likewise.
	* v850.c: Likewise.

	* expr.c: Likewise.
	* final.c: Likewise.
	* gcc.c: Likewise.
	* recog.c: Likewise.

2001-05-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* i386.c (ix86_emit_restore_regs_using_mov, ix86_save_reg): Change
	`bool' parameter to `int'.

	* hash.c (hash_lookup): Likewise.

	* hash.h (hash_lookup): Likewise.

	* tlink.c (symbol_hash_lookup, demangled_hash_lookup): Likewise.

Fri May  4 13:10:03 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_initialize_trampoline): Fix mode of constant.

2001-05-03  Geoff Keating  <geoffk@redhat.com>

	* invoke.texi (i386 Options): Delete references to -malign-jumps,
	-malign-loops, -malign-functions.
	* i386.c (ix86_align_funcs): Delete.
	(ix86_align_loops): Delete.
	(ix86_align_jumps): Delete.
	(override_options): Mark -malign-* as obsolete.  Emulate their
	behaviour with the -falign-* options.  Default -falign-* from
	the processor table.
	* i386.h (FUNCTION_BOUNDARY): Define to 16; revert Richard Kenner's
	patch of Wed May 2 13:09:36 2001.
	(LOOP_ALIGN): Delete.
	(LOOP_ALIGN_MAX_SKIP): Delete.
	(LABEL_ALIGN_AFTER_BARRIER): Delete.
	(LABEL_ALIGN_AFTER_BARRIER_MAX_SKIP): Delete.

2001-05-04  Andreas Jaeger  <aj@suse.de>

	* except.h: Add prototype declaration for
	expand_builtin_init_dwarf_reg_sizes.

2001-05-03  Geoffrey Keating  <geoffk@redhat.com>

	* Makefile.in (site.exp): Set TESTING_IN_BUILD_TREE.

2001-05-03  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md ("bitcmpqi"): New pattern for bitb
	instruction.
	("bitcmpqi2"): New pattern for bit-extract and test.
	("bitcmphi"): New pattern for bitb/bita instructions.

2001-05-03  Joseph S. Myers  <jsm28@cam.ac.uk>

	* gccbug.in: Use a temporary directory when the mktemp command is
	not available.

2001-05-03  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.h (STATIC_CHAIN_REGNUM): Use soft z register
	instead of _.d1.
	(INITIALIZE_TRAMPOLINE): Call it.
	(TRAMPOLINE_SIZE): Define according to 68HC11/68HC12.
	(TRAMPOLINE_TEMPLATE): Remove.
	* config/m68hc11/m68hc11.c (m68hc11_initialize_trampoline): New.
	* config/m68hc11/m68hc11-protos.h (m68hc11_initialize_trampoline):
	Declare.

2001-05-03  David O'Brien  <obrien@FreeBSD.org>

	* config/t-freebsd: Don't install "assert.h" in gcc.  Compile crtbeginS.o
	and crtendS.o with PIC.

2001-05-03  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/larith.asm (__mulqi3): Fix multiplication of two
	negative numbers.
	(___subdi3, ___adddi3): Use x instead of y as index register.
	(__init_bss_section, __map_data_section): Optimize for 68HC12.
	(__memset, __memcpy): Likewise.
	(regs): Put the soft registers in bss for 68HC12.
	(abort): Use trap to abort for 68hc12.
	(__mulhi3, __mulhi32): Use emul for 68hc12.
	(__mulsi3): Avoid to use the tmp soft register for 68hc12.

2001-05-03  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.h (LIMIT_RELOAD_CLASS): Don't define.
	* config/m68hc11/m68hc11-protos.h (limit_reload_class): Remove.
	* config/m68hc11/m68hc11.c (limit_reload_class): Remove.
	(m68hc11_override_options): Remove setting of flag_no_nonansi_builtin.
	Set 68HC12 min offset to -65536.
	(print_operand): Put parenthesis arround the operand if it refers
	to a symbol having the same name as a register.
	(m68hc11_z_replacement): When z register is replaced by its
	equivalent soft register, force the insn to be re-recognized.
	(m68hc11_check_z_replacement): Fix the test when destination is
	the index register and z dies in the insn.
	(m68hc11_reorg): Remove the REG_DEAD notes beforce recomputing them.

2001-05-03  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.c (m68hc11_override_options): Initialize
	costs according to processor variant.
	(m68hc11_shift_cost): New function to compute shift costs.
	(m68hc11_rtx_costs): Define costs according to processor variant.
	(m6811_cost): Costs for 68HC11.
	(m6812_cost): Costs for 68HC12.
	(COSTS_N_INSNS): Remove.

	* config/m68hc11/m68hc11.h (RTX_COSTS): New.
	(DEFAULT_RTX_COSTS): Remove.
	(CONST_COSTS): Define costs according to OUTER_CODE.
	(processor_costs): New struct to define costs.
	(m68hc11_cost): Pointer to current costs.

2001-05-03  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md (*addhi3_68hc12): Fix generation
	and use m68hc11_notice_keep_cc when using leax/leay.
	(addhi3 split): Reject split if the insn is handled by
	leax/leay above.
	* config/m68hc11/m68hc11.c (m68hc11_split_move): For 68HC12 the
	push must be handled in a special way if the source operand uses
	sp as index register.
	(m68hc11_notice_keep_cc): New function.
	(m68hc11_gen_movhi): Use it when an insn changes a register but
	not the flags.
	(m68hc11_gen_movqi): Fix move for 68HC12.
	* config/m68hc11/m68hc11-protos.h (m68hc11_notice_keep_cc): Declare.

2001-05-03  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.c (m68hc11_emit_libcall): Use LCT_CONST
	and don't pass operands[0] to emit_library_call_value.

2001-05-03  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md (tsthi_1): Use cpd for 68HC12.
	(zero_extendsi split): Simplify and use (zero_extendhi).
	(*addhi3): Remove 'w' constraint since stack pointer is handled
	by (addhi3_sp).
	(*ashlhi3_2): Operand 2 is clobbered use '+' for its constraint.
	(*ashlhi3, *ashrhi3, *lshrhi3): Likewise.
	(*ashrhi3_const): Fix shift by 7.
	(*lshrsi3_const16): Fix template.
	(call, call_value): Fix constraint and predicate.

2001-05-03  Stephane Carrez  <Stephane.Carrez@worldnet.fr>

	* config/m68hc11/m68hc11.md (X_REGNUM, D_REGNUM): New constant.
	(Y_REGNUM, SP_REGNUM, PC_REGNUM, A_REGNUM, B_REGNUM): Likewise.
	(CC_REGNUM): Likewise.
	(*unnamed splits): Use above constants instead of hard coded numbers.
	(*adcq, *subcq, *addsi_carry, *rotlqi3_with_carry): Likewise.
	(*rotlhi3_with_carry, *rotrhi3_with_carry): Likewise.
	(*return_16bit, *unnamed peepholes): Likewise.

2001-05-03  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc(rs6000-ibm-aix|powerpc-ibm-aix):  Do not include
	rs6000/rs6000.h twice.

2001-05-03  Mark Elbrecht  <snowball3@bigfoot.com>

	* config/i386/djgpp.h (CPP_PREDEFINES): Define __GO32__.
	(CPP_SPEC): Conditionally define MSDOS and GO32.
	(SUBTARGET_SWITCHES): Ignore -mbnu210 and -mno-bnu210.
	(SUBTARGET_OVERRIDE_OPTIONS): Warn that -mbnu210 and -mno-bnu210 are
	ignored.
	(SUPPORTS_WEAK, SUPPORTS_ONE_ONLY): Remove.

2001-05-03  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.md: Sign-extend GEN_INT operands.

2001-05-03  Mark Mitchell  <mark@codesourcery.com>

	* integrate.h (struct inline_remap): Add leaf_reg_map table.
	* integrate.c (expand_inline_function): Use xcalloc to allocate
	memory.
	(copy_rtx_and_substitute): Use the leaf_reg_map for leaf
	registers.

2001-05-03  Mark Mitchell  <mark@codesourcery.com>

	* c-dump.c (dequeue_and_dump): Don't look at DECL_ASSEMBLER_NAME
	if it is not set.

2001-05-03  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.h (LINK_SPEC): Pass --relax to the
	linker if -mrelax is given.
	(TARGET_SWITCHES): Document -mrelax.

	Re-installed 2001-01-09's patch:
	* hwint.h (HOST_BITS_PER_WIDE_INT, HOST_WIDE_INT): Use long long
	if it's wider than long and the target's long is wider than the
	host's.

2001-05-02  David O'Brien  <obrien@FreeBSD.org>

	* config.gcc, config/rs6000/aix51.h, config/rs6000/mach.h:  Do not
	directly include rs6000/rs6000.h.  Instead do it in tm.h.

2001-05-02  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c (STRING_OBJECT_CLASS_NAME): Default to
	NSConstantString for NeXT-style runtimes.
	(STRING_OBJECT_GLOBAL_NAME): New macro.
	(enum objc_tree_index): Add values OCTI_CNST_STR_GLOB_ID and
	OCTI_STRING_CLASS_DECL.
	(constant_string_global_id): New macro.
	(string_class_decl): Ditto.
	(setup_string_decl): New function.
	(build_objc_string_object): Use it to build a NeXT runtime
	compatible string initializer.

2001-05-02  Jakub Jelinek  <jakub@redhat.com>

	* tradcpp.c (do_define): Make sure we don't walk past limit.

2000-05-01  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* config/rs6000/rs6000.c (rs6000_legitimate_address): Allow any stack
	offsets if not REG_OK_STRICT.

	* config/rs6000/rs6000.h (REG_OK_STRICT_FLAG): New macro.
	(INT_REG_OK_FOR_INDEX_P): Likewise.
	(INT_REG_OK_FOR_BASE_P): Likewise.
	(REG_OK_FOR_INDEX_P): Use INT_REG_OK_FOR_INDEX_P.
	(REG_OK_FOR_BASE_P): Use INT_REG_OK_FOR_BASE_P.
	(LEGITIMATE_OFFSET_ADDRESS_P): Use INT_REG_OK_FOR_INDEX_P and
	INT_REG_OK_FOR_BASE_P instead of REG_OK_FOR_INDEX_P and
	REG_OK_FOR_BASE_P. Take an additional parameter.
	(LEGITIMATE_INDEXED_ADDRESS_P): Likeewise.
	(LEGITIMATE_INDIRECT_ADDRESS_P): Likewise.
	(LEGITIMATE_LO_SUM_ADDRESS_P): Likewise.
	(GO_IF_LEGITIMATE_ADDRESS): Move code into new function
	rs6000_legitimate_address() and use it.
	* config/rs6000/rs6000.c: Update all callers.
	(rs6000_legitimate_address): New function.

2001-05-02  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (rs6000_emit_move): Merge
	special_constant conditional blocks together.

2001-05-02  Dale Johannesen  <dalej@apple.com>

	* config/rs6000/rs6000.h (RS6000_ARG_SIZE): Remove unused NAMED
	parameter.
	(STRICT_ARGUMENT_NAMING): Define.
	* config/rs6000/rs6000.c (function_arg_advance, function_arg,
	function_arg_partial_nregs, setup_incoming_varargs): Remove
	args logic which depends on "named" now that STRICT_ARGUMENT_NAMING
	is defined.

Wed May  2 13:09:36 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/i386/i386.h (FUNCTION_BOUNDARY): Result is unsigned.

	* function.c (fixup_var_regs_1, case SUBREG): Use promoted mode
	for replacement.

	* expr.c (store_field): Do nothing except elaborate side-effects if
	zero-bit field.

2001-05-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-lex.c: NULL_PTR -> NULL.
	* cse.c: Likewise.
	* emit-rtl.c: Likewise.
	* gcse.c: Likewise.
	* genpeep.c: Likewise.
	* jump.c: Likewise.
	* mips-tdump.c: Likewise.
	* reload1.c: Likewise.
	* rtlanal.c: Likewise.
	* stmt.c: Likewise.
	* stor-layout.c: Likewise.
	* toplev.c: Likewise.

2001-05-01  Per Bothner  <per@bothner.com>

	* expr.c (expand_expr):  When compiling LABELED_BLOCK_EXPR,
	call do_pending_stack_adjust before emiting label.

2001-05-01  Mark Mitchell  <mark@codesourcery.com>

	* extend.texi: Fix typo.

2001-05-01  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c (build_module_descriptor): Clear DECL_CONTEXT
	of UOBJC_MODULES_decl.
	(generate_strings): Clear DECL_CONTEXT of new decl nodes.
	(generate_descriptor_table): Ditto.
	(generate_protocols): Ditto.
	(generate_protocol_list): Ditto.
	(generate_classref_translation_entry): Ditto.

2001-05-01  Jeffrey Oldham  <oldham@codesourcery.com>

	* invoke.texi (Optimize Options): Add documentation for `--param
	max-delay-slot-insn-search' and `--param
	max-delay-slot-live-search' and reorder --param section.
	* params.def: Modify initial comment.
	* params.h (param_info): Add `help' member.
	* toplev.c (lang_independent_params): Include `help' description.
	(display_help): Print --param parameters.

2001-05-01  Zack Weinberg  <zackw@stanford.edu>

	* config.gcc: Don't default xmake_file to ${cpu_type}/x-${cpu_type}.
	Remove references to deleted files.
	(*-*-openbsd): No need to override xmake_file.
	(*-*-sysv4): Treat like *-*-sysv.

	* configure.in: Probe for ldopen in various places, and set up
	collect2 to be linked with them if found.
	Don't dink with Windows registry stuff unless $host_os is a
	Win32 os name.  Check to see if we need -ladvapi32.
	* configure: Regenerate.

	* Makefile: Get rid of CLIB and HOST_CLIB.
	Substitute in COLLECT2_LIBS and link collect2 against its contents.
	* build-make: Get rid of HOST_CLIB.

	* config/a29k/x-unix, config/alpha/x-osf, config/i386/x-aix,
	config/i386/x-osfrose, config/m68k/x-dpx2, config/mips/x-iris3,
	config/mips/x-mips, config/mips/x-osfrose, config/mips/x-sony,
	config/mips/x-sysv, config/rs6000/x-aix31, config/rs6000/x-aix41,
	config/rs6000/x-rs6000: Delete.

	* config/i386/x-cygwin, config/m68k/t-aux, config/mips/x-iris:
	Don't set CLIB.

	24 x-host fragments remain, 0 x-cpu, 3 top level.

2001-05-01  Zack Weinberg  <zackw@stanford.edu>

	* aclocal.m4 (gcc_AC_C_CHAR_BIT): Correct test program.
	* configure: Regenerate.

2001-05-01  Angela Marie Thomas <angela@cygnus.com>

	* Makefile.in (install-headers): Remove redundant dependency.

2001-05-01  Nathan Sidwell  <nathan@codesourcery.com>

	* c-tree.texi (USING_STMT): Document.

2001-05-01  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* bitmap.c: Change NULL_PTR to NULL or "(rtx*)0".
	* c-common.c: Likewise.
	* c-decl.c: Likewise.
	* combine.c: Likewise.
	* rs6000.c: Likewise.
	* except.c: Likewise.
	* explow.c: Likewise.
	* expr.c: Likewise.
	* fold-const.c: Likewise.
	* function.c: Likewise.
	* gcc.c: Likewise.
	* gcse.c: Likewise.
	* integrate.c: Likewise.
	* loop.c: Likewise.
	* objc/objc-act.c: Likewise.
	* recog.c: Likewise.
	* reg-stack.c: Likewise.
	* reload.c: Likewise.
	* reload1.c: Likewise.
	* simplify-rtx.c: Likewise.
	* stmt.c: Likewise.
	* varasm.c: Likewise.

2001-05-01  Gabriel Dos Reis  <gdr@codesourcery.com>

	* diagnostic.def: New file.
	* diagnostic.h (diagnostic_t): New enum.
	* Makefile.in (diagnostic.o): Depend on diagnostic.def

2001-04-30  Zack Weinberg  <zackw@stanford.edu>

	* tsystem.h: Test only POSIX for availability of string.h
	and time.h.
	* config.gcc (all systems): If USG appeared in xm_defines,
	change it to POSIX.  If both USG and POSIX appeared, just
	delete USG. Remove unnecessary quotes around xm_defines
	settings.
	(m68k-crds-unos*): Don't #define unos - tested nowhere.
	(m68k-apple-aux*): Don't #define AUX - tested nowhere.
	(alpha*-*-linux*ecoff*, powerpc-*-linux*libc1,
	powerpc-*-linux*): No need to set xm_defines - handled by
	global settings for *-*-linux*.

2001-04-30  Zack Weinberg  <zackw@stanford.edu>

	* dbxout.c, mips-tfile.c, config/mips/mips.c, xcoffout.c:
	Always include gstab.h, not system stab.h.  Don't provide
	default definitions of N_CATCH or N_OPT.  Always use the
	gstab.h variant of STAB_CODE_TYPE.
	* final.c: Don't include stab.h/gstab.h at all, or provide
	defaults for N_SLINE and N_SOL.

	* xcoffout.c: Can assume N_MAIN, N_DSLINE, N_BSLINE, N_BINCL,
	N_EINCL, N_EXCL, N_M2C, N_SCOPE, N_CATCH, and N_OPT are
	available.
	* sdbout.c: Always include gsyms.h instead of system syms.h.

	* configure.in: No need to check for stab.h.
	* configure, config.in: Regenerate.
	* Makefile.in (final.o): Don't depend on gstab.h.

2001-04-30  Mark Mitchell  <mark@codesourcery.com>
	    Richard Henderson  <rth@redhat.com>

	* extend.texi: Improve documentation of volatile asms.

2001-04-30  Mark Mitchell  <mark@codesourcery.com>

	* c-tree.texi: Fix thinko.
	* gcc.texi: Likewise.

2001-04-30  Richard Henderson  <rth@redhat.com>

	* c-common.c (c_promoting_integer_type_p): New function, from the
	corpse of old macro.  Properly promote too-small enumerations and
	booleans.  Adjust all callers.
	* c-common.h (C_PROMOTING_INTEGER_TYPE_P): Remove.
	(c_promoting_integer_type_p): Declare.
	* c-decl.c: Adjust C_PROMOTING_INTEGER_TYPE_P invocations.
	* c-typeck.c: Likewise.
	(default_conversion): Remove now redundant boolean check.

2001-04-30  Jan Hubicka  <jh@suse.cz>
	    Richard Henderson  <rth@redhat.com>

	* regmove.c (try_apply_stack_adjustment): Remove now redundant
	sanity checks.
	(combine_stack_adjustments_for_block): Don't combine stack
	allocation followed by deallocations.  Handle grow-up stacks.

2001-04-30  Mark Mitchell  <mark@codesourcery.com>

	* fdl.texi: New file.
	* c-tree.texi: Use the GFDL.
	* gcc.texi: Likewise.

2001-04-30  Stan Shebs  <shebs@apple.com>

	* invoke.texi: Add a section documenting Objective-C options.

2001-04-27  Andrew Haley  <aph@cambridge.redhat.com>

	* emit-rtl.c (try_split):  Copy EH notes to sequence.

2001-04-30  Mark Mitchell  <mark@codesourcery.com>

	* regmove.c (record_stack_memrefs): Catch all references to the
	stack pointer.

2001-04-29  Toomas Rosin <toomas at ns dot tklabor dot ee>

	* Makefile.in (stmp-fixinc): quote shell assignment values

2001-04-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-aux-info.c: NULL_PTR->NULL in calls to `concat'.

	* gcc.c: Likewise.

	* prefix.c: Likewise.

2001-04-28  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c (handle_class_ref): Rewrite to flush target
	specific code and use new macro ASM_DECLARE_UNRESOLVED_REFERENCE.
	* config/darwin.h (ASM_DECLARE_UNRESOLVED_REFERENCE): Define.
	* tm.texi (ASM_DECLARE_UNRESOLVED_REFERENCE): Document.

	* config/darwin.h (STANDARD_EXEC_PREFIX): Don't define.
	(NEXT_OBJC_RUNTIME): Define.

Sat Apr 28 21:02:58 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* rtl.h (simplify_gen_relational): Add cmp_mode parameter.
	* simplify-rtx.c (simplify_gen_relational): Likewise.

	* simplify-rtx.c (simplify_replace_rtx): Handle relationals and MEMs.

	* i386.h (VALID_SSE_REG_MODE): Accept MMX modes if SSE2
	* i386.md (movsi_1, movdi2, movdi_1_rex64): Handle SSE2 moves.

	* i386.md (negsf2, negdf2, abssf2, absdf2): Force operands to
	registers in SSE case; fix handling of the immediates.
	(negsf2_ifs, abssf2_ifs): Tweak constraints; require
	operands to be in regsiters before reload.
	(negdf2_ifs, absdf2_ifs): Likewise; disable for 64bit
	(negdf2_ifs_rex64, absdf2_ifs_rtx64): New.
	(abstf,absxf,negtf,negxf splitters): Compute
	properly the regnum for x86_64.
	(avsdf2_if_rex64): New.

Sat Apr 28 10:36:23 2001  Jeffrey A Law  (law@cygnus.com)

	* flow.c (propagate_block_delete_insn): Handle deletion of ADDR_VEC
	and ADDR_DIFF_VEC insns when the proceeding CODE_LABEL was put
	into the constant pool.
	* jump.c (jump_optimize_1): Remove barrier successors after all
	the LABEL_NUSES counds have been computed.
	(delete_barrier_successors): When deleting a tablejump insn, also
	delete the jump table it uses.
	* varasm.c (force_const_mem): Set LABEL_PRESERVE_P when forcing a
	label into memory.

2001-04-28  Martin Kalen  <martin.kalen@todaysystems.com.au>

	* pa.c (FRP): Remove erroneous white space in macro definition.

2001-04-28  Andreas Jaeger  <aj@suse.de>

	* invoke.texi: Use XX-bit instead of XXbit or XX bit where
	appropriate.
	* extend.texi: Likewise.
	* tm.texi: Likewise.

2001-04-28  Andreas Jaeger  <aj@suse.de>

	* md.texi: Use XX-bit instead of XXbit or XX bit where
	appropriate.

2001-04-28  Jens Schweikhardt <schweikh@schweikhardt.net>

	* gcc.c (process_command): Allow -l lib in addition to -llib
	for POSIX compliance. This fixes PR c/2347.

	* invoke.texi: Update section on Link Options accordingly.

2001-04-27  Zack Weinberg  <zackw@stanford.edu>

	* function.c (purge_addressof_1): Remove the duplicate
	if (code == SET) block.  Fold the two if (code == ADDRESSOF)
	blocks together.

2001-04-28  Jason Merrill  <jason_merrill@redhat.com>

	* except.c (expand_eh_region_start): Don't start a new block.
	(expand_eh_region_end): Don't end a block.
	* stmt.c (expand_end_bindings): Don't end EH blocks.
	(expand_decl_cleanup): Starting an EH region won't change the block.
	(mark_block_as_eh_region, mark_block_as_not_eh_region): Lose.
	(is_eh_region): Lose.
	* tree.h: Adjust.

2001-04-27  Jeffrey Oldham  <oldham@codesourcery.com>

	* except.c (expand_eh_region_end_cleanup): word_mode, not Pmode.

	* collect2.c (main): Add `-L' case to remove duplicate entries.
	(is_in_args): New function to check for a duplicate argument.
	* defaults.h (LINK_ELIMINATE_DUPLICATE_LDIRECTORIES): New macro.
	* tm.texi (LINK_ELIMINATE_DUPLICATE_LDIRECTORIES): New documentation.
	* config/mips/iris6.h (LINK_ELIMINATE_DUPLICATE_LDIRECTORIES):
	Define to be nonzero.

2001-04-27  Andreas Jaeger  <aj@suse.de>
	    Richard Henderson  <rth@redhat.com>

	* md.texi (Machine Constraints): Document additional i386
	constraints and fix description of "A".

Fri Apr 27 10:43:49 2001  Jeffrey A Law  (law@cygnus.com)

	* tm.texi (TARGET_MEM_FUNCTIONS): Update text.

2001-04-27  Jason Merrill  <jason_merrill@redhat.com>

	* except.c (get_exception_filter): word_mode, not Pmode.

2001-04-26  Geoffrey Keating  <geoffk@redhat.com>

	* config/sparc/sparc.md (movsf_no_f_insn): Add more alternatives
	common to other movsf patterns.  Move up so that in future
	people who change the other patterns will change it too.
	(movsf_lo_sum): Allow even for soft-float; add appropriate
	constraints.
	(movsf_high): Likewise.
	(movsf_high+1): Allow even for soft-float.

	* function.c (expand_function_end): Always clobber the
	return registers, even if there is no return label.

Thu Apr 26 20:28:21 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* (ix86_expand_fp_movcc): Re-enable SSE conditional move generation.

Thu Apr 26 19:20:28 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (abs/neg splitter): Fix calculation of sign bit for TFmodes
	(pushqi2_rex64, pushhi2_rex64): Add.

2001-04-26  Andrew Haley  <aph@cambridge.redhat.com>

	* except.c (expand_eh_region_end_cleanup): Force pending stack
	adjust before emitting label that branches around cleanup code.

2001-04-26  H.J. Lu  (hjl@gnu.org)

	* config.gcc (mips*-*-linux*): Add elfos.h to tm_file.

	* config/mips/ecoff.h (STARTFILE_SPEC): Undefine before
	define.
	* config/mips/elf64.h (MAX_OFILE_ALIGNMENT): Likewise.
	(ASM_OUTPUT_SECTION_NAME): Likewise.
	(ASM_WEAKEN_LABEL): Likewise.
	(UNIQUE_SECTION): Likewise.
	(ASM_OUTPUT_CONSTRUCTOR): Likewise.
	(ASM_OUTPUT_DESTRUCTOR): Likewise.
	* config/mips/elf.h (MAX_OFILE_ALIGNMENT): Likewise.
	(ASM_OUTPUT_SECTION_NAME): Likewise.
	(ASM_WEAKEN_LABEL): Likewise.
	(UNIQUE_SECTION): Likewise.
	(ASM_OUTPUT_CONSTRUCTOR): Likewise.
	(ASM_OUTPUT_DESTRUCTOR): Likewise.
	* config/mips/linux.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/mips/mips.h (DBX_CONTIN_LENGTH): Likewise.
	(ASM_FILE_START): Likewise.
	(ASM_OUTPUT_SOURCE_LINE): Likewise.
	(ASM_DECLARE_OBJECT_NAME): Likewise.
	(ASM_FILE_END): Likewise.
	(ASM_DECLARE_FUNCTION_NAME): Likewise.
	(ASM_OUTPUT_INTERNAL_LABEL): Likewise.
	(ASM_GENERATE_INTERNAL_LABEL): Likewise.
	(ASM_OUTPUT_CASE_LABEL): Likewise.
	(ASM_OUTPUT_SKIP): Likewise.
	(ASM_OUTPUT_ASCII): Likewise.
	(ASM_OUTPUT_IDENT): Likewise.
	(READONLY_DATA_SECTION): Likewise.
	(EXTRA_SECTIONS): Likewise.
	(EXTRA_SECTION_FUNCTIONS): Likewise.
	(SELECT_RTX_SECTION): Likewise.
	(SELECT_SECTION): Likewise.

	* config/mips/linux.h (INVOKE__main): Undefine.
	(CTOR_LIST_BEGIN): Likewise.
	(CTOR_LIST_END): Likewise.
	(DTOR_LIST_BEGIN): Likewise.
	(DTOR_LIST_END): Likewise.
	(SET_ASM_OP): Defined it to ".dummy".
	(ASM_OUTPUT_DEF): Defined.
	(ASM_OUTPUT_DEFINE_LABEL_DIFFERENCE_SYMBOL): Defined.

2001-04-26  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.h (ASM_OUTPUT_MAX_SKIP_ALIGN): Define, if the
	assembler supports .p2align.

2001-04-26  Nathan Sidwell <nathan@codesourcery.com>

	* c-lex.c (c_lex): Remove # from %o diagnostic formatting.

2001-04-26  Jakub Jelinek  <jakub@redhat.com>

	* integrate.c (expand_inline_function): Check for error_mark_node
	in actual argument.

2001-04-26  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.h (CC1_CPU_SPEC): Fix deprecation warnings for
	-m386 and -m486.

2001-04-26  Alexandre Oliva  <aoliva@redhat.com>

	* configure.in (configargs.h): Define thread_model.
	* configure: Rebuilt.
	* gcc.c (main): Print it with -v.

2001-04-25  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Document -Wmissing-braces, -dumpspecs,
	-dumpmachine, -dumpversion, -fmem-report and -ftime-report.
	* gcc.1: Regenerate.

2001-04-25  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* dwarfout.c (is_pseudo_reg, type_main_variant, is_tagged_type,
	is_redundant_typedef): Use static inline instead of inline static.

Wed Apr 25 18:21:01 2001  Christopher Faylor <cgf@cygnus.com>

	* config/i386/cygwin.h: Move W32API search to LINK_SPEC to ensure that
	this directory is always searched.

2001-04-25  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (ix86_expand_epilogue): Properly compute size
	of registers to restore along non eh_return path.

2001-04-25  Jakub Jelinek  <jakub@redhat.com>

	* c-format.c (check_format_info_recurse): Handle
	PLUS_EXPR for format string.

2001-04-25  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/ia64.h (CC1_SPEC): Define.
	* config/ia64/linux.h (CC1_SPEC): Define.

Wed Apr 25 17:09:50 2001  J"orn Rennecke <amylaar@redhat.com>

	* emit-rtl.c (constant_subword): Also do sign extension in
	BITS_PER_WORD == 16 case.

2001-04-25  Jason Merrill  <jason_merrill@redhat.com>

	* loop.c (try_swap_copy_prop): Go back to checking insn.

2001-04-25  Jakub Jelinek  <jakub@redhat.com>

	* emit-rtl.c (subreg_hard_regno): Only do HARD_REGNO_MODE_OK check
	if check_mode is non-zero.

2001-04-25  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.c (ix86_expand_int_movcc): If overlap between
	out and comparison sequence has been detected, put result into
	proper temporary pseudo.

2001-04-24  Zack Weinberg  <zackw@stanford.edu>

	* Makefile.in (LIB2FUNCS): Remove _varargs and __dummy.
	* libgcc-std.ver: Remove __builtin_saveregs, __dummy, and __empty.
	* libgcc2.c: Remove __dummy and __builtin_saveregs.
	* libgcc2.h: Don't prototype __builtin_saveregs or __dummy.
	* config/i860/varargs.asm: New file - preserve i860 __builtin_saveregs
	for future reference.

2001-04-24  Jason Merrill  <jason_merrill@redhat.com>

	* except.c (reachable_handlers): Step out one level from a RESX.

	* except.c (struct eh_region): Rename 'last' to 'resume'.
	(mark_eh_region, duplicate_eh_region_1): Adjust.
	(expand_eh_region_end_cleanup): Remember the jump, not the barrier.
	(build_post_landing_pads): Likewise.
	(expand_end_catch, expand_eh_region_end_allowed): Don't set it.
	(expand_eh_region_end_must_not_throw): Likewise.
	(connect_post_landing_pads): Thread (only) regions with non-deleted
	resume insns.

	* except.c (expand_eh_region_end_cleanup): Save the EH return data
	registers around the cleanup.
	(get_exception_filter): New fn.
	(finish_eh_generation): Use it.

2001-04-24  Nathan Sidwell <nathan@codesourcery.com>

	* c-semantics.c (add_scope_stmt): Don't call
	current_scope_stmt_stack multiple times.

2001-04-24  Zack Weinberg  <zackw@stanford.edu>
	    Nathan Sidwell <nathan@codesourcery.com>

	Lazy __FUNCTION__ generation.
	* c-common.h (RID_FUNCTION_NAME, RID_PRETTY_FUNCTION_NAME,
	RID_C99_FUNCTION_NAME): New _RIDs.
	(CTI_FUNCTION_ID, CTI_PRETTY_FUNCTION_ID, CTI_FUNC_ID): Remove.
	(CTI_FUNCTION_NAME_DECL, CTI_PRETTY_FUNCTION_NAME_DECL,
	CTI_C99_FUNCTION_NAME_DECL, CTI_SAVED_FUNCTION_NAME_DECLS): New
	global tree slots.
	(function_id_node, pretty_function_id_node, func_id_node): Remove.
	(c99_function_name_decl_node, function_name_decl_node,
	pretty_function_name_decl_node, saved_function_name_decls):
	Declare.
	(struct language_function): Remove x_function_name_declared_p.
	(make_fname_decl): Remove a parameter.
	(declare_function_names): Remove prototype.
	(start_fname_decls, finish_fname_decls): Prototype.
	(fname_as_string): Likewise.
	(fname_string, fname_decl): Likewise.
	* c-common.c (make_fname_decl): Adjust.
	(struct fname_var_t): New struct.
	(fname_vars): New static array.
	(declare_function_name): Remove.
	(start_fname_decls, finish_fname_decls): New functions.
	(fname_as_string): New function from remnants of
	declare_function_name.
	(fname_string, fname_decl): New functions.

	* c-decl.c (c_function_name_declared_p): Remove.
	(init_decl_processing): Don't generate __FUNCTION__ et al ids,
	don't call declare_function_name. Call start_fname_decls.
	(c_make_fname_decl): Adjust parameters. Generate the name. Don't
	clobber the line number. Call finish_decl.
	(start_function): Call start_fname_decls.
	(finish_function): Call finish_fname_decls.
	Remove c_function_name_declared_p.
	(push_c_function_context): Don't push c_function_name_declared_p.
	(pop_c_function_context): Don't pop c_function_name_declared_p.
	(c_begin_compound_stmt): Don't check c_function_name_declared_p.
	* c-parse.in (STRING_FUNC_NAME, VAR_FUNC_NAME): New tokens.
	(program): Call finish_fname_decls for C.
	(primary): Add VAR_FUNC_NAME.
	(reswords): Add slots for __FUNCTION__ et al.
	(rid_to_yy): Add mappings for __FUNCTION__ et al.
	(yylexname): If it's a STRING_FUNC_NAME generate the function name
	now. Don't look for VAR_DECLs containing __FUNCTION__ et al.
	* c-semantics.c (prune_unused_decls): Remove.
	(finish_stmt_tree): Don't call prune_unused_decls.
	(genrtl_decl_stmt): Don't prune unused decls here.

2001-04-24  Nick Clifton  <nickc@cambridge.redhat.com>

	* dwarf2out.c (mem_loc_descriptor): If a SYMBOL_REF is in the
	constant pool, use the pool's SYMBOL_REF instead.

	* config/v850/v850.h (STRICT_ALIGNMENT): Always set, even for the
	v850e.

2001-04-23  Joseph S. Myers  <jsm28@cam.ac.uk>

	* c-convert.c (convert): When converting to a BOOLEAN_TYPE, avoid
	passing nested NOP_EXPRs to fold.

Mon Apr 23 14:32:12 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* reg-stack.c (emit_swap_insn): Do not get pass CALL_INSNs.

2001-04-22  Mark Mitchell  <mark@codesourcery.com>

	* loop.c (loop_delete_insns): Add prototype.

2001-04-23  Phil Edwards  <pme@sources.redhat.com>

	* configure.in:  Remove ENABLE_STD_NAMESPACE.
	* config.in:  Regenerated.
	* configure:  Regenerated.

2001-04-22  Stan Shebs  <shebs@apple.com>

	* config.gcc (powerpc-*-darwin*): Move the flag in xm-darwin.h
	into xm_defines.
	* config/rs6000/xm-darwin.h: Remove file.

2001-04-22  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* collect2.c (main): Use concat in lieu of xmalloc/sprintf.
	(write_c_file_stat): Likewise.

	* dbxout.c (dbxout_init): Likewise.

	* profile.c (output_func_start_profiler): Likewise.

2001-04-22  Philipp Thomas  <pthomas@suse.de>

	* ABOUT-GCC-NLS: Now that gettext 0.10.37 is out,
	require it instead of the CVS version.
	* cpperror.c (v_message): Put a blank before the macro
	body to not confuse exgettext.

2001-04-21  Mark Mitchell  <mark@codesourcery.com>

	* flow.c (proagate_one_insn): Remove useless assignment.
	* jump.c (delete_insn): Tidy.
	* loop.c (try_copy_prop): When deleting an instruction with a
	REG_RETVAL note, delete the entire libcall sequence.
	(loop_delete_insns): New function.
	* unroll.c (initial_reg_note_copy): Copy INSN_LIST notes, even if
	we're not substituting into them yet.

2001-04-21  Kazu Hirata  <kazu@hxi.com>

	* config/h8300/h8300.c (general_operand_src): Fix a comment typo.

	* config/sparc/sparc.c (sparc_flat_eligible_for_epilogue_delay):
	Fix a comment typo.
	* config/i960/i960.c (signed_arith_operand): Likewise.

	* calls.c (expand_call): Fix a comment typo.

2001-04-20  Zack Weinberg  <zackw@stanford.edu>

	* configure.in: Probe for times, clock, struct tms, and clock_t.
	* configure, config.in: Regenerate.
	* timevar.c: Replace ifdef forest in get_time with (relatively)
	straightforward series of checks based on autoconf's probes.

Fri Apr 20 12:24:50 2001  Jeffrey A Law  (law@cygnus.com)

	* config/pa/som.h (NM_FLAGS): Define.

2001-04-20  Bernd Schmidt  <bernds@redhat.com>

	* ia64.h (MD_SCHED_REORDER, MD_SCHED_REORDER2): Pass CLOCK to called
	function.
	* ia64-protos.h (ia64_sched_reorder): Additional arg for clock.
	* ia64.c (nop_cycles_until): New function.
	(prev_cycle, prev_first, last_issued): New static variables.
	(ia64_sched_reorder): Additional arg for clock.
	On final scheduling pass, emit extra NOPs as needed.
	Set prev_first and prev_cycle.
	(ia64_sched_reorder2): Pass clock arg down to ia64_sched_reorder.
	(ia64_variable_issue): Set last_issued.

2001-04-20  Alexandre Oliva  <aoliva@redhat.com>

	* config/i386/i386.c (ix86_expand_int_movcc,
	ix86_expand_strlensi_unroll_1): Sign-extend CONST_INTs.

2001-04-20  Geoff Keating  <geoffk@redhat.com>

	* config/rs6000/rs6000.md (ctrsi_internal1, ctrsi_internal2,
	ctrsi_internal3, ctrsi_internal4, ctrsi_internal5,
	ctrsi_internal6, ctrdi_internal1, ctrdi_internal2,
	ctrdi_internal3, ctrdi_internal4, ctrdi_internal5,
	ctrdi_internal6): In the short-branch case, this insn is only 4
	bytes long.  Reported by Reza Yazdani <reza@apple.com>.

2001-04-20  Jakub Jelinek  <jakub@redhat.com>

	* reg-stack.c (check_asm_stack_operands): Issue error if "=t" resp.
	"=u" is used together with "st" resp. "st(1)" clobber.

2001-04-20  Jakub Jelinek  <jakub@redhat.com>

	* gcse.c (gcse_main): Fix comment typo.
	(delete_null_pointer_check): Likewise.
	(hash_scan_set): Don't consider sets with REG_EQUIV MEM notes.
	* cse.c (cse_insn): Likewise.
	* function.c (fixup_var_refs_insns_with_hash): The sequence is
	toplevel.

2001-04-19  Zack Weinberg  <zackw@stanford.edu>

	* toplev.c: Excise all code for the undocumented -dm option.
	(float_signal): Call signal just once, unconditionally.

2001-04-19  Geoff Keating  <geoffk@redhat.com>

	* fold-const.c (fold): Use first_rtl_op rather than
	TREE_CODE_LENGTH when looping over parameters of a tree.
	Correct strange grouping in test for evaluated SAVE_EXPR.

Thu Apr 19 19:15:26 2001  Jeffrey A Law  (law@cygnus.com)

	* config/pa/pa-linux.h (CPLUSPLUS_CPP_SPEC): Undefine.
	* config/pa/pa.h (CPLUSPLuS_CPP_SPEC): Define.

	* config/pa/som.h (ASM_OUTPUT_FUNCTION_PREFIX): Truncate subspace
	name at 32 total characters.
	(ASM_OUTPUT_SECTION_NAME): Similarly.  Also, only support placing
	functions in named sections -- data items can still go into unique
	sections, but they have normal names (ie $LIT$ and $DATA$).

	* config/pa/som.h (SUPPORTS_INIT_PRIORITY): SOM does not support
	INIT_PRIORITY.

2001-04-19 DJ Delorie  <dj@redhat.com>

	* config/alpha/vms.h: Change OBJECT_SUFFIX and EXECUTABLE_SUFFIX
	to TARGET_OBJECT_SUFFIX and TARGET_EXECUTABLE_SUFFIX.
	* config/i386/cygwin.h: Likewise.
	* config/i386/mingw32.h: Likewise.
	* config/vax/vms.h: Likewise.
	* config/i386/djgpp.h: Remove NO_AUTO_EXE_SUFFIX.

	* config/alpha/xm-vms.h: Change OBJECT_SUFFIX and EXECUTABLE_SUFFIX
	to HOST_OBJECT_SUFFIX and HOST_EXECUTABLE_SUFFIX.
	* config/i386/xm-cygwin.h: Likewise.
	* config/i386/xm-djgpp.h: Likewise.
	* config/i386/xm-mingw32.h: Likewise.
	* config/vax/xm-vms.h: Likewise.

	* mkdeps.c (deps_add_default_target): Use TARGET_OBJECT_SUFFIX
	instead of OBJECT_SUFFIX.
	* collect2.c (find_a_file): Look for files matching the extension
	HOST_EXECUTABLE_SUFFIX instead of EXECUTABLE_SUFFIX.
	* gcc.c (DEFAULT_SWITCH_CURTAILS_COMPILATION): Depend on
	TARGET_EXECUTABLE_SUFFIX.
	(find_a_file): Use HOST_EXECUTABLE_SUFFIX.
	(make_relative_prefix): Likewise.
	(convert_filename): Use TARGET_ suffixes throughout.  Remove
	NO_AUTO_EXE_SUFFIX.
	(process_command): Likewise.
	(do_spec_1): Likewise.
	* java/lang.c (init_parse): Likewise.

	* gcc.texi : Document four new options matching the pattern
	(HOST|TARGET)_(OBJECT|EXECUTABLE)_SUFFIX.  Remove documentation
	for deleted macros OBJECT_SUFFIX and EXECUTABLE_SUFFIX.  Remove
	documentation for NO_AUTO_EXE_SUFFIX.

2001-04-19  Mark Mitchell  <mark@codesourcery.com>

	* toplev.h (struct lang_hooks): Allow decode_option to indicate
	that language-independent processing should not be done.
	* toplev.c (main): Adjust accordingly.

	* rtl.texi (jump_insn): Expand on JUMP_LABEL documentation.
	* loop.c (load_mems): Handle a NULL JUMP_LABEL for a JUMP_INSN.

	* mips.md (reload_outputdi): Require that operand0 be a
	general_operand.

2001-04-19  Jakub Jelinek  <jakub@redhat.com>

	* invoke.texi (-Wshadow): Clarify.

2001-04-18  Mark Mitchell  <mark@codesourcery.com>

	* loop.c (load_mems): Examine all the instructions in the loop
	before concluding that all jumps branch to the first instruction
	after the loop.

Wed Apr 18 20:32:03 2001  Christopher Faylor <cgf@cygnus.com>

	* config/i386/xm-cygwin.h (CPP_SPEC): Fix typo.

2001-04-18  Jakub Jelinek  <jakub@redhat.com>

	* cpp.texi (-Wwhite-space): Remove.
	(-Wall): -Wall does not imply -Wwhite-space.

2001-04-17  Zack Weinberg  <zackw@stanford.edu>

	* dbxout.c (dbxout_init): If DBX_OUTPUT_GCC_MARKER is defined,
	use it instead of blindly generating a .stabs.
	* xcoffout.h: Define DBX_OUTPUT_GCC_MARKER so we put the type
	in the right place.
	* xcoffout.c: Don't bother defining default for N_CATCH.
	(UNKNOWN_STAB): Use internal_error.
	(stab_to_sclass): Remove now-unnecessary aborts.
	Remove #if 0'ed case N_BROWS.  Add #ifdef N_OPT block.

Tue Apr 17 21:41:11 2001  Jeffrey A Law  (law@cygnus.com)

	* jump.c (mark_all_labels): Canonicalize the tail recursion
	label attached to CALL_PLACEHOLDER insns.

2001-04-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* output.h (dump_flow_info, free_basic_block_vars,
	which_alternative): Delete redundant prototypes.

	* rtl.h (bss_section): Likewise.

2001-04-17  Loren J. Rittle  <ljrittle@acm.org>

	* dbxout.c (N_OPT): Define if not available from <stab.h>

2001-04-17  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* vax.h (PROMOTE_PROTOTYPES): Define for compatibility with system
	libraries and native K&R compilers.

2001-04-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-typeck.c (convert_arguments): Don't check for width changes
	with -Wtraditional.

	* invoke.texi (-Wtraditional): Update documentation.

2001-04-16  Zack Weinberg  <zackw@stanford.edu>

	* toplev.c (output_lang_identify): Delete.
	(compile_file): Don't call ASM_IDENTIFY_GCC or ASM_IDENTIFY_LANGUAGE.
	Don't generate gcc2_compiled. label.  Don't emit a nop if profiling.
	If IDENT_ASM_OP is defined, emit an .ident "GCC (GNU) <version>"
	after calling ASM_FILE_END.

	* dbxout.c (dbxout_init): Don't call ASM_IDENTIFY_GCC_AFTER_SOURCE.
	Instead, unconditionally emit an N_OPT stab with string equal
	to STABS_GCC_MARKER, which defaults to "gcc2_compiled."

	* defaults.h: Don't provide default for ASM_IDENTIFY_LANGUAGE.

	* config/dbxelf.h, config/freebsd.h, config/nextstep.h,
	config/psos.h, config/ptx4.h, config/1750a/1750a.h,
	config/alpha/alpha.h, config/alpha/elf.h, config/arc/arc.h,
	config/arm/aof.h, config/arm/coff.h, config/arm/elf.h,
	config/arm/linux-elf.h, config/avr/avr.h, config/d30v/d30v.h,
	config/dsp16xx/dsp16xx.h, config/h8300/h8300.h,
	config/i370/i370.h, config/i386/beos-elf.h,
	config/i386/osf1elf.h, config/i386/osfrose.h,
	config/ia64/sysv4.h, config/m68k/3b1.h, config/m68k/auxgas.h,
	config/m68k/crds.h, config/m68k/hp320.h, config/m68k/m68kv4.h,
	config/m68k/mot3300.h, config/m68k/news.h, config/m68k/sgs.h,
	config/m68k/tower-as.h, config/mcore/mcore-elf.h,
	config/mips/iris6.h, config/mips/osfrose.h,
	config/mips/sni-svr4.h, config/pa/som.h, config/pdp11/pdp11.h,
	config/sparc/sp64-elf.h:
	Delete definitions of any or all of: ASM_IDENTIFY_GCC,
	ASM_IDENTIFY_GCC_AFTER_SOURCE, and ASM_IDENTIFY_LANGUAGE.

	* config/elfos.h, config/freebsd.h, config/linux.h,
	config/alpha/elf.h, config/arm/linux-elf.h, config/i386/i386elf.h,
	config/i386/ptx4-i.h, config/mips/gnu.h, config/mips/linux.h,
	config/sparc/linux.h, config/sparc/linux64.h: Delete definitions
	of ASM_FILE_START which merely emit a .version directive.  Delete
	definitions of ASM_FILE_END which merely emit an .ident directive.

	* config/avr/avr.h, config/vax/vax.h: Delete definition of
	ASM_IDENTIFY_GCC and move part of its logic into
	ASM_FILE_START.

	* config/i386/att.h, config/i386/gas.h, config/i386/linux.h,
	config/sparc/linux-aout.h: Don't emit .version directive in
	ASM_FILE_START.

	* config/i386/dgux.c, config/m88k/m88k.c, config/sh/sh.c
	(output_file_start): Correct comment.

	* config/i386/osfrose.h: Don't emit trailing .ident directive.
	* config/m68k/mot3300.h: Override STABS_GCC_MARKER to "gcc2_compiled%"
	to match gdb.
	* config/pa/lib2funcs.asm: Delete gcc_compiled. label.
	* config/rs6000/aix.h: Correct comment.

	* config/i386/i386afe.h: Delete.
	* config.gcc: Remove references to i386afe.h.

	* tm.texi: Delete documentation of ASM_IDENTIFY_GCC.  The
	other macros deleted by this patch were undocumented.

Mon Apr 16 08:03:48 2001  Jeffrey A Law  (law@cygnus.com)

	* pa.md (reload_outdi): Operand 0 must be a non hard register.

	* pa.c (secondary_reload_class): SAR<->FP copies require a
	secondary register.

	* install.texi (mips-mips-bsd): Update list of functions
	required to include memmove.
	* tm.texi (TARGET_MEM_FUNCTIONS): Update list of implicitly
	used functions to include memmove.

2001-04-15  Toon Moene  <toon@moene.indiv.nluug.nl>

	* i386.md (sqrtdf2): SFmode should be DFmode.

2001-04-15  Alexandre Oliva  <aoliva@redhat.com>

	* gcse.c (compute_ld_motion_mems): ASM outputs aren't moveable.
	(find_moveable_store): Likewise.

2001-04-15  Jim Wilson  <wilson@redhat.com>

	* function.c (expand_function_end): Handle PARALLEL real_decl_rtl.

Sat Apr 14 16:24:19 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (ashldi3_1_rex64): Add 'J' to the constraints
	(ashrdi3_1_rex64): Change 'n' constraint to 'J'.

2001-04-14  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.md (cmpsi): Tell reload to disregard the
	first alternative.

2001-04-14  Alan Modra  <amodra@one.net.au>

	* pa.c (force_mode): New function.
	(emit_move_sequence): Use it instead of generating new rtx_REGs.

2001-04-13  Jim Wilson  <wilson@redhat.com>

	* config/ia64/ia64.c (ia64_expand_epilogue): Emit alloc if sibcall_p.
	(first_instruction): New static variable.
	(rtx_needs_barrier): Return 1 for alloc.
	(init_insn_group_barriers): Set first_instruction.
	(rws_sum): Delete duplicate definition.
	(group_barrier_needed_p): Return 0 when first_instruction true.
	(safe_group_barrier_needed_p): Save and restore first_instruction
	around group_barrier_needed_p call.

Fri Apr 13 21:40:28 2001  Loren J. Rittle  <ljrittle@acm.org>

	* expr.h (enum libfunc_index): Add LTI_memmove.
	(memmove_libfunc): Define macro.
	* optabs.c (init_optabs): Initialize memmove_libfunc.
	* expr.c (expand_assignment): Use memmove_libfunc instead of
	memcpy_libfunc.

2001-04-13  Alan Modra  <alan@linuxcare.com.au>

	* pa.h (GO_IF_LEGITIMATE_ADDRESS): Disallow PIC LO_SUM
	fp mode addresses.

2001-04-13  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (reg-stack.o): Depend on reload.h.
	(insn-attrtab.o): Depend on flags.h.

	* genattrtab (main): Include flags.h in insn-attrtab.c.

	* reg-stack.c: Include reload.h.

	* sparc.h (flag_pic): Delete redundant declaration.

	* output.h (flag_pic): Likewise.

	* tree.h (pedantic): Likewise.

2001-04-13  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (toplev.o, jump.o, regmove.o): Depend on reload.h

	* jump.c, regmove.c, toplev.c: Include reload.h.

	* reload.h (reload_cse_regs): Declare.

	* rtl.h (find_equiv_reg, operands_match_p, safe_from_earlyclobber,
	reload_cse_regs, init_reload, mark_home_live, reload,
	init_caller_save): Delete redundant prototypes.

2001-04-13  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (ssa.o, regclass.o): Depend on $(EXPR_H).

	* regclass.c, ssa.c: Include expr.h.

	* rtl.h (memory_address, force_reg, emit_queue, emit_move_insn,
	gen_move_insn): Delete redundant declarations.

2001-04-13  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* Makefile.in (CFLAGS, BOOT_CFLAGS): Partly revert 2000-10-27 patch.
	(stage1_build): Instead pass down STAGE1_CFLAGS here. Pass down
	MAKEINFO and MAKEINFOFLAGS too.
	(stage4_build): Correctly order -B flags.

2001-04-13  Alan Modra  <amodra@one.net.au>

	* pa.c (hppa_init_pic_save): Set rtx_unchanging for
	PIC_OFFSET_TABLE_SAVE_RTX.
	(zdepi_cint_p): Describe zdepi insn.
	Formatting and white space fixes throughout file.

	* pa.c (uint32_operand): Don't use long constant >= 2^32.
	(emit_move_sequence): Use HOST_WIDE_INT constants.  Don't worry
	about 32->64 bit sign extension if 32 bit HOST_WIDE_INTs.
	(compute_movstrsi_length): Make `align' unsigned to avoid warning.
	(output_64bit_and): Use plain `int's for shift counts.
	(output_64bit_ior): Likewise.
	(function_arg_partial_nregs): Use unsigned vars to avoid warnings.
	* pa.h (CONST_OK_FOR_LETTER_P): Use HOST_WIDE_INT constants for case
	`N', and simplify.

	* pa-hpux10.h (NEW_HP_ASSEMBLER): Define to 1.
	* pa-hpux11.h (NEW_HP_ASSEMBLER): Likewise.
	* pa.h (LEGITIMATE_CONSTANT_P) Collapse two defines depending on
	NEW_HP_ASSEMBLER into one.  Kill warnings.

	* pa-gas.h: Delete file.
	* config.gcc: Match `parisc' as well as `hppa' for cpu_type=pa.
	Add new targets hppa*64*-*-linux* and parisc*64*-*-linux*.  Update
	hppa*-*-linux*.  For all pa targets, remove pa/gas.h from tm_file,
	instead setting MASK_GAS | MASK_JUMP_IN_DELAY in target_cpu_default2.

	* config/pa/mill32.S: New file.
	* config/pa/mill64.S: New file.
	* config/pa/t-linux (LIBGCC1, CROSS_LIBGCC1, LIB1ASMFUNCS,
	LIB1ASMSRC, CRTSTUFF_T_CFLAGS_S, TARGET_LIBGCC2_CFLAGS): Define.
	* config/pa/t-linux64: New file.
	* config/pa/t-pa64 (CROSS_LIBGCC1): Change to libgcc1-asm.a
	(LIB1ASMFUNCS, LIB1ASMSRC): Define.
	(TARGET_LIBGCC2_CFLAGS): Add -Dpa64=1 -DELF=1.

	* elfos.h (SELECT_SECTION): Undef before defining.
	* pa-linux.h (LINUX_DEFAULT_ELF, PTRDIFF_TYPE, CPP_SPEC): Remove.
	(LIB_SPEC): Remove -lmilli.
	(DBX_REGISTER_NUMBER): Remove.
	(PREFERRED_DEBUGGING_TYPE, DWARF2_ASM_LINE_DEBUG_INFO,
	(DWARF2_UNWIND_INFO, ASM_SPEC, LINK_SPEC, FUNCTION_OK_FOR_SIBCALL,
	NO_PROFILE_COUNTERS, SELECT_RTX_SECTION, INCOMING_RETURN_ADDR_RTX,
	DWARF_FRAME_RETURN_COLUMN, STRING_ASM_OP, TEXT_SECTION_ASM_OP,
	DATA_SECTION_ASM_OP, BSS_SECTION_ASM_OP, ASM_FILE_START,
	ASM_OUTPUT_DEF, ASM_OUTPUT_ADDR_VEC_ELT, ASM_OUTPUT_ADDR_DIFF_ELT,
	ASM_OUTPUT_LABEL, ASM_GLOBALIZE_LABEL, ASM_DECLARE_FUNCTION_NAME,
	TARGET_GAS): Define.
	* pa.c (output_arg_descriptor): Disable for TARGET_ELF32.
	(function_arg): If TARGET_ELF32, pass fp args in both general and fp
	regs if we don't have a prototype.
	* pa.md (canonicalize_funcptr_for_compare): Not for TARGET_ELF32.
	* pa.h (TARGET_ELF32): Default to 0 if undefined.
	(EH_RETURN_DATA_REGNO, EH_RETURN_STACKADJ_RTX,
	EH_RETURN_HANDLER_RTX): Define.
	* pa32-regs.h (DBX_REGISTER_NUMBER): Remove unnecessary test.
	(DWARF_FRAME_REGNUM): Define.
	* pa64-regs.h (DWARF_FRAME_REGNUM): Define.
	* pa32-linux.h: New file.
	* pa64-linux.h: New file.

	* pa-64.h (WCHAR_TYPE, WCHAR_TYPE_SIZE): Define.
	(ASM_OUTPUT_DOUBLE_INT): Format, protect macro with do..while.
	(LINK_SPEC, LIB_SPEC, MD_EXEC_PREFIX, MD_STARTFILE_PREFIX,
	NEW_HP_ASSEMBLER, ASM_FILE_START, OBJECT_FORMAT_ELF,
	DWARF2_DEBUGGING_INFO, PREFERRED_DEBUGGING_FORMAT,
	DWARF2_ASM_LINE_DEBUG_INFO, USE_CONST_SECTION, CONST_SECTION_ASM_OP,
	CTORS_SECTION_ASM_OP, DTORS_SECTION_ASM_OP, INIT_SECTION_ASM_OP,
	FINI_SECTION_ASM_OP, EXTRA_SECTIONS, EXTRA_SECTION_FUNCTIONS,
	READONLY_DATA_SECTION, CONST_SECTION_FUNCTION, CTORS_SECTION_FUNCTION,
	DTORS_SECTION_FUNCTION, ASM_OUTPUT_SECTION_NAME, MAKE_DECL_ONE_ONLY,
	UNIQUE_SECTION_P, UNIQUE_SECTION, INT_ASM_OP, ASM_OUTPUT_CONSTRUCTOR,
	ASM_OUTPUT_DESTRUCTOR, TYPE_ASM_OP, SIZE_ASM_OP, ASM_WEAKEN_LABEL,
	TYPE_OPERAND_FMT, ASM_DECLARE_RESULT): Move to..
	* pa64-hpux.h: New file.
	(ASM_FILE_START): Correct typo.
	(PREFERRED_DEBUGGING_FORMAT): Rename to PREFERRED_DEBUGGING_TYPE.
	* config.gcc: Modify for above.

Fri Apr 13 00:09:22 EDT 2001  John Wehle  (john@feith.com)

	* jump.c (jump_optimize_1): Don't delete dead stores here.
	* toplev.c (rest_of_compilation): Call delete_trivially_dead_insns
	prior to running jump optimize before cse2.

2001-04-12  Richard Henderson  <rth@redhat.com>

	* Makefile.in (regmove.o): Depend on except.h.
	* regmove.c: Include it.

2001-04-12  Stan Shebs  <shebs@apple.com>

	* objc/objc-act.c: Remove all code ifdefed with the never-used
	macro OBJC_INT_SELECTORS.
	* config/d30v/d30v.h: Remove commented-out ref to OBJC_INT_SELECTORS.
	* tm.texi: Remove doc for OBJC_INT_SELECTORS.

Thu Apr 12 18:13:37 2001  Rodney Brown  <RodneyBrown@mynd.com>

	* config/pa/quadlib.c: Add prototypes.

2001-04-12  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* bitmap.h (debug_bitmap): Delete redundant prototype.

	* rtl.h (get_frame_size): Likewise.

2001-04-12  Jim Wilson  <wilson@redhat.com>

	* config/ia64/ia64.md (extendsfdf2, extendsftf2, extenddftf2): Simplify
	to just emit an fnorm.

2001-04-12  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-common.h (truthvalue_conversion, type_for_mode,
	type_for_size): Delete redundant declarations.

	* c-lex.h (is_class_name): Likewise.

	* c-tree.h (pedantic, convert, getdecls, gettags,
	global_bindings_p, init_decl_processing, insert_block,
	maybe_build_cleanup, poplevel, print_lang_decl,
	print_lang_identifier, print_lang_type, pushdecl, pushlevel,
	set_block, incomplete_type_error, build_function_call,
	lvalue_or_else, mark_addressable): Likewise.

	* expr.h (expand_tree_builtin): Likewise.

2001-04-12  Mark Mitchell  <mark@codesourcery.com>

	* invoke.texi: Document --param max-gcse-memory.

2001-04-12  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* configure.in (errno): Check for declaration.
	* configure, config.in: Regenerated.

	* system.h (errno): Only declare if not already done.

2001-04-12  Alexandre Oliva  <aoliva@redhat.com>

	* recog.c (general_operand, immediate_operand,
	nonmemory_operand): Require CONST_INTs to be sign-extended
	values for their modes.

2001-04-12  Alexandre Oliva  <aoliva@redhat.com>

	* expmed.c (store_bit_field): Truncate CONST_INTs.
	(expand_mult_highpart, expand_divmod): Likewise.
	* expr.c (convert_modes, store_field): Likewise.
	* integrate.c (expand_inline_function): Use promote_mode() to
	determine whether to convert_modes() an argument as signed
	or unsigned.
	* optabs.c (expand_binop): Get CONST_INT operands
	sign-extended for their appropriate modes.
	* stmt.c (emit_case_nodes): Convert node values to the
	appropriate mode.
	(expand_end_case): Convert minval and range to the appropriate
	mode.
	* unroll.c (loop_iterations): Truncate abs_diff to the mode of
	the iteration variable.
	* varasm.c (immed_double_const): Don't require words to be
	narrower than host wide ints to properly sign-extend
	CONST_INTs.

2001-04-12  kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sh.md (builtin_setjmp_receiver): New expander.

2001-04-12  David Edelsohn  <dje@watson.ibm.com>

	* config/rs6000/rs6000.c (rs6000_emit_move): Do not
	special-case HOST_BITS_PER_WIDE_INT != 32.  Use same criteria
	for generating CONST_INT and CONST_DOUBLE.

2001-04-12  Alexandre Oliva  <aoliva@redhat.com>

	* config/rs6000/rs6000.c (logical_operand): CONST_INTs are
	already sign-extended.
	(rs6000_emit_prologue): Make register iterator signed.
	(rs6000_emit_epilogue): Likewise.
	* config/rs6000/rs6000.md (addsi3, adddi3): Sign-extend high
	and low.
	(movsf split, movdf split): Sign-extend CONST_INTs.
	(movdi splits): Likewise.

2001-04-12  Kelley Cook <kelley.cook@home.com>

	* config-lang.in (lang_dirs): Add in zlib.

2001-04-11  Alexandre Oliva  <aoliva@redhat.com>

	* config/i386/i386.md: Apply trunc_int_for_mode() to GEN_INT
	operands that make it to RTL.

2001-04-11  Stan Shebs  <shebs@apple.com>

	Add Darwin (Mac OS X kernel) native support.
	* config.gcc (powerpc-*-darwin*): Add native bits.
	* config/darwin.c: New file, generic Darwin support functions.
	* config/darwin.h: New file, generic Darwin definitions.
	* config/darwin-protos.h: New file, generic Darwin prototypes.
	* rs6000/darwin.h: New file, Darwin for PowerPC.
	* rs6000/t-darwin: New file, Darwin makefile fragment.
	* rs6000/rs6000.h (OBJECT_MACHO): New macro.
	(TARGET_MACHO): Ditto.
	(rs6000_abi): Add ABI_DARWIN.
	(RS6000_REG_SAVE): Add ABI_DARWIN case.
	(RS6000_SAVE_AREA): Ditto.
	(FP_ARG_MAX_REG): Ditto.
	(RETURN_ADDRESS_OFFSET): Ditto.
	* rs6000/rs6000.c (rs6000_legitimize_address): Add TARGET_MACHO
	cases.
	(rs6000_emit_move): Add ABI_DARWIN cases.
	(print_operand): Ditto.
	(first_reg_to_save): Ditto.
	(rs6000_stack_info): Ditto, also align stack by 16 instead of 8.
	(debug_stack_info): Ditto.
	(rs6000_emit_prologue): Ditto.
	(rs6000_emit_epilogue): Ditto.
	(output_profiler_hook): Ditto.
	(output_function_profiler): Ditto.
	(rs6000_add_gc_roots): Call machopic_add_gc_roots if TARGET_MACHO.
	(output_mi_thunk): Add TARGET_MACHO case.
	(add_compiler_stub): Ditto.
	(output_compiler_stub): Ditto.
	(no_previous_def): Ditto.
	(output_call): Ditto.
	(machopic_output_stub): Ditto.
	(rs6000_machopic_legitimize_pic_address): Ditto.
	(toc_section): Ditto.
	* rs6000/rs6000.md (addsi3_high): New TARGET_MACHO pattern.
	(macho_high): Ditto.
	(macho_low): Ditto.
	(movsi_low): Ditto.
	(load_macho_picbase): Ditto.
	(call): Add TARGET_MACHO case to modify function.
	(call_value): Ditto.
	(call_nonlocal_sysv): Add ABI_DARWIN case.
	(call_value_nonlocal_sysv): Ditto.
	* rs6000/rs6000-protos.h (rs6000_machopic_legitimize_pic_address):
	Add prototype.
	(machopic_output_stub): Ditto.
	* ginclude/stddef.h: Test _BSD_WCHAR_T_DEFINED_.

2001-04-11  Mark Mitchell  <mark@codesourcery.com>

	* dwarf2out.c (modified_type_die): Don't create new types here.
	* tree.h (get_qualified_type): New function.
	(build_qualified_type): Adjust comment.
	* tree.c (get_qualified_type): New function.
	(build_qualified_type): Use it.

2001-04-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cpp.texi (-Wtraditional): Update description.

	* invoke.texi (-Wtraditional): Likewise.

2001-04-11  Jim Wilson  <wilson@redhat.com>

	* config/ia64/ia64.h (FUNCTION_ARG_BOUNDARY): Return 128 if argument
	requires more than 64 bits of alignment.

2001-04-11  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpplib.c (do_line): Sanity check iff enable checking.

2001-04-11  Richard Henderson  <rth@redhat.com>

	* Makefile.in (insn-recog.o): Depend on toplev.h.
	(insn-emit.o, doloop.o): Likewise.
	* genrecog.c, genemit.c: Include toplev.h in generated file.
	* doloop.c: Include toplev.h.

2001-04-11  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in (gcse.o): Depend on params.h.
	* gcse.c: Include params.h.
	(gcse_main): Don't do GCSE if doing so will take inordinate
	amounts of memory.
	* params.def (PARAM_MAX_GCSE_MEMORY): New  parameter.
	* params.h (MAX_GCSE_MEMORY): New macro.

2001-04-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (insn-output.o): Depend on $(EXPR_H).

	* genoutput.c (output_prologue): Include expr.h in insn-output.c.

2001-04-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* output.h (assemble_real): Declare if REAL_VALUE_TYPE is defined.

	* real.h (ereal_atof, real_value_truncate, target_isnan,
	target_isinf, target_negative, assemble_real, debug_real): Delete
	redundant prototypes.

	* Makefile.in (ifcvt.o): Depend on toplev.h.

	* c-semantics.c: Include expr.h.

	* ifcvt.c: Include toplev.h.

	* expr.h (rtx_equal_p): Delete prototype.

	* rtl.h (exact_log2_wide, floor_log2_wide, permalloc,
	protect_from_queue, gen_jump, gen_beq, gen_bge, gen_ble,
	eliminate_constant_term, expand_complex_abs, find_single_use,
	make_tree, init_expr_once, init_optabs, supports_one_only):
	Likewise.

	* tree.h (exact_log2_wide, floor_log2_wide, expand_null_return,
	rest_of_type_compilation, emit_queue, do_pending_stack_adjust,
	expand_assignment, store_expr, emit_line_note_after,
	emit_line_note_force, split_specs_attrs, label_rtx): Likewise.

	* toplev.h (exact_log2_wide, floor_log2_wide): Add prototype.

	* sparc-protos.h: Delete redundant prototypes.

2001-04-11  Vladimir Makarov  <vmakarov@toke.toronto.redhat.com>

	* reload.c (push_reload): Add condition missed in SUBREG byte
	offset patch.

Wed Apr  4 00:28:23 2001  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* sparc/sol2-sld-64.h (STARTFILE_SPEC): Added missing blank.

Wed Apr 11 14:06:10 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (floatsisf_sse): Fix output template
	* i386.c (ix86_expand_fp_movcc)

	* reg-stack.c (emit_pop_insn): Handle complex modes.
	(move_for_stack_reg): Emit proper move mode.
	(subst_stack_regs_pat): Handle complex modes.

2001-04-11  Jakub Jelinek  <jakub@redhat.com>

	* cpplex.c (_cpp_lex_token): Only warn if -Wcomment.

2001-04-10  Richard Henderson  <rth@redhat.com>

	* libgcc2.h (__terminate_func_ptr): Remove typedef.
	(__pure_virtual, __terminate, __terminate_set_func,
	__default_terminate, __throw_type_match, __empty,
	__get_eh_context, __get_eh_info, __get_dynamic_handler_chain,
	__eh_rtime_match, __unwinding_cleanup, __rethrow,
	__sjthrow, __sjpopnthrow, __eh_alloc, __eh_free):
	Remove prototypes of deleted functions.

2001-04-10  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-typeck.c (convert_arguments): -Wtraditional now activates
	-Wconversion warnings, except for changes in signed-ness.
	Detect complex<->int & int<->complex conversions as well.

	* invoke.texi (-Wtraditional): Document it.

Tue Apr 10 17:45:50 2001  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* gcse.c (update_ld_motion_stores): Don't use variable I for an insn.
	* flow.c (set_block_for_new_insns): Remove needless cast and
	properly check for unset block number.

2001-04-10  Andrew MacLeod  <amacleod@redhat.com>

	* function.c (purge_single_hard_subreg_set): Only check REGNO if
	the subreg was a hard register. Pseudos are left as subregs.

2001-04-09  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* Makefile.in (LIB2FUNCS_STATIC_EXTRA): New macro.
	(LIB2ADD_ST): New macro, pass it to mklibgcc.
	* mklibgcc.in (libgcc2_st_objs): New variable, set it from LIB2ADD_ST.
	(libgcc_st_objs): New, set from libgcc2_st_objs. Use it for libgcc.a.
	* config/rs6000/t-ppccomm (LIB2FUNCS_STATIC_EXTRA): New macro.

2001-04-09  Bo Thorsen  <bo@suse.co.uk>

	* config/i386/i386.md: "TARGET_64BIT && TARGET_64BIT": Removed one.

2001-04-09  Andrew MacLeod  <amacleod@redhat.com>

	* output.h (set_block_num): Missed it earlier, remove deprecated
	prototype.

2001-04-09  Andrew MacLeod  <amacleod@redhat.com>

	* gcse.c (oprs_unchanged_p): Pass basic_block to load_killed_in_block_p.
	(load_killed_in_block_p): Change bb parameter from int to basic_block.
	(oprs_not_set_p): Pass basic_blocks instead of ints as parameters.
	(handle_rd_kill_set): Change bb parameter from int to basic_block.
	(compute_kill_rd): Pass basic_blocks instead of ints as parameters.
	(expr_killed_p): Change bb parameter from int to basic_block, pass
	basic_blocks instead of ints as parameters.
	(compute_ae_kill): Pass basic_blocks instead of ints as parameters.
	(expr_reaches_here_p_work, expr_reaches_here_p): Change bb parameter
	from int to basic_block, pass basic_blocks instead of ints as parms.
	(pre_expr_reaches_here_p_work, pre_expr_reaches_here_p): Change bb
	parameter from int to basic_block, pass basic_blocks instead of ints.
	(process_insert_insn): Pass basic_blocks instead of ints as parameters.
	(insert_insn_end_bb): Change bb parameter from int to basic_block,
	pass basic_blocks instead of ints.
	(pre_edge_insert, pre_insert_copy_insn, pre_insert_copies): Pass
	basic_blocks instead of ints as parameters.
	(pre_delete): Pass basic_blocks instead of ints as parameters.
	(hoist_expr_reaches_here_p): Change bb parameter from int to
	basic_block, pass basic_blocks instead of ints.
	(hoist_code): Pass basic_blocks instead of ints as parameters.
	(reg_set_info, store_ops_ok, store_killed_after, store_killed_before):
	Change bb parameter from int to basic_block.
	(build_store_vectors): Pass basic_blocks instead of ints as parameters.
	(insert_insn_start_bb): Change bb parameter from int to basic_block,
	pass basic_blocks instead of ints.
	(insert_store): Pass basic_blocks instead of ints as parameters.
	(replace_store_insn, delete_store): Change bb parameter from int to
	basic_block, pass basic_blocks instead of ints.
	(store_motion): Pass basic_blocks instead of ints as parameters.

2001-04-09  Andrew MacLeod  <amacleod@redhat.com>

	* basic-block.h (set_new_block_for_insns): New Prototype.
	(set_block_num): Delete prototype.
	* flow.c (set_block_num): Remove obsolete function.
	(set_block_for_new_insns): Set BB for single or multiple insns.
	* gcse.c (handle_avail_expr): Use set_block_for_new_insns.
	(process_insn_end_bb): Use set_block_for_new_insns or
	set_block_for_insn instead of set_block_num.
	(pre_insert_copy_insn): Use set_block_for_new_insns.
	(update_ld_motion_stores): Use set_block_for_new_insns.
	(insert_insn_start_bb): Use set_block_for_new_insns.
	(replace_store_insn): Use set_block_for_new_insns.

2001-04-09  Andrew MacLeod  <amacleod@redhat.com>
	    Jeff Law  <law@redhat.com>

	* alias.c (get_addr): Externalize.
	(canon_true_dependence): New function. Behaves like true_dependance
	except it already assumes a MEM has been canonicalized.
	* flags.h (flag_gcse_lm, flag_gcse_sm): New optimization flags.
	* gcse.c (struct ls_expr): Add load/store expressions structure.
	(modify_mem_list, canon_modify_mem_list): New variable.
	(gcse_main): Initialize & finalize alias analysis. Use enhanced
	load motion and store motion if requested.
	(alloc_gcse_mem): Allocate space for modify_mem_list array.
	(free_gcse_mem): Free the modify_mem_list array.
	(oprs_unchanged_p): Use load_killed_in_block_p.
	(gcse_mems_conflict_p, gcse_mem_operand): New variables.
	(mems_conflict_for_gcse_p): New function.  Don't kill loads
	with stores to themselves if its in the load/store expression list.
	(load_killed_in_block_p): New function.
	(canon_list_insert): New Function.
	(record_last_mem_set_info): Keep a list of all instructions which
	can modify memory for each basic block.
	(compute_hash_table, reset_opr_set_tables): Clear modify_mem_list.
	(oprs_not_set_p): Use load_killed_in_block_p.
	(mark_call, mark_set, mark_clobber): Use record_last_mem_set_info.
	(expr_killed_p): Use load_killed_in_block_p.
	(compute_transp): Do not pessimize memory references.
	(pre_edge_insert): Update stores for a load motion expression.
	(one_pre_gcse_pass): Check loads/stores for extra load motion.
	(ldst_entry): Find or create a ldst_expr structure.
	(free_ldst_entry): Free memory for an individual item.
	(free_ldst_mems): Free entire load/store expression list.
	(print_ldst_list): Print debug info.
	(find_rtx_in_ldst): Try to find an rtx expression in the ldst list.
	(enumerate_ldsts): Assign integer values to each entry in list.
	(first_ls_expr): First expression in the list.
	(next_ls_expr): Next expression in the list.
	(simple_mem): Check if expression qualifies for ld/st expression list.
	(invalidate_any_buried_refs): Remove from expression list if its
	used in some other way we don't understand.
	(compute_ld_motion_mems): Find all potential enhanced load motion
	expression.
	(trim_ld_motion_mems): Remove any expressions which are invalid.
	(update_ld_motion_stores): Copy store values to registers for loads
	which have been moved.
	(regvec, st_antloc, num_store): New global statics.
	(reg_set_info): Marks registers as set.
	(store_ops_ok): Verfies registers expressions are valid in a block.
	(find_moveable_store): Look for moveable stores in a pattern.
	(compute_store_table): Find stores in a function worth moving, maybe.
	(load_kills_store): Check dependence of a load and store.
	(find_loads): Find any loads in a pattern.
	(store_killed_in_insn): Check if a store is killed in an insn.
	(store_killed_after): Check is store killed after an insn in a block.
	(store_killed_before): Check is store killed before an insn in a block.
	(build_store_vectors): Generate the antic and avail vectors.
	(insert_insn_start_bb): Insert at the start of a BB, update BLOCK_HEAD.
	(insert_store): Add a store to an edge.
	(replace_store_insn): Replace a store with a SET insn.
	(delete_store): Delete a store insn.
	(free_store_memory): Free memory.
	(store_motion): Perform store motion.
	* invoke.texi: Add documentation for -fcse-lm and -fgcse-sm.
	* rtl.h (get_addr, canon_true_dependence): Add prototypes.
	* toplev.c (flag_gcse_lm, flag_gcse_sm): New Variables.
	(f_options): Add gcse-lm and gcse-sm.

Mon Apr  9 16:18:03 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (expand_fp_movcc): Fix condition reversal code.

	* i386.c (ix86_register_move_cost): Fix handling of reformating penalty
	* i386.h (INTEGER_CLASS_P, MAYBE_INTEGER_CLASS_P): New.
	(CLASS_MAX_NREGS): Use it.

	* i386.h (HARD_REGNO_NREGS): Handle properly TF and TCmodes on 64bit;
	handle properly complex values.
	(CLASS_MAX_NREGS): Likewise; update comment.

2001-04-05  Bernd Schmidt  <bernds@redhat.com>

	* ia64.c (ia64_flag_schedule_insns2): New variable.
	(ia64_override_options): Initialize it.  Clear
	flag_schedule_insns_after_reload.
	(ia64_reorg): Only do scheduling if ia64_flag_schedule_insns2.

Mon Apr  9 15:09:13 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (truncdfsf2_*): Add i387->int/sse reg alternatives;
	Do not require source to match destination anymore;
	Add abort to the nontrivial cases that should be handled by split.
	(fix_trunc?fdi): Add SSE case for x86_64.
	(floatdi?f): Likewise.
	(floatdi?f_sse): New.
	(fix_trunc?fdi_sse): New.

2001-04-09  Richard Sandiford   <rsandifo@redhat.com>

	* dwarfout.c (DEBUG_ARANGES_BEGIN_LABEL): New label.
	(DEBUG_ARANGES_END_LABEL): Ditto.
	(dwarfout_init): Generate length and version fields at the start
	of the .debug_aranges info.  Insert DEBUG_ARANGES_BEGIN_LABEL
	after the length field.
	(dwarfout_finish): Insert DEBUG_ARANGED_END_LABEL at the end of
	the .debug_aranges info.

Sun Apr  8 00:43:27 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (call, call_value): Make sure that resulting call_insn
	does have proper second operand.

Sun Apr  8 22:50:49 2001  Christopher Faylor <cgf@cygnus.com>

	* config/i386/xm-cygwin.h (GET_ENV_PATH_LIST): Eliminate obsolete
	function.  Remove include of sys/cygwin.h.

Sun Apr  8 22:20:27 2001  Christopher Faylor <cgf@cygnus.com>

	* config/i386/cygwin.h (STARTFILE_SPEC): search */lib/w32api by default.
	(CPP_SPEC): Always search */include/w32api for header files.
	(ASM_OUTPUT_SECTION_NAME): Avoid testing NULL DECL.
	(LINK_SPEC): Add "cyg" to the library search prefixes.

2001-04-08  Philip Blundell  <philb@gnu.org>

	* config/arm/arm.h (ASM_OUTPUT_LABELREF): Use asm_fprintf.

2001-04-08  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpperror.c (print_location): Don't special case <stdin>.
	(_cpp_begin_message): Handle WARNING_SYSHDR the same as
	WARNING, but we don't check if we're in system headers.
	* cpplib.h (enum error_type): WARNING_SYSHDR: New.
	* cpplib.c (do_warning): Warn in system headers.

2001-04-07  Mumit Khan <khan@NanoTech.Wisc.EDU>

	* mbchar.c: Include config.h first.

2001-04-07  Zack Weinberg  <zackw@stanford.edu>

	* config.gcc: Set default for xmake_file at top, not bottom.
	Change places that set xmake_file to "none" to set to the
	empty string instead, or remove them entirely if there is no
	default xmake_file for this cpu_type.  Remove references to
	deleted files.

	* config/x-lynx, config/convex/x-convex, config/elxsi/x-elxsi,
	config/i386/x-isc, config/i386/x-isc3, config/i386/x-ncr3000,
	config/i386/x-next, config/i386/x-sco, config/i386/x-sysv3,
	config/i386/x-vsta, config/i860/x-sysv4, config/m68k/x-amix,
	config/m68k/x-apollo68, config/m68k/x-ccur, config/m68k/x-crds,
	config/m68k/x-hp2bsd, config/m68k/x-mot3300, config/m68k/x-mot3300-gas,
	config/m68k/x-tower, config/m88k/x-sysv4, config/mips/x-dec-osf1,
	config/mips/x-sni-svr4, config/mips/x-ultrix, config/romp/x-mach,
	config/romp/x-romp, config/rs6000/x-beos, config/rs6000/x-lynx,
	config/rs6000/x-mach, config/rs6000/x-sysv4, config/sparc/x-sysv4:
	Delete.

	* config/a29k/x-unix, config/i386/x-aix, config/i386/x-osf1elf,
	config/i386/x-osfrose, config/m68k/x-dpx2, config/mips/x-iris3,
	config/mips/x-mips, config/mips/x-osfrose, config/mips/x-sony,
	config/mips/x-sysv, config/rs6000/x-aix31:
	Just set CLIB to -lld or -lmld, as appropriate.

	* config/arm/x-riscix, config/i370/x-oe, config/i386/x-dgux,
	config/i386/x-sco4, config/i386/x-sco5, config/m68k/x-hp320,
	config/m68k/x-hp320g, config/m68k/x-next, config/m88k/x-dgux,
	config/mips/x-iris, config/pa/x-pa:
	Just set (some of) FIXPROTO_DEFINES, STMP_FIXPROTO,
	OTHER_FIXINCLUDES_DIRS.

	* config/i386/x-djgpp: Don't set LN or LN_S.
	* config/m88k/x-dolph: Don't define __m88k__.
	* config/m88k/x-tekXD88: Don't set AR_FLAGS.
	* config/pa/x-pa-mpeix: Just set up quadlib.asm.
	* config/i860/fx2800.h: No need to #undef SVR4.

	38 x-host fragments remain, 2 x-cpu.

2001-04-07  Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* c4x.h (HARD_REGNO_NREGS): HCmode mode uses 2 regs not 4.

2001-04-06  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cpplib.c (cpp_push_buffer): Give stdin buffers the name <stdin>.

2001-04-06  Neil Booth  <neil@daikokuya.demon.co.uk>

	* configure.in: Add check for lstat.
	* configure, config.in: Regenerate.
	* cppinit.c (append_include_chain): Make empty path ".".
	* cpplib.c (do_line): Don't simplify #line paths.
	* cppfiles.c (remove_component_p): New function.
	(find_or_create_entry): Acknowledge stat () errors during
	path simplification.
	(handle_missing_header): Don't simplify paths.
	(_cpp_simplify_pathname): Don't simplify VMS paths.  Return
	the empty path untouched.  Don't leave a trailing '/'.

2001-04-06  Benjamin Kosnik  <bkoz@redhat.com>

	* cppdefault.c (GPLUSPLUS_BACKWARD_INCLUDE_DIR): Add.
	* Makefile.in (-DGPLUSPLUS_BACKWARD_INCLUDE_DIR): Add.

2001-04-06  Neil Booth  <neil@daikokuya.demon.co.uk>

	* cppfiles.c (open_file): Fail directories silently, but
	with an errno of NOENT set.
	(read_include_file): Move the common exit code to the sole
	caller.  Return an int indicating success or failure.  Let
	open_file handle directories.
	(stack_include_file): If read_include_file fails,
	push a "null" buffer.

2001-04-05  DJ Delorie  <dj@redhat.com>

	* function.h (virtuals_instantiated): Declare.
	* function.c: (virtuals_instantiated): Make global.
	* calls.c (emit_library_call_value_1): Use
	virtual_outgoing_args_rtx only if it hasn't been instantiated.
	Otherwise, use the stack pointer directly.

Thu Apr  5 19:13:33 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_initialize_trampoline): New global function.
	* i386.h (TRAMPOLINE_SIZE): Size is 23 for x86_64.
	(INITIALIZE_TRAMPOLINE): Move offline.
	* i386-protos.h (x86_initialize_trampoline): Declare.

Thu Apr  5 19:02:15 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.md (movdi_1_rex64): Allow SSE->SSE reg move.
	(lea_0): Rename to lea_1.
	(lea_1_zext, lea_1_rex64, lea_2_rex64): New patterns.
	(lea_general_?): Allow SImodes on TARGET_64BIT
	(lea_general_?_zext): New patterns.
	(call_1, call_1_rex64): Fix.

Thu Apr  5 19:00:15 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_split_long_move): Use PUT_MODE instead of change_address.

Thu Apr  5 18:25:56 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (function_arg): Return constm1_rtx for last argument.
	(ix86_expand_prologue): Update gen_call calls.
	* i386.h (FUNCTION_BLOCK_PROFILER_EXIT): Likewise.
	* i386.md (call_pop): Likewise.
	(call): Second operand is VOIDmode.
	(call_0): Likewise; Support 64bits.
	(call_exp): New expander.
	(call_1): Get to the sync.
	(call_1_exp): New pattern.
	(call_value): Support 64bit.
	(call_value_exp): New pattern.
	(untyped_call): Update gen_call call.
	(call_value_pop): Disable for 64bit.
	(call_value_0_rex64): New pattern.
	(call_value_1_rex64): Likewise.

2001-04-05  Bo Thorsen  <bo@suse.de>

	* i386.md: Don't allow "builtin_setjmp_receiver" for TARGET_64BIT.

Thu Apr  5 13:44:17 2001  J"orn Rennecke <amylaar@redhat.com>

	* i386.md (*andsi_1+3): If used after reload, make sure the operand
	satisfies ANY_QI_REG_P.

2001-04-05  Bernd Schmidt  <bernds@redhat.com>

	* config/ia64/ia64.c (rtx_needs_barrier): A PARALLEL can contain
	ASM_OPERAND.

	* sched-deps.c (sched_analyze_insn): Revert more of the March 27
	change.

2001-04-04  Zack Weinberg  <zackw@stanford.edu>

	* config.gcc: Remove default for xm_file.  Clean up local
	machine type handling.  Remove settings of xm_file to
	something that doesn't exist.  In the big switch, set xm_file,
	don't append to it (the value before the big switch is always
	null).  Don't force build_xm_file or host_xm_file to have a value.
	* configure.in: Remove default for xm_file.  Do not special
	case $cpu/xm-$cpu.h not existing.
	* configure: Regenerate.

2001-04-04  Diego Novillo  <dnovillo@redhat.com>

	* simplify-rtx.c (simplify_binary_operation): Check for overflow
	when folding integer division and modulo operations.

2001-04-04  Andrew MacLeod  <amacleod@redhat.com>

	* dwarf2out.c (output_cfi): Add 'for_eh' parameter, use PTR_SIZE
	instead of DWARF2_ADDR_SIZE for EH addresses.
	(output_call_frame_info): Use PTR_SIZE instead of DWARF2_ADDR_SIZE for
	EH addresses.

2001-04-04  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.h (IA64_UNWIND_INFO): Disable.
	* config/ia64/t-glibc (LIB2ADDEH): Disable.
	* config/ia64/t-ia64 (LIB2ADDEH): Disable.

2001-04-04  Richard Henderson  <rth@redhat.com>

	* configure.in (gcc_cv_as_leb128): Escape "." in regexp.
	* configure: Rebuilt.

2001-04-04  Jakub Jelinek  <jakub@redhat.com>

	* gcse.c (delete_null_pointer_checks_1): Add delete_list argument,
	push insns to delete to it instead of deleting them.
	(delete_null_pointer_checks): Delete insns from delete_list after
	all delete_null_pointer_checks_1 passes are done.

2001-04-04  Richard Henderson  <rth@redhat.com>

	* configure.in (gcc_cv_as_leb128): Tweek minor number extraction.
	* configure: Rebuilt.

2001-04-04  Zack Weinberg  <zackw@stanford.edu>

	* expr.h: Remove #ifdef FUNCTION_CONVERSION_BUG logic.
	* config/romp/xm-romp.h: Delete.

2001-04-04  Bernd Schmidt  <bernds@redhat.com>

	* sched-deps.c (sched_analyze_insn): Partially revert March 27
	change.

2001-04-04 Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* emit-rtl.c (mark_label_nuses) Increment the label uses for
	all labels present in rtx.
	(try_split) Call new function for all split insns.

2001-04-04  Jakub Jelinek  <jakub@redhat.com>

	* recog.c (validate_replace_rtx_1): Instead of aborting just make
	sure the change won't be validated.

Wed Apr  4 00:45:38 EDT 2001  John Wehle  (john@feith.com)

	* rtl.h (set_noop_p): Declare.
	* flow.c (set_noop_p): Move from here ...
	* rtlanal.c (set_noop_p): ... to here and enhance.
	* cse.c (delete_trivially_dead_insns): Use it.
	* gcse.c (hash_scan_set): Likewise.
	* jump.c (delete_noop_moves): Likewise.
	* recog.c (split_all_insns): Likewise.

2001-04-04  Alan Modra  <alan@linuxcare.com.au>

	* dwarf2out.c (dwarf2out_frame_debug_expr): Support adjusting
	stack pointer via a LO_SUM.  Ditto for setting a temp register
	used to save to the stack.  Set cfa_temp when setting fp, and
	allow matches to cfa_temp in addition to cfa_store when saving
	regs.  Handle POST_INC and LO_SUM register stores.  Document the
	changes and errors in rule 12 doco.

	* pa.c (set_reg_plus_d, store_reg, load_reg): Return last insn.
	(actual_fsize, local_fsize, save_fregs): Move for store_reg to see.
	(load_reg): Move closer to epilogue code.
	(DO_FRAME_NOTES): Define to control the following..
	(FRP): Define to set RTX_FRAME_RELATED_P on insns.
	(hppa_expand_prologue): Use FRP and REG_FRAME_RELATED_EXPR
	notes as necessary.
	(hppa_expand_epilogue): Likewise.

2001-04-03  Richard Henderson  <rth@redhat.com>

	* configure.in (gcc_cv_as_leb128): Reject gas before 2.11.
	* configure: Rebuild.

2001-04-03  Richard Henderson  <rth@redhat.com>

	* rtl.h (LCT_THROW): New.
	* calls.c (emit_library_call_value_1): Handle it.
	* except.c (connect_post_landing_pads): Use it.

2001-04-03  Zack Weinberg  <zackw@stanford.edu>

	* gansidecl.h: Delete file.
	* configure.in: Change all refs to gansidecl.h to use
	ansidecl.h.  Adjust *_file_list so they know where ansidecl.h
	lives.
	* configure: Regenerate.

	* Makefile.in (intl.o): Don't depend on gansidecl.h.
	* defaults.h: s/gansidecl.h/ansidecl.h/ in comment.
	* ggc.h, config/fr30/fr30.h, config/mcore/mcore.c:
	Don't include gansidecl.h.
	* intl.c, main.c, version.c, fixinc/fixlib.h,
	fixinc/procopen.c, fixinc/server.c: Include ansidecl.h not
	gansidecl.h.

Tue Apr  3 19:41:21 CEST 2001  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_force_to_memory, ix86_free_from_memory):
	Update for 64bit.

2001-04-03  Zack Weinberg  <zackw@stanford.edu>

	* config/i386/xm-beos.h, config/i386/xm-isc.h,
	config/i386/xm-next.h, config/i386/xm-sco.h,
	config/i386/xm-sco5.h, config/m68k/xm-plexus.h,
	config/m88k/xm-m88k.h: Delete.

	* config/i386/xm-djgpp.h: Don't define __MSDOS__.
	* config/romp/xm-romp.h: Don't define bcopy.
	* config/rs6000/xm-beos.h: Don't define bcopy, HAVE_VPRINTF,
	HAVE_PUTENV, HAVE_RENAME, or USE_C_ALLOCA.

	* config.gcc: Remove references to deleted files.

	14 xm-host.h remain, 1 xm-cpu.h.

2001-04-03  Jakub Jelinek  <jakub@redhat.com>
	    David S. Miller  <davem@pierdol.cobaltmicro.com>
	    Andrew MacLeod  <amacleod@redhat.com>

	Use byte offsets in SUBREGs instead of words.

	* alias.c (nonlocal_mentioned_p): Use subreg_regno function.
	* caller-save.c (mark_set_regs): Change callers of subreg_hard_regno
	to pass new argument.
	(add_stored_regs): Use subreg_regno_offset function.
	* calls.c (expand_call): For non-paradoxical SUBREG take endianess
	into account.
	(precompute_arguments): Use gen_lowpart_SUBREG.
	* combine.c (try_combine): Replace explicit XEXP with SUBREG_REG.
	(combine_simplify_rtx): Rework to use SUBREG_BYTE.
	(simplify_set): Rework to use SUBREG_BYTE.
	(expand_field_assignment): Use SUBREG_BYTE.
	(make_extraction): Use SUBREG_BYTE.
	(if_then_else_cond): Use SUBREG_BYTE.
	(apply_distributive_law): Use SUBREG_BYTE and fixup subreg comments.
	(gen_lowpart_for_combine): Compute full byte offset.
	* cse.c (mention_regs): Use SUBREG_BYTE.
	(remove_invalid_subreg_refs): Rework to use SUBREG_BYTE.
	(canon_hash): Use SUBREG_BYTE.
	(fold_rtx): Pass SUBREG_BYTE div UNITS_PER_WORD to operand_subword.
	(gen_lowpart_if_possible): Formatting.
	* dbxout.c (dbxout_symbol_location): Compute SUBREG hard regnos
	correctly.
	* dwarf2out.c (is_pseudo_reg): Fixup explicit XEXP into SUBREG_REG
	(mem_loc_descriptor): Fixup explicit XEXP into SUBREG_REG
	(loc_descriptor): Fixup explicit XEXP into SUBREG_REG
	* dwarfout.c (is_pseudo_reg): Fixup explicit XEXP into SUBREG_REG
	(output_mem_loc_descriptor): Fixup explicit XEXP into SUBREG_REG
	(output_loc_descriptor): Fixup explicit XEXP into SUBREG_REG
	* emit-rtl.c (gen_rtx_SUBREG): New function, used to verify
	certain invariants about SUBREGs the compiler creates.
	(gen_lowpart_SUBREG): New function.
	(subreg_hard_regno): New function to get the final register number.
	(gen_lowpart_common): Use SUBREG_BYTE.
	(gen_imagpart): Spacing nits.
	(subreg_realpart_p): Use SUBREG_BYTE.
	(gen_highpart): Use SUBREG_BYTE.
	(subreg_lowpart_p): Always compute endian corrected goal offset,
	even at the byte level, then compare against that.
	(constant_subword): New function, pulled out all constant cases
	from operand_subword and changed second argument name to offset.
	(operand_subword): Detect non REG/SUBREG/CONCAT/MEM cases early
	and call constant_subword to do the work.  Return const0_rtx if
	looking for a word outside of OP.
	(operand_subword_force): Change second arg name to offset.
	* expmed.c (store_bit_field): Use SUBREG_BYTE.
	(store_split_bit_field): Use SUBREG_BYTE.
	(extract_bit_field): Use SUBREG_BYTE.
	(extract_split_bit_field): Use SUBREG_BYTE.
	(expand_shift): Use SUBREG_BYTE.
	* expr.c (store_expr, expand_expr): Use gen_lowpart_SUBREG.
	* final.c (alter_subreg) Use subreg_hard_regno and SUBREG_BYTE.
	* flow.c (set_noop_p): Use SUBREG_BYTE.
	(mark_set_1): Remove ALTER_HARD_SUBREG. Use subreg_regno_offset instead.
	* function.c (fixup_var_refs_1): Fixup explicit XEXP into a SUBREG_REG.
	(fixup_memory_subreg): Use SUBREG_BYTE and remove byte endian
	correction code.
	(optimize_bit_field): Use SUBREG_BYTE.
	(purge_addressof_1): Use SUBREG_BYTE.
	(purge_single_hard_subreg_set): Use subreg_regno_offset function.
	(assign_params): Mark arguments SUBREG_PROMOTED_VAR_P if they are
	actually promoted by the caller and PROMOTE_FOR_CALLS_ONLY is true.
	* gengenrtl.c (special_rtx): Add SUBREG.
	* global.c (mark_reg_store): Use SUBREG_BYTE.
	(set_preference): Rework to use subreg_regno_offset and SUBREG_BYTE.
	* ifcvt (noce_emit_move_insn): Use SUBREG_BYTE.
	* integrate.c (copy_rtx_and_substitute): Use SUBREG_BYTE and make sure
	final byte offset is congruent to subreg's mode size.
	(subst_constants): Use SUBREG_BYTE.
	(mark_stores): Use subreg_regno_offset function.
	* jump.c (rtx_renumbered_equal_p, true_regnum): Use subreg_regno_offset
	function and SUBREG_BYTE.
	* local-alloc.c (combine_regs): Use subreg_regno_offset function.
	(reg_is_born): Use subreg_hard_regno.
	* recog.c (valid_replace_rtx_1): Use SUBREG_BYTE and remove byte
	endian correction code.  Don't combine subregs unless resulting
	offset aligns with type.  Fix subreg constant extraction for DImode.
	Simplify SUBREG of VOIDmode CONST_DOUBLE.
	(general_operand): Remove dead mode_altering_drug code.
	(indirect_operand): Use SUBREG_BYTE.
	(constrain_operands): Use subreg_regno_offset function.
	* reg-stack.c (get_true_reg): Use subreg_regno_offset function.
	* regmove.c (regmove_optimize): Use SUBREG_BYTE.
	(optimize_reg_copy_3): Use gen_lowpart_SUBREG.
	* regs.h (REG_SIZE): Allow target to override.
	(REGMODE_NATURAL_SIZE): New macro which target can override.
	* reload.c (reload_inner_reg_of_subreg): subreg_regno should be used
	on the entire subreg rtx.
	(push_reload): Use SUBREG_BYTE in comments and code.
	(find_dummy_reload): Use subreg_regno_offset.  Only adjust offsets
	for hard registers inside subregs.
	(operands_match_p): Use subreg_regno_offset.
	(find_reloads): Use SUBREG_BYTE and only advance offset for subregs
	containing hard regs.
	(find_reload_toplev): Use SUBREG_BYTE.  Remove byte endian
	corrections when fixing up MEM subregs.
	(find_reloads_address_1): Use SUBREG_BYTE, subreg_regno, and
	subreg_regno_offset where appropriate.
	(find_reloads_subreg_address): Use SUBREG_BYTE.  Remove
	byte endian corrections when fixing up MEM subregs.
	(subst_reloads): When combining two subregs, make sure final
	offset is congruent to subreg's mode size.
	(find_replacement): Use SUBREG_BYTE and subreg_regno_offset.
	(refers_to_regno_for_reload_p): Use subreg_regno.
	(reg_overlap_mentioned_for_reload_p): Use subreg_regno_offset.
	* reload1.c (eliminate_regs) Use SUBREG_BYTE. Remove byte endian
	correction code for memory subreg fixups.
	(forget_old_reload_1): Use subreg_regno_offset.
	(choose_reload_regs): Use subreg_regno.
	(emit_input_reload_insns): Use SUBREG_BYTE.
	(reload_combine_note_store): Use subreg_regno_offset.
	(move2add_note_store): Use subreg_regno_offset.
	* resource.c (update_live_status, mark_referenced_resources): Use
	subreg_regno function.
	(mark_set_resources): Use subreg_regno function.
	* rtl.h (SUBREG_WORD): Rename to SUBREG_BYTE.
	(subreg_regno_offset, subreg_regno): Define prototypes.
	(subreg_hard_regno, constant_subword, gen_rtx_SUBREG): Newi functions.
	(gen_lowpart_SUBREG): Add prototype.
	* rtl.texi (subreg): Update to reflect new byte offset representation.
	Add mentioning of the effect that BYTES_BIG_ENDIAN has on subregs now.
	* rtlanal.c (refers_to_regno_p): Use subreg_regno.
	(reg_overlap_mentioned_p): Use subreg_regno.
	(replace_regs); Make sure final offset of combined subreg is
	congruent to size of subreg's mode.
	(subreg_regno_offset): New function.
	(subreg_regno): New function.
	* sched-vis.c (print_value): Change SUBREG_WORD to SUBREG_BYTE.
	* sdbout.c (sdbout_symbol): Compute offset using alter_subreg.
	* stmt.c (expand_anon_union_decl): Use gen_lowpart_SUBREG.
	* tm.texi (ALTER_HARD_SUBREG): Remove, it is now dead.
	(SUBREG_REGNO_OFFSET): Describe SUBREG_REGNO_OFFSET overrides.
	* config/a29k/a29k.c (gpc_reg_operand): Use subreg_regno.
	(a29k_get_reloaded_address): Use SUBREG_BYTE.
	(print_operand): Use SUBREG_BYTE.
	* config/alpha/alpha.c (print_operand_address): Use SUBREG_BYTE.
	* config/arm/arm.c (arm_reload_in_hi): Use SUBREG_BYTE.
	(arm_reload_out_hi): Use SUBREG_BYTE.
	* config/d30v/d30v.c (d30v_split_double): Use subreg_regno_offset
	instead of SUBREG_WORD.
	(d30v_print_operand_memory_reference): Use subreg_regno_offset.
	* config/dsp16xx/dsp16xx.md (extendqihi2, zero_extendqihi2): Fix
	SUBREG creation to use byte offset.
	* config/h8300/h8300.md (Unnamed HImode zero extraction and 16bit
